var express = require('express'),
    app = express(),

    bodyParser   = require('body-parser'),


    createError = require('http-errors'),

    path = require('path'),
    cookieParser = require('cookie-parser'),
    logger = require('morgan')
;

app.use(bodyParser.json({limit: '50mb', extended: true}));
app.use(bodyParser.urlencoded({limit: '50mb', extended: true }));
app.use(cookieParser());

var indexRouter                 = require('./routes/index'),

    hangerLiveRouter            = require('./routes/adatgyujto_vallfa_live'),
    hangerReplayRouter          = require('./routes/adatgyujto_vallfa_replay'),
    stabbingMachineLiveRouter   = require('./routes/adatgyujto_szurkalogep_live'),
    stabbingMachineReplayRouter = require('./routes/adatgyujto_szurkalogep_replay'),
    carLiveRouter               = require('./routes/adatgyujto_szeker_live'),
    carReplayRouter             = require('./routes/adatgyujto_szeker_replay'),
    helmetLiveRouter            = require('./routes/adatgyujto_sisak_live'),
    helmetReplayRouter          = require('./routes/adatgyujto_sisak_replay'),

    loginRouter                 = require('./routes/login'),

    dataRouter                  = require('./routes/data'),
    generatorRouter             = require('./routes/generator'),


    generalCommunicationRouter  = require('./routes/generalCommunication')
;


// view engine setup
app.set('views', path.join(__dirname, 'views'));
app.set('view engine', 'ejs');

app.use(logger('dev'));
app.use(express.json());
app.use(express.urlencoded({ extended: false }));
app.use(cookieParser());

app.use(express.static(path.join(__dirname, 'public')));
app.use('/public', express.static(__dirname + '/public'));


let mode = process.env.MODE;
if(mode == "NORMAL") {  app.use('/',    hangerLiveRouter);}
else {                  app.use('/',    helmetLiveRouter);}


app.use('/vallfa',                      hangerLiveRouter);
app.use('/vallfa-elo',                  hangerLiveRouter);
app.use('/vallfa-visszajatszas',        hangerReplayRouter);

app.use('/szurkalogep',                 stabbingMachineLiveRouter);
app.use('/szurkalogep-elo',             stabbingMachineLiveRouter);
app.use('/szurkalogep-visszajatszas',   stabbingMachineReplayRouter);

app.use('/sisak',                       helmetLiveRouter);
app.use('/sisak-elo',                   helmetLiveRouter);
app.use('/sisak-visszajatszas',         helmetReplayRouter);

app.use('/szeker',                      carLiveRouter);
app.use('/szeker-elo',                  carLiveRouter);
app.use('/szeker-visszajatszas',        carReplayRouter);

app.use('/bejelentkezes',               loginRouter);

app.use('/data',                        dataRouter);
app.use('/generator',                   generatorRouter);

app.use('/generalCommunication',        generalCommunicationRouter);

// catch 404 and forward to error handler
app.use(function(req, res, next) {
  next(createError(404));
});

// error handler
app.use(function(err, req, res, next) {
  // set locals, only providing error in development
  res.locals.message = err.message;
  res.locals.error = req.app.get('env') === 'development' ? err : {};

  // render the error page
  res.status(err.status || 500);
  res.render('error');
});

module.exports = app;
