var     db              = require('./SQLConnection'),
        eventLogger     = require('./eventLogger'),
        logger          = require('./logger'),
        moment          = require('moment'),
        nd              = require('nd4js')

;

const { v4: uuidv4 } = require('uuid');


moment.locale('hu');

function simplifyModificationsString(referenceIds) {
    let original = JSON.stringify(referenceIds);
    let replaced = original
        .replace("[","")
        .replace("]","")
        .replace(/"/g, '')
        .replace(/{/g, '')
        .replace(/}/g, '')
        .replace(/:/g, ': ')
        .replace(/,/g, ', ')
    ;
    return replaced
}

//region Student
function compareStudent(student, nameCurrentTitle, nameCurrentFamily, nameCurrentGiven, nameOriginalTitle, nameOriginalFamily, nameOriginalGiven, nameMothersTitle, nameMothersFamily, nameMothersGiven, birthplace, birthday, nationality, contactMail, contactPhone, addressPermanentCountry, addressPermanentPostalcode, addressPermanentCity, addressPermanentPlaceName, addressPermanentPlaceType, addressPermanentPlaceNumber, addressPermanentPlaceBuilding, addressPermanentPlaceStaircase, addressPermanentPlaceFloor, addressPermanentPlaceDoor, addressContactCountry, addressContactPostalcode, addressContactCity, addressContactPlaceName, addressContactPlaceType, addressContactPlaceNumber, addressContactPlaceBuilding, addressContactPlaceStaircase, addressContactPlaceFloor, addressContactPlaceDoor, socialSecurityNumber, identityCardNumber, taxIdentificationNumber, bankAccountNumber,bankAccountHolder, previousOKJ, foreignIdentifierType, foreignIdentifierName, foreignReason, highSchoolGraduation, drivingLicenceNumber, addressCardNumber, additionalInformation) {
    let modifications = [];

    if(student.nameCurrentTitle !== nameCurrentTitle) modifications.push({"Név előtag": student.nameCurrentTitle +" -> " + nameCurrentTitle});
    if(student.nameCurrentFamily !== nameCurrentFamily) modifications.push({"Vezetéknév": student.nameCurrentFamily +" -> " + nameCurrentFamily});
    if(student.nameCurrentGiven !== nameCurrentGiven) modifications.push({"Keresztnév": student.nameCurrentGiven +" -> " + nameCurrentGiven});

    if(student.nameOriginalTitle !== nameOriginalTitle) modifications.push({"Születési név előtag": student.nameOriginalTitle +" -> " + nameOriginalTitle});
    if(student.nameOriginalFamily !== nameOriginalFamily) modifications.push({"Születési vezetéknév": student.nameOriginalFamily +" -> " + nameOriginalFamily});
    if(student.nameOriginalGiven !== nameOriginalGiven) modifications.push({"Születési keresztnév": student.nameOriginalGiven +" -> " + nameOriginalGiven});

    if(student.nameMothersTitle !== nameMothersTitle) modifications.push({"Anyja neve előtag": student.nameMothersTitle +" -> " + nameMothersTitle});
    if(student.nameMothersFamily !== nameMothersFamily) modifications.push({"Anyja vezetékneve": student.nameMothersFamily +" -> " + nameMothersFamily});
    if(student.nameMothersGiven !== nameMothersGiven) modifications.push({"Anyja keresztneve": student.nameMothersGiven +" -> " + nameMothersGiven});

    if(student.birthplace !== birthplace) modifications.push({"Születési hely": student.birthplace +" -> " + birthplace});
    if(student.birthday !== birthday) {
        let birthday_old = moment(student.birthday).format("YYYY.MM.DD."),
            birthday_new = moment(parseInt(birthday)).format("YYYY.MM.DD.");
        modifications.push({"Születésnap": birthday_old +" -> " + birthday_new});
    }

    if(student.nationality !== nationality) modifications.push({"Állampolgárság": student.nationality +" -> " + nationality});
    if(student.contactMail !== contactMail) modifications.push({"Email cím": student.contactMail +" -> " + contactMail});
    if(student.contactPhone !== contactPhone) modifications.push({"Telefonszám": student.contactPhone +" -> " + contactPhone});

    if(student.addressPermanentCountry !== addressPermanentCountry) modifications.push({"Állandó lakcím - Ország": student.addressPermanentCountry +" -> " + addressPermanentCountry});
    if(student.addressPermanentPostalcode !== addressPermanentPostalcode) modifications.push({"Állandó lakcím - Irányítószám": student.addressPermanentPostalcode +" -> " + addressPermanentPostalcode});
    if(student.addressPermanentCity !== addressPermanentCity) modifications.push({"Állandó lakcím - Város": student.addressPermanentCity +" -> " + addressPermanentCity});
    if(student.addressPermanentPlaceName !== addressPermanentPlaceName) modifications.push({"Állandó lakcím - Közterület": student.addressPermanentPlaceName +" -> " + addressPermanentPlaceName});
    if(student.addressPermanentPlaceType !== addressPermanentPlaceType) modifications.push({"Állandó lakcím - Közterület jelleg": student.addressPermanentPlaceType +" -> " + addressPermanentPlaceType});
    if(student.addressPermanentPlaceNumber !== addressPermanentPlaceNumber) modifications.push({"Állandó lakcím - Házszám": student.addressPermanentPlaceNumber +" -> " + addressPermanentPlaceNumber});
    if(student.addressPermanentPlaceBuilding !== addressPermanentPlaceBuilding) modifications.push({"Állandó lakcím - Épület": student.addressPermanentPlaceBuilding +" -> " + addressPermanentPlaceBuilding});
    if(student.addressPermanentPlaceStaircase !== addressPermanentPlaceStaircase) modifications.push({"Állandó lakcím - Lépcsőház": student.addressPermanentPlaceStaircase +" -> " + addressPermanentPlaceStaircase});
    if(student.addressPermanentPlaceFloor !== addressPermanentPlaceFloor) modifications.push({"Állandó lakcím - Emelet": student.addressPermanentPlaceFloor +" -> " + addressPermanentPlaceFloor});
    if(student.addressPermanentPlaceDoor !== addressPermanentPlaceDoor) modifications.push({"Állandó lakcím - Ajtó": student.addressPermanentPlaceDoor +" -> " + addressPermanentPlaceDoor});

    if(student.addressContactCountry !== addressContactCountry) modifications.push({"Értesítési cím - Ország": student.addressContactCountry +" -> " + addressContactCountry});
    if(student.addressContactPostalcode !== addressContactPostalcode) modifications.push({"Értesítési cím - Irányítószám": student.addressContactPostalcode +" -> " + addressContactPostalcode});
    if(student.addressContactCity !== addressContactCity) modifications.push({"Értesítési cím - Város": student.addressContactCity +" -> " + addressContactCity});
    if(student.addressContactPlaceName !== addressContactPlaceName) modifications.push({"Értesítési cím - Közterület": student.addressContactPlaceName +" -> " + addressContactPlaceName});
    if(student.addressContactPlaceType !== addressContactPlaceType) modifications.push({"Értesítési cím - Közterület jelleg": student.addressContactPlaceType +" -> " + addressContactPlaceType});
    if(student.addressContactPlaceNumber !== addressContactPlaceNumber) modifications.push({"Értesítési cím - Házszám": student.addressContactPlaceNumber +" -> " + addressContactPlaceNumber});
    if(student.addressContactPlaceBuilding !== addressContactPlaceBuilding) modifications.push({"Értesítési cím - Épület": student.addressContactPlaceBuilding +" -> " + addressContactPlaceBuilding});
    if(student.addressContactPlaceStaircase !== addressContactPlaceStaircase) modifications.push({"Értesítési cím - Lépcsőház": student.addressContactPlaceStaircase +" -> " + addressContactPlaceStaircase});
    if(student.addressContactPlaceFloor !== addressContactPlaceFloor) modifications.push({"Értesítési cím - Emelet": student.addressContactPlaceFloor +" -> " + addressContactPlaceFloor});
    if(student.addressContactPlaceDoor !== addressContactPlaceDoor) modifications.push({"Értesítési cím - Ajtó": student.addressContactPlaceDoor +" -> " + addressContactPlaceDoor});

    if(student.socialSecurityNumber !== socialSecurityNumber) modifications.push({"TAJ szám": student.socialSecurityNumber +" -> " + socialSecurityNumber});
    if(student.identityCardNumber !== identityCardNumber) modifications.push({"Személyigazolványszám": student.identityCardNumber +" -> " + identityCardNumber});
    if(student.taxIdentificationNumber !== taxIdentificationNumber) modifications.push({"Adószám": student.taxIdentificationNumber +" -> " + taxIdentificationNumber});

    if(student.bankAccountNumber !== bankAccountNumber) modifications.push({"Bankszámlaszám": student.bankAccountNumber +" -> " + bankAccountNumber});
    if(student.bankAccountHolder !== bankAccountHolder) modifications.push({"Bankszámla tulajdonosa": student.bankAccountHolder +" -> " + bankAccountHolder});

    if(student.previousOKJ !== previousOKJ) modifications.push({"Előző OKJ-s végzettségek": student.previousOKJ +" -> " + previousOKJ});

    if(student.foreignIdentifierType !== foreignIdentifierType) modifications.push({"Külföldi igazolvány típusa": student.foreignIdentifierType +" -> " + foreignIdentifierType});
    if(student.foreignIdentifierName !== foreignIdentifierName) modifications.push({"Külföldi igazolvány száma": student.foreignIdentifierName +" -> " + foreignIdentifierName});
    if(student.foreignReason !== foreignReason) modifications.push({"Itt tartózkodás oka": student.foreignReason +" -> " + foreignReason});

    if(student.highSchoolGraduation !== highSchoolGraduation) modifications.push({"Érettségi": student.highSchoolGraduation +" -> " + highSchoolGraduation});
    if(student.drivingLicenceNumber !== drivingLicenceNumber) modifications.push({"Jogosítvány száma": student.drivingLicenceNumber +" -> " + drivingLicenceNumber});
    if(student.addressCardNumber !== addressCardNumber) modifications.push({"Lakcímkártya száma": student.addressCardNumber +" -> " + addressCardNumber});

    return simplifyModificationsString(modifications);
}
module.exports.insertOrModifyStudent = function(studentId, nameCurrentTitle, nameCurrentFamily, nameCurrentGiven, nameOriginalTitle, nameOriginalFamily, nameOriginalGiven, nameMothersTitle, nameMothersFamily, nameMothersGiven, birthplace, birthday, nationality, contactMail, contactPhone, addressPermanentCountry, addressPermanentPostalcode, addressPermanentCity, addressPermanentPlaceName, addressPermanentPlaceType, addressPermanentPlaceNumber, addressPermanentPlaceBuilding, addressPermanentPlaceStaircase, addressPermanentPlaceFloor, addressPermanentPlaceDoor, addressContactCountry, addressContactPostalcode, addressContactCity, addressContactPlaceName, addressContactPlaceType, addressContactPlaceNumber, addressContactPlaceBuilding, addressContactPlaceStaircase, addressContactPlaceFloor, addressContactPlaceDoor, socialSecurityNumber, identityCardNumber, taxIdentificationNumber, bankAccountNumber, bankAccountHolder, previousOKJ, foreignIdentifierType, foreignIdentifierName, foreignReason, highSchoolGraduation, drivingLicenceNumber, addressCardNumber, additionalInformation ) {
    let result = {
        eventType: eventLogger.eventType.Student,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };


    if(studentId === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedStudentId = uuidv4(); //generate ID
            let crossCheck = db.getStudent(generatedStudentId); //check generated ID

            if(crossCheck.studentId !== generatedStudentId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertStudent(generatedStudentId, nameCurrentTitle, nameCurrentFamily, nameCurrentGiven, nameOriginalTitle, nameOriginalFamily, nameOriginalGiven, nameMothersTitle, nameMothersFamily, nameMothersGiven, birthplace, birthday, nationality, contactMail, contactPhone, addressPermanentCountry, addressPermanentPostalcode, addressPermanentCity, addressPermanentPlaceName, addressPermanentPlaceType, addressPermanentPlaceNumber, addressPermanentPlaceBuilding, addressPermanentPlaceStaircase, addressPermanentPlaceFloor, addressPermanentPlaceDoor, addressContactCountry, addressContactPostalcode, addressContactCity, addressContactPlaceName, addressContactPlaceType, addressContactPlaceNumber, addressContactPlaceBuilding, addressContactPlaceStaircase, addressContactPlaceFloor, addressContactPlaceDoor, socialSecurityNumber, identityCardNumber, taxIdentificationNumber, bankAccountNumber, bankAccountHolder, previousOKJ, foreignIdentifierType, foreignIdentifierName, foreignReason, highSchoolGraduation, drivingLicenceNumber, addressCardNumber, additionalInformation);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "A tanuló sikeresen létrehozva (név: " + nameCurrentFamily +" "+nameCurrentGiven+", id: "+generatedStudentId+")";
                result.newId = generatedStudentId;

            } else { logger.warn("we have a user with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        //check student ID
        let crossCheckModify = db.getStudent(studentId);

        if(crossCheckModify.studentId === studentId) {
            db.updateStudent(studentId, nameCurrentTitle, nameCurrentFamily, nameCurrentGiven, nameOriginalTitle, nameOriginalFamily, nameOriginalGiven, nameMothersTitle, nameMothersFamily, nameMothersGiven, birthplace, birthday, nationality, contactMail, contactPhone, addressPermanentCountry, addressPermanentPostalcode, addressPermanentCity, addressPermanentPlaceName, addressPermanentPlaceType, addressPermanentPlaceNumber, addressPermanentPlaceBuilding, addressPermanentPlaceStaircase, addressPermanentPlaceFloor, addressPermanentPlaceDoor, addressContactCountry, addressContactPostalcode, addressContactCity, addressContactPlaceName, addressContactPlaceType, addressContactPlaceNumber, addressContactPlaceBuilding, addressContactPlaceStaircase, addressContactPlaceFloor, addressContactPlaceDoor, socialSecurityNumber, identityCardNumber, taxIdentificationNumber, bankAccountNumber, bankAccountHolder, previousOKJ, foreignIdentifierType, foreignIdentifierName, foreignReason, highSchoolGraduation, drivingLicenceNumber, addressCardNumber, additionalInformation);

            result.eventResult = eventLogger.eventResult.Success;
            result.message = "A tanuló sikeresen módosítva! Módosítások: " + compareStudent(crossCheckModify, nameCurrentTitle, nameCurrentFamily, nameCurrentGiven, nameOriginalTitle, nameOriginalFamily, nameOriginalGiven, nameMothersTitle, nameMothersFamily, nameMothersGiven, birthplace, birthday, nationality, contactMail, contactPhone, addressPermanentCountry, addressPermanentPostalcode, addressPermanentCity, addressPermanentPlaceName, addressPermanentPlaceType, addressPermanentPlaceNumber, addressPermanentPlaceBuilding, addressPermanentPlaceStaircase, addressPermanentPlaceFloor, addressPermanentPlaceDoor, addressContactCountry, addressContactPostalcode, addressContactCity, addressContactPlaceName, addressContactPlaceType, addressContactPlaceNumber, addressContactPlaceBuilding, addressContactPlaceStaircase, addressContactPlaceFloor, addressContactPlaceDoor, socialSecurityNumber, identityCardNumber, taxIdentificationNumber, bankAccountNumber, bankAccountHolder, previousOKJ, foreignIdentifierType, foreignIdentifierName, foreignReason, highSchoolGraduation, drivingLicenceNumber, addressCardNumber, additionalInformation);
        } else {
            logger.debug("student not found with the following id: "+ studentId);

            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "A tanuló nem található (id: "+studentId+")";
        }
    }

    return result;
};
module.exports.deleteStudent = function(studentId) {
    let result = {
        eventType: eventLogger.eventType.Student,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let student = db.getStudent(studentId);

    if (student.studentId === studentId) {
        db.deleteStudent(studentId);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "A tanuló sikeresen törlve (név: "+ student.nameCurrentFamily +" "+ student.nameCurrentGiven +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "A tanuló törlése sikertelen, nem található (id: " + studentId +")";
    }

    return result;
};
module.exports.createUserForAStudent = function(studentId ) {
    let result = {
        eventType: eventLogger.eventType.User,
        operation: eventLogger.operation.Create,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };
    let student = db.getStudent(studentId);
    if(student.studentId === studentId) {
        if(student.contactMail !== "") {
            let existingUser = db.getUser(student.contactMail);

            if(existingUser.username !== student.contactMail) {
                db.insertUser(student.contactMail, moment(student.birthday).format("YYYYMMDD"), "TANULO", student.nameCurrentFamily +" "+student.nameCurrentGiven, student.contactMail, studentId);

                result.eventResult = eventLogger.eventResult.Success;
                result.message = "A felhasználói fiók létre lett hozva a tanulónak";
                result.studentName = student.nameCurrentFamily +" "+student.nameCurrentGiven;
                result.studentId = student.studentId
            } else {
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "A tanulónak már van felhasználói fiókja";
                result.studentName = student.nameCurrentFamily +" "+student.nameCurrentGiven;
                result.studentId = student.studentId
            }
        } else if(student.contactPhone !== "") {
            let existingUser = db.getUser(student.contactPhone);

            if(existingUser.username !== student.contactPhone) {
                db.insertUser(student.contactPhone, moment(student.birthday).format("YYYYMMDD"), "TANULO", student.nameCurrentFamily +" "+student.nameCurrentGiven, student.contactPhone, studentId);

                result.eventResult = eventLogger.eventResult.Success;
                result.message = "A felhasználói fiók létre lett hozva a tanulónak";
                result.studentName = student.nameCurrentFamily +" "+student.nameCurrentGiven;
                result.studentId = student.studentId
            } else {
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "A tanulónak már van felhasználói fiókja";
                result.studentName = student.nameCurrentFamily +" "+student.nameCurrentGiven;
                result.studentId = student.studentId
            }
        } else {
            logger.debug("student found, but doesn't have an email address neither phone number: "+ studentId);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "A tanuló email címe nem található";
            result.studentName = student.nameCurrentFamily +" "+student.nameCurrentGiven;
            result.studentId = student.studentId
        }
    } else {
        logger.debug("student not found with the following id: "+ studentId);
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "A tanuló nem található (id: "+studentId+")";
    }
    return result;
};
//endregion

//region DecaWave
let AnchorsX = nd.array([0.00,   0.00,   3.35,   3.48]),
    AnchorsY = nd.array([1.73,   0.00,   1.75,   0.00]),
    AnchorsZ = nd.array([1.38,   1.33,   1.40,   1.35]);

let AR = nd.array([10.0, 1.0, 1.0, 1.0]);   //Intialize the arrays as floats with arbirtray values
let PR = nd.array([2.0, 2.0, 2.0, 2.0]);

module.exports.cumputeDecaWaveTagPosition = function(decaWaveRawData) {

    let pos = nd.array([1.00, 1.00, 1.00]);     //Postion of the tag to back calculate the ranges for testing purposes

    AR = nd.array([10.0, 1.0, 1.0, 1.0]);
    PR = [decaWaveRawData.range0, decaWaveRawData.range1, decaWaveRawData.range2, decaWaveRawData.range3];

    //Implment iterative least squared estimation
    for(let i = 0; i <10; i++){

        try {

            let temp = Math.sqrt(((pos[0] - AnchorsX) ** 2) + ((pos[1] - AnchorsY) ** 2) + ((pos[2] - AnchorsZ) ** 2));
            AR = [temp,temp,temp,temp];

            let XH = (pos[0] - AnchorsX) / AR;
            let YH = (pos[1] - AnchorsY) / AR;
            let ZH = (pos[2] - AnchorsZ) / AR;

            let H = [[XH[0], YH[0], ZH[0]], [XH[1], YH[1], ZH[1]], [XH[1], YH[2], ZH[2]], [XH[3], YH[3], ZH[3]]];

            //let deltaPR = nd.subtract(AR, PR);
            let deltaPR = AR - PR;
            let posChang = nd.la.lstsq(H, deltaPR)[0];

            //pos = nd.subtract(pos, posChang);
            pos = pos - posChang;

        } catch (e) {

        }

    }

    return pos;
};

//endregion DecaWave

//region -= Enumerations =-

//region Status
function compareStatus(check, name, description, relevance) {
    let modifications = [];
    if(check.name !== name) modifications.push({"Név": check.name +" -> " + name});
    if(check.relevance !== relevance) modifications.push({"Relevancia": check.relevance +" -> " + relevance});
    if(check.description !== description) modifications.push({"Részletek": check.description +" -> " + description});
    return simplifyModificationsString(modifications);
}

module.exports.insertOrModifyStatus = function(id, name, description, relevance) {
    let result = {
        eventType: eventLogger.eventType.Status,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    if(id === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedId = uuidv4();
            let crossCheck = db.getStatus(generatedId); //check generated ID

            if(crossCheck.id !== generatedId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertStatus(generatedId, name, description, relevance);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "A státusz sikeresen létrehozva (név: " + name +", részletek: "+details+")";
            } else { logger.warn("we have a status with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        let crossCheck = db.getStatus(id);

        if(crossCheck.id === id) {
            db.updateStatus(id, name, description, relevance);
            result.eventResult = eventLogger.eventResult.Success;
            result.message = "A státusz sikeresen módosítva! Módosítások: " + compareStatus(crossCheck, name, description, relevance);
        } else {
            logger.debug("status not found with the following id: "+ id);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "A státusz nem található (id: "+id+")";
        }
    }

    return result;
};

module.exports.deleteStatus = function(id) {
    let result = {
        eventType: eventLogger.eventType.Status,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let check = db.getStatus(id);

    if(check.id === id) {
        db.deleteStatus(id);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "Sikeres törlés (id: " + check.id +", name: "+ check.name +", leírás: "+ check.description +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "A státusz nem található (id: " + id +")";
    }

    return result;
};
//endregion Status

//region Result
function compareResult(check, name, description) {
    let modifications = [];
    if(check.name !== name) modifications.push({name: check.name +" -> " + name});
    if(check.description !== description) modifications.push({description: check.description +" -> " + description});
    return simplifyModificationsString(modifications);
}

module.exports.insertOrModifyResult = function(id, name, description) {
    let result = {
        eventType: eventLogger.eventType.Result,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    if(id === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedId = uuidv4();
            let crossCheck = db.getResult(generatedId); //check generated ID

            if(crossCheck.id !== generatedId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertResult(generatedId, name, description);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "Az elem sikeresen létrehozva (név: " + name +", részletek: "+details+")";
            } else { logger.warn("we have a result with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        let crossCheck = db.getResult(id);

        if(crossCheck.id === id) {
            db.updateResult(id, name, description);
            result.eventResult = eventLogger.eventResult.Success;
            result.message = "Az elem sikeresen módosítva! Módosítások: " + compareResult(crossCheck, name, description);
        } else {
            logger.debug("result not found with the following id: "+ id);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "Az elem nem található (id: " + id +")";
        }
    }

    return result;
};

module.exports.deleteResult = function(id) {
    let result = {
        eventType: eventLogger.eventType.Result,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let check = db.getResult(id);

    if(check.id === id) {
        db.deleteResult(id);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "Sikeres törlés (id: " + check.id +", name: "+ check.name +", leírás: "+ check.description +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "Az elem nem található (id: " + id +")";
    }

    return result;
};
//endregion Result

//region Role
function compareRole(check, name, description) {
    let modifications = [];
    if(check.name !== name) modifications.push({name: check.name +" -> " + name});
    if(check.description !== description) modifications.push({description: check.description +" -> " + description});
    return simplifyModificationsString(modifications);
}

module.exports.insertOrModifyRole = function(id, name, description) {
    let result = {
        eventType: eventLogger.eventType.Role,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    if(id === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedId = uuidv4();
            let crossCheck = db.getRole(generatedId); //check generated ID

            if(crossCheck.id !== generatedId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertRole(generatedId, name, description);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "Az elem sikeresen létrehozva (név: " + name +", részletek: "+details+")";
            } else { logger.warn("we have a role with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        let crossCheck = db.getRole(id);

        if(crossCheck.id === id) {
            db.updateRole(id, name, description);
            result.eventResult = eventLogger.eventResult.Success;
            result.message = "Az elem sikeresen módosítva! Módosítások: " + compareRole(crossCheck, name, description);
        } else {
            logger.debug("role not found with the following id: "+ id);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "Az elem nem található (id: " + id +")";
        }
    }

    return result;
};

module.exports.deleteRole = function(id) {
    let result = {
        eventType: eventLogger.eventType.Role,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let check = db.getRole(id);

    if(check.id === id) {
        db.deleteRole(id);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "Sikeres törlés (id: " + check.id +", name: "+ check.name +", leírás: "+ check.description +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "Az elem nem található (id: " + id +")";
    }

    return result;
};
//endregion Role

//region UserRole
function compareUserRole(check, name, description) {
    let modifications = [];
    if(check.name !== name) modifications.push({name: check.name +" -> " + name});
    if(check.description !== description) modifications.push({description: check.description +" -> " + description});
    return simplifyModificationsString(modifications);
}

module.exports.insertOrModifyUserRole = function(id, name, description) {
    let result = {
        eventType: eventLogger.eventType.UserRole,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    if(id === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedId = uuidv4();
            let crossCheck = db.getUserRole(generatedId); //check generated ID

            if(crossCheck.id !== generatedId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertUserRole(generatedId, name, description);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "Az elem sikeresen létrehozva (név: " + name +", részletek: "+details+")";
            } else { logger.warn("we have a role with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        let crossCheck = db.getUserRole(id);

        if(crossCheck.id === id) {
            db.updateRole(id, name, description);
            result.eventResult = eventLogger.eventResult.Success;
            result.message = "Az elem sikeresen módosítva! Módosítások: " + compareUserRole(crossCheck, name, description);
        } else {
            logger.debug("role not found with the following id: "+ id);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "Az elem nem található (id: " + id +")";
        }
    }

    return result;
};

module.exports.deleteUserRole = function(id) {
    let result = {
        eventType: eventLogger.eventType.UserRole,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let check = db.getUserRole(id);

    if(check.id === id) {
        db.deleteUserRole(id);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "Sikeres törlés (id: " + check.id +", name: "+ check.name +", leírás: "+ check.description +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "Az elem nem található (id: " + id +")";
    }

    return result;
};
//endregion Role

//region EventOperation
function compareEventOperation(check, name, description) {
    let modifications = [];
    if(check.name !== name) modifications.push({name: check.name +" -> " + name});
    if(check.description !== description) modifications.push({description: check.description +" -> " + description});
    return simplifyModificationsString(modifications);
}

module.exports.insertOrModifyEventOperation = function(id, name, description) {
    let result = {
        eventType: eventLogger.eventType.EventOperation,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    if(id === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedId = uuidv4();
            let crossCheck = db.getEventOperation(generatedId); //check generated ID

            if(crossCheck.id !== generatedId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertEventOperation(generatedId, name, description);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "Az elem sikeresen létrehozva (név: " + name +", részletek: "+details+")";
            } else { logger.warn("we have a eventOperation with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        let crossCheck = db.getEventOperation(id);

        if(crossCheck.id === id) {
            db.updateEventOperation(id, name, description);
            result.eventResult = eventLogger.eventResult.Success;
            result.message = "Az elem sikeresen módosítva! Módosítások: " + compareEventOperation(crossCheck, name, description);
        } else {
            logger.debug("eventOperation not found with the following id: "+ id);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "Az elem nem található (id: " + id +")";
        }
    }

    return result;
};

module.exports.deleteEventOperation = function(id) {
    let result = {
        eventType: eventLogger.eventType.EventOperation,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let check = db.getEventOperation(id);

    if(check.id === id) {
        db.deleteEventOperation(id);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "Sikeres törlés (id: " + check.id +", name: "+ check.name +", leírás: "+ check.description +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "Az elem nem található (id: " + id +")";
    }

    return result;
};
//endregion EventOperation

//region EventResult
function compareEventResult(check, name, description) {
    let modifications = [];
    if(check.name !== name) modifications.push({name: check.name +" -> " + name});
    if(check.description !== description) modifications.push({description: check.description +" -> " + description});
    return simplifyModificationsString(modifications);
}

module.exports.insertOrModifyEventResult = function(id, name, description) {
    let result = {
        eventType: eventLogger.eventType.EventResult,
        operation: eventLogger.operation.Undefined,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    if(id === "0") {
        result.operation = eventLogger.operation.Create;

        while (result.eventResult !== eventLogger.eventResult.Success) {
            let generatedId = uuidv4();
            let crossCheck = db.getEventResult(generatedId); //check generated ID

            if(crossCheck.id !== generatedId) { //insert if the generated id is not used for another student. Generate new otherwise
                db.insertEventResult(generatedId, name, description);
                result.eventResult = eventLogger.eventResult.Success;
                result.message = "Az elem sikeresen létrehozva (név: " + name +", részletek: "+details+")";
            } else { logger.warn("we have a EventResult with this generated id"); }
        }

    } else {
        result.operation = eventLogger.operation.Modify;

        let crossCheck = db.getEventResult(id);

        if(crossCheck.id === id) {
            db.updateEventResult(id, name, description);
            result.eventResult = eventLogger.eventResult.Success;
            result.message = "Az elem sikeresen módosítva! Módosítások: " + compareEventResult(crossCheck, name, description);
        } else {
            logger.debug("eventOperation not found with the following id: "+ id);
            result.eventResult = eventLogger.eventResult.Fail;
            result.message = "Az elem nem található (id: " + id +")";
        }
    }

    return result;
};

module.exports.deleteEventResult = function(id) {
    let result = {
        eventType: eventLogger.eventType.EventResult,
        operation: eventLogger.operation.Delete,
        eventResult: eventLogger.eventResult.Undefined,
        message: "UNDEFINED"
    };

    let check = db.getEventResult(id);

    if(check.id === id) {
        db.deleteEventResult(id);
        result.eventResult = eventLogger.eventResult.Success;
        result.message = "Sikeres törlés (id: " + check.id +", name: "+ check.name +", leírás: "+ check.description +")";
    } else {
        result.eventResult = eventLogger.eventResult.Fail;
        result.message = "Az elem nem található (id: " + id +")";
    }

    return result;
};
//endregion EventResult

//endregion -= Enumerations =-