var fs = require('fs'),
    logger = require('./logger'),
    moment = require('moment'),
    { v4: uuidv4 } = require('uuid'),

    eventLogger = require('../lib/eventLogger'),

    documentGenerator = require('../lib/documentGenerator'),

    dataManager = require('../lib/dataManager'),
    db = require('./SQLConnection')
;
moment.locale('hu');

module.exports.sendFileInRes = function (path, fileName, res) {
    try {
        let stat = fs.statSync(path);
        res.writeHead(200, {'Content-Length': stat.size, "Content-Disposition": "attachment; filename=" + fileName});
        let readStream = fs.createReadStream(path);
        readStream.pipe(res);
    } catch (err) {
        logger.error('Error: ' + err.message + "\n\n" + err.stack);

        logger.error('Path: ' + path + ", fileName: " + fileName);
        //res.writeHead(500);
    }

};

module.exports.vallfaByDeviceIdBetweenTimestamps = async function (from, to, deviceId) {
    let generationResult = await documentGenerator.vallfaByDeviceIdBetweenTimestamps(from, to, deviceId);
    return generationResult;
};
module.exports.vallfaByDeviceId = async function (deviceId) {
    let generationResult = await documentGenerator.vallfaByDeviceId(deviceId);
    return generationResult;
};

module.exports.szekerByDeviceIdBetweenTimestamps = async function (from, to, deviceId) {
    let generationResult = await documentGenerator.szekerByDeviceIdBetweenTimestamps(from, to, deviceId);
    return generationResult;
};
module.exports.szekerByDeviceId = async function (deviceId) {
    let generationResult = await documentGenerator.szekerByDeviceId(deviceId);
    return generationResult;
};

module.exports.szurkalogepByDeviceIdBetweenTimestamps = async function (from, to, deviceId) {
    let generationResult = await documentGenerator.szurkalogepByDeviceIdBetweenTimestamps(from, to, deviceId);
    return generationResult;
};
module.exports.szurkalogepByDeviceId = async function (deviceId) {
    let generationResult = await documentGenerator.szurkalogepByDeviceId(deviceId);
    return generationResult;
};

module.exports.sisakByDeviceIdBetweenTimestamps = async function (from, to, deviceId) {
    let generationResult = await documentGenerator.sisakByDeviceIdBetweenTimestamps(from, to, deviceId);
    return generationResult;
};
module.exports.sisakByDeviceId = async function (deviceId) {
    let generationResult = await documentGenerator.sisakByDeviceId(deviceId);
    return generationResult;
};
