const   db = require('../lib/SQLConnection'),
        Enum = require('enum');


module.exports.insertEvent= function (userId, referenceId, eventType, operation, eventResult, message) {
    db.insertEvent(userId, referenceId, eventType, operation, eventResult, message);
};

module.exports.insertEventWithResult= function (userId, referenceId, result) {
    db.insertEvent(userId, referenceId, result.eventType, result.operation, result.eventResult, result.message);
};

module.exports.eventType = new Enum({
    'Undefined':            0,

    'Login':                1,
    'Logout':               2,

    'Student':              3,
    'Comment':              4,
    'Payment':              5,

    'Partner':              6,
    'Proposal':             7,
    'Document':             8,
    'ToDo':                 9,


    'PriceItemOfModule':    14,
    'PriceItemForStudent':  15,

    'Course':               16,
    'Module':               17,
    'ModuleTopic':          19,

    'StudentAndModule':     18,
    'StudentAndAppointment':20,

    'Member':               21,
    'MemberAndModule':      22,

    'Location':             11,

    //Enumerations
    'Status':               10,

    'PaymentMode':          12,
    'PaymentMethod':        13,

    'Role':                 23,
    'Result':               24,
    'ModuleTopicType':      25,
    'ModuleTopicFormat':    26,

    'ModuleType':           27,

    'PriceItemType':        28,
    'EducationMode':        29,

    'PriceDefault':         30,
    'ModuleTopicDefault':   31,

    'EventOperation':       32,
    'EventResult':          33,

    'DocumentCategory':     34,

    'UserRole':             35,
    'ImportedData':         36,
    'Exemption':            37,

    'ModuleAndModuleTopic': 38,
    'Appointment':          39,
    'AppointmentDefault':   40,
    'WhereFrom':            41,

    'Backup':               42,

    'DefaultTodo':          43,
    'Notification':         44,

    'DeadlineReferenceType':45,
    'TodoType'             :46,
    'RepeatType'           :47,


    'Picture'                       :48,
    'Question'                      :49,
    'QuestionSet'                   :50,
    'QuestionSetAndModule'          :51,
    'DefaultQuestionSetAndModule'   :52,
    'StudentAnswersForQuestionSetAndModule'      :55,

    'DocumentAndModule'             :53,
    'DefaultDocumentAndModule'      :54,
    'StudentAndDocumentOfModule'      :55,

    'EmailTemplate'      :56,
    'Email'      :57,
    'Tag'      :58,

    'Video'      :59,
    'VideoAndModule'      :60,
    'StudentAndVideoOfModule'      :61,
    'DefaultVideoAndModule'      :62,



});

module.exports.operation = new Enum({
    'Undefined': 0,
    'Login': 1,
    'Logout': 2,

    'Create': 3,
    'Modify': 4,
    'Delete': 5,
    'Import': 6,
    'Restore': 7,
});

module.exports.eventResult = new Enum({
    'Undefined': 0,
    'Success': 1,
    'Fail': 2
});


