'use strict';

let dataSet_TableUpdateTimes = [],

    timeStampThreshold = 1000,

    measurements_device1 = [],
    measurements_device2 = [],
    measurements_device3 = [],
    measurements_device4 = [],

    dataSet_rfid = [],
    dataSet_ph_Value = [],
    dataSet_temperature_Thermocouple = [],

    dataSet_spect_A = [],
    dataSet_spect_B = [],
    dataSet_spect_C = [],
    dataSet_spect_D = [],
    dataSet_spect_E = [],
    dataSet_spect_F = [],
    dataSet_spect_G = [],
    dataSet_spect_H = [],
    dataSet_spect_I = [],
    dataSet_spect_J = [],
    dataSet_spect_K = [],
    dataSet_spect_L = [],
    dataSet_spect_R = [],
    dataSet_spect_S = [],
    dataSet_spect_T = [],
    dataSet_spect_U = [],
    dataSet_spect_V = [],
    dataSet_spect_W = [],

    dataDurationInMilliseconds = 10*1000,

    selectedDeviceId = null,

    chart_temperature,
    chart_ph,
    chart_a_f,
    chart_g_l,
    chart_r_w,

    colorOfTemperature = "#60C173",
    colorOfPH = "#75B4FF",

    needToRefreshSzurkaloTimeline = false,
    displayMinMaxAvg = false,

    layoutType = "SZURKALOGEP",

    timeToBakcAtStart = -10 // !! minute

;

$(document).ready(function() {

    enumerationRefreshCallbacks.push(refreshEnumerationUsersOnSzurkalogepLive);


    if(displayMode == "NORMAL") {
        $('#btn_Sisak').hide();
        $('#btn_Vallfa').show();
        $('#btn_Szeker').show();
        $('#btn_Szurka').show();
    } else {
        $('#btn_Sisak').show()
        $('#btn_Vallfa').hide();
        $('#btn_Szeker').hide();
        $('#btn_Szurka').hide();
    }

    kvpRefreshCallbacks.push(refreshKVPsOnSzurkalogepLive);

    $('#dataDuration_10s').on('click', function () {refreshChartDuration(10);});
    $('#dataDuration_01m').on('click', function () {refreshChartDuration(1*60);});
    $('#dataDuration_05m').on('click', function () {refreshChartDuration(5*60);});
    $('#dataDuration_10m').on('click', function () {refreshChartDuration(10*60);});

    $('#btnSaveSettings').on('click', function () {saveSettings();});
    $('#modalSettings').on('shown.bs.modal', function (e) {$('#modalSettings_Pos_1_x').focus();});

    //region Charts
    chart_temperature = new Chart(document.getElementById("chart-line-temp").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [{data: [], label: 'Dataset 1', type: 'line', fill: false,},]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            legend: {display: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, angeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {
                        isoWeekday: true,
                        tooltipFormat: 'YYYY.MM.DD. HH:mm:ss',
                        displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}
                    },
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {}
                    }
                }]  ,
                //yAxes: [{ticks : {min: 0, max: 10,}}]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
            annotation: {annotations: [
                    {type: 'box', id: 'limits', xScaleID: 'x-axis-0', yScaleID: 'y-axis-0', yMax: 0.0, yMin:  0.0, borderColor: '#60C173', borderWidth: 2, backgroundColor: '#60C17355',},
                    {type: 'line',id: 'min', mode: 'horizontal', scaleID: 'y-axis-0', borderColor: 'gray',   borderDash: [6, 6], borderDashOffset: 5, borderWidth: 2, value: 0.0, drawTime: 'afterDraw', label: {backgroundColor: 'rgba(0,0,0,0.8)', fontFamily: "sans-serif", fontSize: 12, fontStyle: "bold", fontColor: "#fff", xPadding: 6, yPadding: 6, cornerRadius: 6, position: "left", xAdjust: 0, yAdjust: 0, enabled: displayMinMaxAvg, content: "Min.: 0"},},
                    {type: 'line',id: 'max', mode: 'horizontal', scaleID: 'y-axis-0', borderColor: 'gray',   borderDash: [6, 6], borderDashOffset: 5, borderWidth: 2, value: 0.0, drawTime: 'afterDraw', label: {backgroundColor: 'rgba(0,0,0,0.8)', fontFamily: "sans-serif", fontSize: 12, fontStyle: "bold", fontColor: "#fff", xPadding: 6, yPadding: 6, cornerRadius: 6, position: "left", xAdjust: 0, yAdjust: 0, enabled: displayMinMaxAvg, content: "Max.: 0"},},
                    {type: 'line',id: 'avg', mode: 'horizontal', scaleID: 'y-axis-0', borderColor: 'gray',   borderDash: [6, 6], borderDashOffset: 5, borderWidth: 2, value: 0.0, drawTime: 'afterDraw', label: {backgroundColor: 'rgba(0,0,0,0.8)', fontFamily: "sans-serif", fontSize: 12, fontStyle: "bold", fontColor: "#fff", xPadding: 6, yPadding: 6, cornerRadius: 6, position: "left", xAdjust: 0, yAdjust: 0, enabled: displayMinMaxAvg, content: "Átl.: 0.00"},},
                ]}
        }
    });
    chart_ph = new Chart(document.getElementById("chart-line-ph").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [{data: [], label: 'Dataset 1', type: 'line', fill: false},]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            legend: {display: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {

                            /* chart.data.datasets.forEach(function(dataset) {
                                 dataset.data.push({
                                     x: Date.now(),
                                     y: Math.random()
                                 });
                             });*/

                        }
                    }
                }],
                yAxes: [{ticks : {min: 4, max: 8,}}]
            },
            plugins: {colorschemes: {scheme: 'brewer.YlGn7'}},
            annotation: {annotations: [
                    {type: 'box', id: 'limits', xScaleID: 'x-axis-0', yScaleID: 'y-axis-0', yMax: 0.0, yMin:  0.0, borderColor: '#60C173', borderWidth: 2, backgroundColor: '#60C17355',},
                    {type: 'line',id: 'min', mode: 'horizontal', scaleID: 'y-axis-0', borderColor: 'gray',   borderDash: [6, 6], borderDashOffset: 5, borderWidth: 2, value: 0.0, drawTime: 'afterDraw', label: {backgroundColor: 'rgba(0,0,0,0.8)', fontFamily: "sans-serif", fontSize: 12, fontStyle: "bold", fontColor: "#fff", xPadding: 6, yPadding: 6, cornerRadius: 6, position: "left", xAdjust: 0, yAdjust: 0, enabled: displayMinMaxAvg, content: "Min.: 0"},},
                    {type: 'line',id: 'max', mode: 'horizontal', scaleID: 'y-axis-0', borderColor: 'gray',   borderDash: [6, 6], borderDashOffset: 5, borderWidth: 2, value: 0.0, drawTime: 'afterDraw', label: {backgroundColor: 'rgba(0,0,0,0.8)', fontFamily: "sans-serif", fontSize: 12, fontStyle: "bold", fontColor: "#fff", xPadding: 6, yPadding: 6, cornerRadius: 6, position: "left", xAdjust: 0, yAdjust: 0, enabled: displayMinMaxAvg, content: "Max.: 0"},},
                    {type: 'line',id: 'avg', mode: 'horizontal', scaleID: 'y-axis-0', borderColor: 'gray',   borderDash: [6, 6], borderDashOffset: 5, borderWidth: 2, value: 0.0, drawTime: 'afterDraw', label: {backgroundColor: 'rgba(0,0,0,0.8)', fontFamily: "sans-serif", fontSize: 12, fontStyle: "bold", fontColor: "#fff", xPadding: 6, yPadding: 6, cornerRadius: 6, position: "left", xAdjust: 0, yAdjust: 0, enabled: displayMinMaxAvg, content: "Átl.: 0.00"},},
                ]}
        }
    });
    chart_a_f = new Chart(document.getElementById("chart-line-a_f").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [{data: [], label: 'Dataset 1', type: 'line', fill: false,},]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {

                            /*chart.data.datasets.forEach(function(dataset) {
                                dataset.data.push({
                                    x: Date.now(),
                                    y: Math.random()
                                });
                            });*/

                        }
                    }
                }]
            },
            plugins: {colorschemes: {scheme: 'brewer.Accent6'}},
            annotation: {annotations: [

                ]}
        }
    });
    chart_g_l = new Chart(document.getElementById("chart-line-g_l").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [{data: [], label: 'Dataset 1', type: 'line', fill: false,},]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {

                            /*chart.data.datasets.forEach(function(dataset) {
                                dataset.data.push({
                                    x: Date.now(),
                                    y: Math.random()
                                });
                            });*/

                        }
                    }
                }]
            },
            plugins: {colorschemes: {scheme: 'brewer.PastelOne6'}},
            annotation: {annotations: [

                ]}
        }
    });
    chart_r_w = new Chart(document.getElementById("chart-line-r_w").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [{data: [], label: 'Dataset 1', type: 'line', fill: false,},]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {

                            /*chart.data.datasets.forEach(function(dataset) {
                                dataset.data.push({
                                    x: Date.now(),
                                    y: Math.random()
                                });
                            });*/

                        }
                    }
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.ClassicLight10'}},
            annotation: {annotations: [

                ]}
        }
    });
    //endregion Charts

    refreshTableUpdateTimes();

    setInterval(function(){ refreshTableUpdateTimes(); }, 1000);

    showData(selectedDeviceId);
    setInterval(function(){ showData(selectedDeviceId); }, 1000);


    resizePanel();
    $(window).bind('resize', function(){resizePanel();});
});

function refreshKVPsOnSzurkalogepLive() {
    chart_temperature.annotation.elements['limits'].options.yMax = parseFloat(dataSet_KVPs["limit_temp_max"]);
    chart_temperature.annotation.elements['limits'].options.yMin = parseFloat(dataSet_KVPs["limit_temp_min"]);

    chart_ph.annotation.elements['limits'].options.yMax = parseFloat(dataSet_KVPs["limit_PH_max"]);
    chart_ph.annotation.elements['limits'].options.yMin = parseFloat(dataSet_KVPs["limit_PH_min"]);
}

//region Download data
function refreshTableUpdateTimes() {
    $.ajax({
        url: "../generalCommunication/tableupdatetimes",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {

            if(resp) {

                let tableUpdateTimes = resp.tableUpdateTimes;

                for (let key in tableUpdateTimes) {
                    if (!(key in dataSet_TableUpdateTimes) || tableUpdateTimes[key] > dataSet_TableUpdateTimes[key]) {
                        refreshItem(key);
                        dataSet_TableUpdateTimes[key] = tableUpdateTimes[key];
                    }
                }
            } else {
                dataSet_TableUpdateTimes = [];
            }
        }
    });
}

function refreshItem(key) {
    switch(key) {
        case "kvp":                         refreshKVPs(); break;

        case "rfid":                        refreshData_rfid(selectedDeviceId); break;
        case "ph_Value":                    refreshData_ph_Value(selectedDeviceId); break;
        case "temperatureThermocouple":     refreshData_temperature_Thermocouple(selectedDeviceId); break;

        case "spect_A":            refreshData_spect_A(); break;
        case "spect_B":            refreshData_spect_B(); break;
        case "spect_C":            refreshData_spect_C(); break;
        case "spect_D":            refreshData_spect_D(); break;
        case "spect_E":            refreshData_spect_E(); break;
        case "spect_F":            refreshData_spect_F(); break;
        case "spect_G":            refreshData_spect_G(); break;
        case "spect_H":            refreshData_spect_H(); break;
        case "spect_I":            refreshData_spect_I(); break;
        case "spect_J":            refreshData_spect_J(); break;
        case "spect_K":            refreshData_spect_K(); break;
        case "spect_L":            refreshData_spect_L(); break;
        case "spect_R":            refreshData_spect_R(); break;
        case "spect_S":            refreshData_spect_S(); break;
        case "spect_T":            refreshData_spect_T(); break;
        case "spect_U":            refreshData_spect_U(); break;
        case "spect_V":            refreshData_spect_V(); break;
        case "spect_W":            refreshData_spect_W(); break;

        default:                   refreshEnumerationData(key); break;
    }
}

function addItemToMeasurements(measurements, type, timeStamp, value) {

    let found = false;
    measurements.forEach((temp) => {
        if( Math.abs(timeStamp - temp.timeStamp) < timeStampThreshold ) {
            found = true;
            temp[""+type] = value;
            temp[""+type+"_timeStamp"] = timeStamp;
        }
    } );

    if(!found) {
        let temp = {timeStamp: timeStamp}
        temp[""+type] = value;
        temp[""+type+"_timeStamp"] = timeStamp
        measurements.unshift(temp);
    }

}

function refreshData_rfid() {
    let timeStamp = dataSet_TableUpdateTimes["rfid"];
    if (dataSet_rfid.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/rfidOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp, deviceId: selectedDeviceId, }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_rfid = dataSet_rfid.concat(resp);showData(selectedDeviceId);}}});
}


function refreshData_ph_Value() {
    let timeStamp = dataSet_TableUpdateTimes["ph_Value"];
    if (dataSet_ph_Value.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;

    $.ajax({url: "../data/ph_ValueOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp , deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "ph_Value", tempData.timeStamp, tempData.ph_Value); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "ph_Value", tempData.timeStamp, tempData.ph_Value); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "ph_Value", tempData.timeStamp, tempData.ph_Value); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "ph_Value", tempData.timeStamp, tempData.ph_Value); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_ph_Value = dataSet_ph_Value.concat(resp);
        //needToRefreshSzurkaloTimeline = true;
    }}});

}

function refreshData_temperature_Thermocouple() {
    let timeStamp = dataSet_TableUpdateTimes["temperatureThermocouple"];
    if (dataSet_temperature_Thermocouple.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/temperatureThermocoupleOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp , deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {
            if(resp) {
                resp.forEach((tempData) => {
                    switch(tempData.deviceId) {
                        case selectedDeviceId:     addItemToMeasurements(measurements_device1, "temperatureThermocouple", tempData.timeStamp, tempData.temperatureThermocouple); break;
                        case "ketto":   addItemToMeasurements(measurements_device2, "temperatureThermocouple", tempData.timeStamp, tempData.temperatureThermocouple); break;
                        case "harom":   addItemToMeasurements(measurements_device3, "temperatureThermocouple", tempData.timeStamp, tempData.temperatureThermocouple); break;
                        case "negy":    addItemToMeasurements(measurements_device4, "temperatureThermocouple", tempData.timeStamp, tempData.temperatureThermocouple); break;
                        default:        console.log("Unknown deviceId"); break;
                    }
                });
                dataSet_temperature_Thermocouple = dataSet_temperature_Thermocouple.concat(resp);
                needToRefreshSzurkaloTimeline = true;
            }}});
}

function refreshData_spect_A() {
    let timeStamp = dataSet_TableUpdateTimes["spect_A"];
    if (dataSet_spect_A.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_AOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp, deviceId: selectedDeviceId }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_A", tempData.timeStamp, tempData.spect_A); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_A", tempData.timeStamp, tempData.spect_A); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_A", tempData.timeStamp, tempData.spect_A); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_A", tempData.timeStamp, tempData.spect_A); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_A = dataSet_spect_A.concat(resp);
    }}});

}
function refreshData_spect_B() {
    let timeStamp = dataSet_TableUpdateTimes["spect_B"];
    if (dataSet_spect_B.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_BOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_B", tempData.timeStamp, tempData.spect_B); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_B", tempData.timeStamp, tempData.spect_B); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_B", tempData.timeStamp, tempData.spect_B); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_B", tempData.timeStamp, tempData.spect_B); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_B = dataSet_spect_B.concat(resp);
    }}});

}
function refreshData_spect_C() {
    let timeStamp = dataSet_TableUpdateTimes["spect_C"];
    if (dataSet_spect_C.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_COfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_C", tempData.timeStamp, tempData.spect_C); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_C", tempData.timeStamp, tempData.spect_C); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_C", tempData.timeStamp, tempData.spect_C); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_C", tempData.timeStamp, tempData.spect_C); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_C = dataSet_spect_C.concat(resp);
    }}});

}
function refreshData_spect_D() {
    let timeStamp = dataSet_TableUpdateTimes["spect_D"];
    if (dataSet_spect_D.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_DOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_D", tempData.timeStamp, tempData.spect_D); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_D", tempData.timeStamp, tempData.spect_D); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_D", tempData.timeStamp, tempData.spect_D); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_D", tempData.timeStamp, tempData.spect_D); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_D = dataSet_spect_D.concat(resp);
    }}});

}
function refreshData_spect_E() {
    let timeStamp = dataSet_TableUpdateTimes["spect_E"];
    if (dataSet_spect_E.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_EOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_E", tempData.timeStamp, tempData.spect_E); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_E", tempData.timeStamp, tempData.spect_E); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_E", tempData.timeStamp, tempData.spect_E); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_E", tempData.timeStamp, tempData.spect_E); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_E = dataSet_spect_E.concat(resp);
    }}});

}
function refreshData_spect_F() {
    let timeStamp = dataSet_TableUpdateTimes["spect_F"];
    if (dataSet_spect_F.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_FOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
            resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_F", tempData.timeStamp, tempData.spect_F); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_F", tempData.timeStamp, tempData.spect_F); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_F", tempData.timeStamp, tempData.spect_F); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_F", tempData.timeStamp, tempData.spect_F); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_F = dataSet_spect_F.concat(resp);
    }}});

}
function refreshData_spect_G() {
    let timeStamp = dataSet_TableUpdateTimes["spect_G"];
    if (dataSet_spect_G.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_GOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_G", tempData.timeStamp, tempData.spect_G); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_G", tempData.timeStamp, tempData.spect_G); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_G", tempData.timeStamp, tempData.spect_G); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_G", tempData.timeStamp, tempData.spect_G); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_G = dataSet_spect_G.concat(resp);
    }}});

}
function refreshData_spect_H() {
    let timeStamp = dataSet_TableUpdateTimes["spect_H"];
    if (dataSet_spect_H.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_HOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_H", tempData.timeStamp, tempData.spect_H); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_H", tempData.timeStamp, tempData.spect_H); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_H", tempData.timeStamp, tempData.spect_H); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_H", tempData.timeStamp, tempData.spect_H); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_H = dataSet_spect_H.concat(resp);
    }}});

}
function refreshData_spect_I() {
    let timeStamp = dataSet_TableUpdateTimes["spect_I"];
    if (dataSet_spect_I.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_IOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_I", tempData.timeStamp, tempData.spect_I); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_I", tempData.timeStamp, tempData.spect_I); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_I", tempData.timeStamp, tempData.spect_I); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_I", tempData.timeStamp, tempData.spect_I); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_I = dataSet_spect_I.concat(resp);
    }}});

}
function refreshData_spect_J() {
    let timeStamp = dataSet_TableUpdateTimes["spect_J"];
    if (dataSet_spect_J.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_JOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_J", tempData.timeStamp, tempData.spect_J); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_J", tempData.timeStamp, tempData.spect_J); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_J", tempData.timeStamp, tempData.spect_J); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_J", tempData.timeStamp, tempData.spect_J); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_J = dataSet_spect_J.concat(resp);
    }}});

}
function refreshData_spect_K() {
    let timeStamp = dataSet_TableUpdateTimes["spect_K"];
    if (dataSet_spect_K.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_KOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_K", tempData.timeStamp, tempData.spect_K); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_K", tempData.timeStamp, tempData.spect_K); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_K", tempData.timeStamp, tempData.spect_K); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_K", tempData.timeStamp, tempData.spect_K); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_K = dataSet_spect_K.concat(resp);
    }}});

}
function refreshData_spect_L() {
    let timeStamp = dataSet_TableUpdateTimes["spect_L"];
    if (dataSet_spect_L.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_LOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_L", tempData.timeStamp, tempData.spect_L); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_L", tempData.timeStamp, tempData.spect_L); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_L", tempData.timeStamp, tempData.spect_L); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_L", tempData.timeStamp, tempData.spect_L); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_L = dataSet_spect_L.concat(resp);
    }}});

}
function refreshData_spect_R() {
    let timeStamp = dataSet_TableUpdateTimes["spect_R"];
    if (dataSet_spect_R.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_ROfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_R", tempData.timeStamp, tempData.spect_R); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_R", tempData.timeStamp, tempData.spect_R); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_R", tempData.timeStamp, tempData.spect_R); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_R", tempData.timeStamp, tempData.spect_R); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_R = dataSet_spect_R.concat(resp);
    }}});

}
function refreshData_spect_S() {
    let timeStamp = dataSet_TableUpdateTimes["spect_S"];
    if (dataSet_spect_S.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_SOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_S", tempData.timeStamp, tempData.spect_S); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_S", tempData.timeStamp, tempData.spect_S); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_S", tempData.timeStamp, tempData.spect_S); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_S", tempData.timeStamp, tempData.spect_S); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_S = dataSet_spect_S.concat(resp);
    }}});

}
function refreshData_spect_T() {
    let timeStamp = dataSet_TableUpdateTimes["spect_T"];
    if (dataSet_spect_T.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_TOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_T", tempData.timeStamp, tempData.spect_T); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_T", tempData.timeStamp, tempData.spect_T); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_T", tempData.timeStamp, tempData.spect_T); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_T", tempData.timeStamp, tempData.spect_T); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_T = dataSet_spect_T.concat(resp);
    }}});

}
function refreshData_spect_U() {
    let timeStamp = dataSet_TableUpdateTimes["spect_U"];
    if (dataSet_spect_U.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_UOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_U", tempData.timeStamp, tempData.spect_U); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_U", tempData.timeStamp, tempData.spect_U); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_U", tempData.timeStamp, tempData.spect_U); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_U", tempData.timeStamp, tempData.spect_U); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_U = dataSet_spect_U.concat(resp);
    }}});

}
function refreshData_spect_V() {
    let timeStamp = dataSet_TableUpdateTimes["spect_V"];
    if (dataSet_spect_V.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_VOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_V", tempData.timeStamp, tempData.spect_V); break;
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_V", tempData.timeStamp, tempData.spect_V); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_V", tempData.timeStamp, tempData.spect_V); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_V", tempData.timeStamp, tempData.spect_V); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_V = dataSet_spect_V.concat(resp);
    }}});

}
function refreshData_spect_W() {
    let timeStamp = dataSet_TableUpdateTimes["spect_W"];
    if (dataSet_spect_W.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_WOfDeviceAfterTimeStamp", data: { timeStamp: timeStamp,  deviceId: selectedDeviceId,}, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {
        resp.forEach((tempData) => {
                switch(tempData.deviceId) {
                    case "ketto":   addItemToMeasurements(measurements_device2, "spect_W", tempData.timeStamp, tempData.spect_W); break;
                    case selectedDeviceId:     addItemToMeasurements(measurements_device1, "spect_W", tempData.timeStamp, tempData.spect_W); break;
                    case "harom":   addItemToMeasurements(measurements_device3, "spect_W", tempData.timeStamp, tempData.spect_W); break;
                    case "negy":    addItemToMeasurements(measurements_device4, "spect_W", tempData.timeStamp, tempData.spect_W); break;
                    default:        console.log("Unknown deviceId"); break;
                }
            });
        dataSet_spect_W = dataSet_spect_W.concat(resp);
    }}});

}


//endregion

//region Process data
function processData() {

    let spect_A_device1 = [], spect_A_device2 = [], spect_A_device3 = [], spect_A_device4 = [],
        spect_B_device1 = [], spect_B_device2 = [], spect_B_device3 = [], spect_B_device4 = [],
        spect_C_device1 = [], spect_C_device2 = [], spect_C_device3 = [], spect_C_device4 = [],
        spect_D_device1 = [], spect_D_device2 = [], spect_D_device3 = [], spect_D_device4 = [],
        spect_E_device1 = [], spect_E_device2 = [], spect_E_device3 = [], spect_E_device4 = [],
        spect_F_device1 = [], spect_F_device2 = [], spect_F_device3 = [], spect_F_device4 = [],
        spect_G_device1 = [], spect_G_device2 = [], spect_G_device3 = [], spect_G_device4 = [],
        spect_H_device1 = [], spect_H_device2 = [], spect_H_device3 = [], spect_H_device4 = [],
        spect_I_device1 = [], spect_I_device2 = [], spect_I_device3 = [], spect_I_device4 = [],
        spect_J_device1 = [], spect_J_device2 = [], spect_J_device3 = [], spect_J_device4 = [],
        spect_K_device1 = [], spect_K_device2 = [], spect_K_device3 = [], spect_K_device4 = [],
        spect_L_device1 = [], spect_L_device2 = [], spect_L_device3 = [], spect_L_device4 = [],
        spect_R_device1 = [], spect_R_device2 = [], spect_R_device3 = [], spect_R_device4 = [],
        spect_S_device1 = [], spect_S_device2 = [], spect_S_device3 = [], spect_S_device4 = [],
        spect_T_device1 = [], spect_T_device2 = [], spect_T_device3 = [], spect_T_device4 = [],
        spect_U_device1 = [], spect_U_device2 = [], spect_U_device3 = [], spect_U_device4 = [],
        spect_V_device1 = [], spect_V_device2 = [], spect_V_device3 = [], spect_V_device4 = [],
        spect_W_device1 = [], spect_W_device2 = [], spect_W_device3 = [], spect_W_device4 = [],

        PHValueData_device1 = [], PHValueData_device2 = [], PHValueData_device3 = [], PHValueData_device4 = [],

        temperatureData_Thermocouple_device1   = [], temperatureData_Thermocouple_device2   = [], temperatureData_Thermocouple_device3    = [], temperatureData_Thermocouple_device4   = []
    ;

    let timeStampMin = Date.now()-dataDurationInMilliseconds, timeStampMax = Date.now(),
        sum_temperatureThermocoupleData_1 = 0, cnt_temperatureThermocoupleData_1 = 0, min_temperatureThermocoupleData_1 = Number.MAX_VALUE, max_temperatureThermocoupleData_1 = Number.MIN_VALUE, current_temperatureThermocoupleData_1 = 0,
        sum_temperatureThermocoupleData_2 = 0, cnt_temperatureThermocoupleData_2 = 0, min_temperatureThermocoupleData_2 = Number.MAX_VALUE, max_temperatureThermocoupleData_2 = Number.MIN_VALUE, current_temperatureThermocoupleData_2 = 0,
        sum_temperatureThermocoupleData_3 = 0, cnt_temperatureThermocoupleData_3 = 0, min_temperatureThermocoupleData_3 = Number.MAX_VALUE, max_temperatureThermocoupleData_3 = Number.MIN_VALUE, current_temperatureThermocoupleData_3 = 0,
        sum_temperatureThermocoupleData_4 = 0, cnt_temperatureThermocoupleData_4 = 0, min_temperatureThermocoupleData_4 = Number.MAX_VALUE, max_temperatureThermocoupleData_4 = Number.MIN_VALUE, current_temperatureThermocoupleData_4 = 0,
        sum_ph_ValueData_1 = 0, cnt_ph_ValueData_1 = 0, min_ph_ValueData_1 = Number.MAX_VALUE, max_ph_ValueData_1 = Number.MIN_VALUE, current_ph_ValueData_1 = 0,
        sum_ph_ValueData_2 = 0, cnt_ph_ValueData_2 = 0, min_ph_ValueData_2 = Number.MAX_VALUE, max_ph_ValueData_2 = Number.MIN_VALUE, current_ph_ValueData_2 = 0,
        sum_ph_ValueData_3 = 0, cnt_ph_ValueData_3 = 0, min_ph_ValueData_3 = Number.MAX_VALUE, max_ph_ValueData_3 = Number.MIN_VALUE, current_ph_ValueData_3 = 0,
        sum_ph_ValueData_4 = 0, cnt_ph_ValueData_4 = 0, min_ph_ValueData_4 = Number.MAX_VALUE, max_ph_ValueData_4 = Number.MIN_VALUE, current_ph_ValueData_4 = 0;

    dataSet_spect_A.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_A_device1.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "egy":     spect_A_device1.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "ketto":   spect_A_device2.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "harom":   spect_A_device3.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "negy":    spect_A_device4.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_B.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_B_device1.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "egy":     spect_B_device1.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "ketto":   spect_B_device2.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "harom":   spect_B_device3.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "negy":    spect_B_device4.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_C.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_C_device1.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "egy":     spect_C_device1.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "ketto":   spect_C_device2.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "harom":   spect_C_device3.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "negy":    spect_C_device4.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_D.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_D_device1.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "egy":     spect_D_device1.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "ketto":   spect_D_device2.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "harom":   spect_D_device3.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "negy":    spect_D_device4.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_E.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_E_device1.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "egy":     spect_E_device1.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "ketto":   spect_E_device2.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "harom":   spect_E_device3.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "negy":    spect_E_device4.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_F.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_F_device1.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "egy":     spect_F_device1.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "ketto":   spect_F_device2.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "harom":   spect_F_device3.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "negy":    spect_F_device4.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_G.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_G_device1.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "egy":     spect_G_device1.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "ketto":   spect_G_device2.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "harom":   spect_G_device3.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "negy":    spect_G_device4.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_H.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_H_device1.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "egy":     spect_H_device1.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "ketto":   spect_H_device2.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "harom":   spect_H_device3.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "negy":    spect_H_device4.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_I.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_I_device1.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "egy":     spect_I_device1.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "ketto":   spect_I_device2.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "harom":   spect_I_device3.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "negy":    spect_I_device4.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_J.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_J_device1.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "egy":     spect_J_device1.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "ketto":   spect_J_device2.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "harom":   spect_J_device3.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "negy":    spect_J_device4.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_K.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_K_device1.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "egy":     spect_K_device1.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "ketto":   spect_K_device2.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "harom":   spect_K_device3.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "negy":    spect_K_device4.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_L.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_L_device1.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "egy":     spect_L_device1.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "ketto":   spect_L_device2.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "harom":   spect_L_device3.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "negy":    spect_L_device4.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_R.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_R_device1.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "egy":     spect_R_device1.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "ketto":   spect_R_device2.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "harom":   spect_R_device3.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "negy":    spect_R_device4.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_S.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_S_device1.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "egy":     spect_S_device1.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "ketto":   spect_S_device2.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "harom":   spect_S_device3.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "negy":    spect_S_device4.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_T.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_T_device1.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "egy":     spect_T_device1.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "ketto":   spect_T_device2.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "harom":   spect_T_device3.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "negy":    spect_T_device4.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_U.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_U_device1.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "egy":     spect_U_device1.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "ketto":   spect_U_device2.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "harom":   spect_U_device3.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "negy":    spect_U_device4.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_V.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_V_device1.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "egy":     spect_V_device1.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "ketto":   spect_V_device2.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "harom":   spect_V_device3.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "negy":    spect_V_device4.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_W.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     spect_W_device1.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "egy":     spect_W_device1.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "ketto":   spect_W_device2.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "harom":   spect_W_device3.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "negy":    spect_W_device4.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    /*
    dataSet_ph_Value.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     PHValueData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "ketto":   PHValueData_device2.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "harom":   PHValueData_device3.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "negy":    PHValueData_device4.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_temperature_Thermocouple.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     temperatureData_Thermocouple_device1.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple});  break;
            case "ketto":   temperatureData_Thermocouple_device2.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple});  break;
            case "harom":   temperatureData_Thermocouple_device3.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple});  break;
            case "negy":    temperatureData_Thermocouple_device4.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple});  break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    */

    dataSet_temperature_Thermocouple.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:
                temperatureData_Thermocouple_device1.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple});
                if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_temperatureThermocoupleData_1 = tempData.temperatureThermocouple;
                    sum_temperatureThermocoupleData_1 += tempData.temperatureThermocouple; cnt_temperatureThermocoupleData_1++;
                    if(tempData.temperatureThermocouple < min_temperatureThermocoupleData_1 ) min_temperatureThermocoupleData_1=tempData.temperatureThermocouple;
                    if(tempData.temperatureThermocouple > max_temperatureThermocoupleData_1 ) max_temperatureThermocoupleData_1 =tempData.temperatureThermocouple;}
                break;
            case "egy":     temperatureData_Thermocouple_device1.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_temperatureThermocoupleData_1 = tempData.temperatureThermocouple; sum_temperatureThermocoupleData_1 += tempData.temperatureThermocouple; cnt_temperatureThermocoupleData_1++; if(tempData.temperatureThermocouple < min_temperatureThermocoupleData_1 ) min_temperatureThermocoupleData_1=tempData.temperatureThermocouple; if(tempData.temperatureThermocouple > max_temperatureThermocoupleData_1 ) max_temperatureThermocoupleData_1 =tempData.temperatureThermocouple;} break;
            case "ketto":   temperatureData_Thermocouple_device2.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_temperatureThermocoupleData_2 = tempData.temperatureThermocouple; sum_temperatureThermocoupleData_2 += tempData.temperatureThermocouple; cnt_temperatureThermocoupleData_2++; if(tempData.temperatureThermocouple < min_temperatureThermocoupleData_2 ) min_temperatureThermocoupleData_2=tempData.temperatureThermocouple; if(tempData.temperatureThermocouple > max_temperatureThermocoupleData_2 ) max_temperatureThermocoupleData_2 =tempData.temperatureThermocouple;} break;
            case "harom":   temperatureData_Thermocouple_device3.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_temperatureThermocoupleData_3 = tempData.temperatureThermocouple; sum_temperatureThermocoupleData_3 += tempData.temperatureThermocouple; cnt_temperatureThermocoupleData_3++; if(tempData.temperatureThermocouple < min_temperatureThermocoupleData_3 ) min_temperatureThermocoupleData_3=tempData.temperatureThermocouple; if(tempData.temperatureThermocouple > max_temperatureThermocoupleData_3 ) max_temperatureThermocoupleData_3 =tempData.temperatureThermocouple;} break;
            case "negy":    temperatureData_Thermocouple_device4.push({ x: tempData.timeStamp, y: tempData.temperatureThermocouple}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_temperatureThermocoupleData_4 = tempData.temperatureThermocouple; sum_temperatureThermocoupleData_4 += tempData.temperatureThermocouple; cnt_temperatureThermocoupleData_4++; if(tempData.temperatureThermocouple < min_temperatureThermocoupleData_4 ) min_temperatureThermocoupleData_4=tempData.temperatureThermocouple; if(tempData.temperatureThermocouple > max_temperatureThermocoupleData_4 ) max_temperatureThermocoupleData_4 =tempData.temperatureThermocouple;} break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_ph_Value.forEach((tempData) => {
        switch(tempData.deviceId) {
            case selectedDeviceId:     PHValueData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Value}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_ph_ValueData_1 = tempData.ph_Value; sum_ph_ValueData_1 += tempData.ph_Value; cnt_ph_ValueData_1++; if(tempData.ph_Value < min_ph_ValueData_1 ) min_ph_ValueData_1=tempData.ph_Value; if(tempData.ph_Value > max_ph_ValueData_1 ) max_ph_ValueData_1 =tempData.ph_Value;} break;
            case "egy":     PHValueData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Value}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_ph_ValueData_1 = tempData.ph_Value; sum_ph_ValueData_1 += tempData.ph_Value; cnt_ph_ValueData_1++; if(tempData.ph_Value < min_ph_ValueData_1 ) min_ph_ValueData_1=tempData.ph_Value; if(tempData.ph_Value > max_ph_ValueData_1 ) max_ph_ValueData_1 =tempData.ph_Value;} break;
            case "ketto":   PHValueData_device2.push({ x: tempData.timeStamp, y: tempData.ph_Value}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_ph_ValueData_2 = tempData.ph_Value; sum_ph_ValueData_2 += tempData.ph_Value; cnt_ph_ValueData_2++; if(tempData.ph_Value < min_ph_ValueData_2 ) min_ph_ValueData_2=tempData.ph_Value; if(tempData.ph_Value > max_ph_ValueData_2 ) max_ph_ValueData_2 =tempData.ph_Value;} break;
            case "harom":   PHValueData_device3.push({ x: tempData.timeStamp, y: tempData.ph_Value}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_ph_ValueData_3 = tempData.ph_Value; sum_ph_ValueData_3 += tempData.ph_Value; cnt_ph_ValueData_3++; if(tempData.ph_Value < min_ph_ValueData_3 ) min_ph_ValueData_3=tempData.ph_Value; if(tempData.ph_Value > max_ph_ValueData_3 ) max_ph_ValueData_3 =tempData.ph_Value;} break;
            case "negy":    PHValueData_device4.push({ x: tempData.timeStamp, y: tempData.ph_Value}); if(tempData.timeStamp >= timeStampMin && tempData.timeStamp <= timeStampMax) { current_ph_ValueData_4 = tempData.ph_Value; sum_ph_ValueData_4 += tempData.ph_Value; cnt_ph_ValueData_4++; if(tempData.ph_Value < min_ph_ValueData_4 ) min_ph_ValueData_4=tempData.ph_Value; if(tempData.ph_Value > max_ph_ValueData_4 ) max_ph_ValueData_4 =tempData.ph_Value;} break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    let avgTemperatureData = 0, minTemperatureData = 0, maxTemperatureData = 0;
    let avgPHData = 0, minPHData = 0, maxPHData = 0;

    chart_temperature.data = {datasets: [{ label: "Hőmérséklet",          data: temperatureData_Thermocouple_device1,  fill: false, borderColor: colorOfTemperature,pointBackgroundColor: colorOfTemperature, pointBorderColor: colorOfTemperature, pointHoverBackgroundColor: colorOfTemperature, pointHoverBorderColor: colorOfTemperature,},]};
    chart_ph.data = {datasets: [{ label: "PH",   data: PHValueData_device1,         fill: false, borderColor: colorOfPH,pointBackgroundColor: colorOfPH, pointBorderColor: colorOfPH, pointHoverBackgroundColor: colorOfPH, pointHoverBorderColor: colorOfPH,},]};
    chart_a_f.data = {datasets: [
            { label: "A", data: spect_A_device1, fill: false,},
            { label: "B", data: spect_B_device1, fill: false,},
            { label: "C", data: spect_C_device1, fill: false,},
            { label: "D", data: spect_D_device1, fill: false,},
            { label: "E", data: spect_E_device1, fill: false,},
            { label: "F", data: spect_F_device1, fill: false,},
        ]};
    chart_g_l.data = {datasets: [
            { label: "G", data: spect_G_device1, fill: false,},
            { label: "H", data: spect_H_device1, fill: false,},
            { label: "I", data: spect_I_device1, fill: false,},
            { label: "J", data: spect_J_device1, fill: false,},
            { label: "K", data: spect_K_device1, fill: false,},
            { label: "L", data: spect_L_device1, fill: false,},
        ]};
    chart_r_w.data = {datasets: [
            { label: "R", data: spect_R_device1, fill: false,},
            { label: "S", data: spect_S_device1, fill: false,},
            { label: "T", data: spect_T_device1, fill: false,},
            { label: "U", data: spect_U_device1, fill: false,},
            { label: "V", data: spect_V_device1, fill: false,},
            { label: "W", data: spect_W_device1, fill: false,},
        ]};
    avgTemperatureData = sum_temperatureThermocoupleData_1 / cnt_temperatureThermocoupleData_1; minTemperatureData = min_temperatureThermocoupleData_1; maxTemperatureData = max_temperatureThermocoupleData_1;
    avgPHData = sum_ph_ValueData_1 / cnt_ph_ValueData_1; minPHData = min_ph_ValueData_1; maxPHData = max_ph_ValueData_1;
    /*
    if(selectedDeviceId == "egy") {
        chart_temperature.data = {datasets: [{ label: "Hőmérséklet",          data: temperatureData_Thermocouple_device1,  fill: false, borderColor: colorOfTemperature,pointBackgroundColor: colorOfTemperature, pointBorderColor: colorOfTemperature, pointHoverBackgroundColor: colorOfTemperature, pointHoverBorderColor: colorOfTemperature,},]};
        chart_ph.data = {datasets: [{ label: "PH",   data: PHValueData_device1,         fill: false, borderColor: colorOfPH,pointBackgroundColor: colorOfPH, pointBorderColor: colorOfPH, pointHoverBackgroundColor: colorOfPH, pointHoverBorderColor: colorOfPH,},]};
        chart_a_f.data = {datasets: [
                { label: "A", data: spect_A_device1, fill: false,},
                { label: "B", data: spect_B_device1, fill: false,},
                { label: "C", data: spect_C_device1, fill: false,},
                { label: "D", data: spect_D_device1, fill: false,},
                { label: "E", data: spect_E_device1, fill: false,},
                { label: "F", data: spect_F_device1, fill: false,},
            ]};
        chart_g_l.data = {datasets: [
                { label: "G", data: spect_G_device1, fill: false,},
                { label: "H", data: spect_H_device1, fill: false,},
                { label: "I", data: spect_I_device1, fill: false,},
                { label: "J", data: spect_J_device1, fill: false,},
                { label: "K", data: spect_K_device1, fill: false,},
                { label: "L", data: spect_L_device1, fill: false,},
            ]};
        chart_r_w.data = {datasets: [
                { label: "R", data: spect_R_device1, fill: false,},
                { label: "S", data: spect_S_device1, fill: false,},
                { label: "T", data: spect_T_device1, fill: false,},
                { label: "U", data: spect_U_device1, fill: false,},
                { label: "V", data: spect_V_device1, fill: false,},
                { label: "W", data: spect_W_device1, fill: false,},
            ]};
        avgTemperatureData = sum_temperatureThermocoupleData_1 / cnt_temperatureThermocoupleData_1; minTemperatureData = min_temperatureThermocoupleData_1; maxTemperatureData = max_temperatureThermocoupleData_1;
        avgPHData = sum_ph_ValueData_1 / cnt_ph_ValueData_1; minPHData = min_ph_ValueData_1; maxPHData = max_ph_ValueData_1;
    }
    else if(selectedDeviceId == "ketto") {
        chart_temperature.data = {datasets: [{ label: "Hőmérséklet",          data: temperatureData_Thermocouple_device2,  fill: false, borderColor: colorOfTemperature,pointBackgroundColor: colorOfTemperature, pointBorderColor: colorOfTemperature, pointHoverBackgroundColor: colorOfTemperature, pointHoverBorderColor: colorOfTemperature,},]};
        chart_ph.data = {datasets: [{ label: "PH",   data: PHValueData_device2,         fill: false, borderColor: colorOfPH,pointBackgroundColor: colorOfPH, pointBorderColor: colorOfPH, pointHoverBackgroundColor: colorOfPH, pointHoverBorderColor: colorOfPH,},]};
        chart_a_f.data = {datasets: [
                { label: "A", data: spect_A_device2, fill: false,},
                { label: "B", data: spect_B_device2, fill: false,},
                { label: "C", data: spect_C_device2, fill: false,},
                { label: "D", data: spect_D_device2, fill: false,},
                { label: "E", data: spect_E_device2, fill: false,},
                { label: "F", data: spect_F_device2, fill: false,},
            ]};
        chart_g_l.data = {datasets: [
                { label: "G", data: spect_G_device2, fill: false,},
                { label: "H", data: spect_H_device2, fill: false,},
                { label: "I", data: spect_I_device2, fill: false,},
                { label: "J", data: spect_J_device2, fill: false,},
                { label: "K", data: spect_K_device2, fill: false,},
                { label: "L", data: spect_L_device2, fill: false,},
            ]};
        chart_r_w.data = {datasets: [
                { label: "R", data: spect_R_device2, fill: false,},
                { label: "S", data: spect_S_device2, fill: false,},
                { label: "T", data: spect_T_device2, fill: false,},
                { label: "U", data: spect_U_device2, fill: false,},
                { label: "V", data: spect_V_device2, fill: false,},
                { label: "W", data: spect_W_device2, fill: false,},
            ]};

        avgTemperatureData = sum_temperatureThermocoupleData_2 / cnt_temperatureThermocoupleData_2; minTemperatureData = min_temperatureThermocoupleData_2; maxTemperatureData = max_temperatureThermocoupleData_2;
        avgPHData = sum_ph_ValueData_2 / cnt_ph_ValueData_2; minPHData = min_ph_ValueData_2; maxPHData = max_ph_ValueData_2;
    }
    else if(selectedDeviceId == "harom") {
        chart_temperature.data = {datasets: [{ label: "Hőmérséklet",          data: temperatureData_Thermocouple_device3,  fill: false, borderColor: colorOfTemperature,pointBackgroundColor: colorOfTemperature, pointBorderColor: colorOfTemperature, pointHoverBackgroundColor: colorOfTemperature, pointHoverBorderColor: colorOfTemperature,},]};
        chart_ph.data = {datasets: [{ label: "PH",   data: PHValueData_device3,         fill: false, borderColor: colorOfPH,pointBackgroundColor: colorOfPH, pointBorderColor: colorOfPH, pointHoverBackgroundColor: colorOfPH, pointHoverBorderColor: colorOfPH,},]};
        chart_a_f.data = {datasets: [
                { label: "A", data: spect_A_device3, fill: false,},
                { label: "B", data: spect_B_device3, fill: false,},
                { label: "C", data: spect_C_device3, fill: false,},
                { label: "D", data: spect_D_device3, fill: false,},
                { label: "E", data: spect_E_device3, fill: false,},
                { label: "F", data: spect_F_device3, fill: false,},
            ]};
        chart_g_l.data = {datasets: [
                { label: "G", data: spect_G_device3, fill: false,},
                { label: "H", data: spect_H_device3, fill: false,},
                { label: "I", data: spect_I_device3, fill: false,},
                { label: "J", data: spect_J_device3, fill: false,},
                { label: "K", data: spect_K_device3, fill: false,},
                { label: "L", data: spect_L_device3, fill: false,},
            ]};
        chart_r_w.data = {datasets: [
                { label: "R", data: spect_R_device3, fill: false,},
                { label: "S", data: spect_S_device3, fill: false,},
                { label: "T", data: spect_T_device3, fill: false,},
                { label: "U", data: spect_U_device3, fill: false,},
                { label: "V", data: spect_V_device3, fill: false,},
                { label: "W", data: spect_W_device3, fill: false,},
            ]};

        avgTemperatureData = sum_temperatureThermocoupleData_3 / cnt_temperatureThermocoupleData_3; minTemperatureData = min_temperatureThermocoupleData_3; maxTemperatureData = max_temperatureThermocoupleData_3;
        avgPHData = sum_ph_ValueData_3 / cnt_ph_ValueData_3; minPHData = min_ph_ValueData_3; maxPHData = max_ph_ValueData_3;
    }
    else if(selectedDeviceId == "negy") {
        chart_temperature.data = {datasets: [{ label: "Hőmérséklet",          data: temperatureData_Thermocouple_device4,  fill: false, borderColor: colorOfTemperature,pointBackgroundColor: colorOfTemperature, pointBorderColor: colorOfTemperature, pointHoverBackgroundColor: colorOfTemperature, pointHoverBorderColor: colorOfTemperature,},]};
        chart_ph.data = {datasets: [{ label: "PH",   data: PHValueData_device4,         fill: false, borderColor: colorOfPH,pointBackgroundColor: colorOfPH, pointBorderColor: colorOfPH, pointHoverBackgroundColor: colorOfPH, pointHoverBorderColor: colorOfPH,},]};
        chart_a_f.data = {datasets: [
                { label: "A", data: spect_A_device4, fill: false,},
                { label: "B", data: spect_B_device4, fill: false,},
                { label: "C", data: spect_C_device4, fill: false,},
                { label: "D", data: spect_D_device4, fill: false,},
                { label: "E", data: spect_E_device4, fill: false,},
                { label: "F", data: spect_F_device4, fill: false,},
            ]};
        chart_g_l.data = {datasets: [
                { label: "G", data: spect_G_device4, fill: false,},
                { label: "H", data: spect_H_device4, fill: false,},
                { label: "I", data: spect_I_device4, fill: false,},
                { label: "J", data: spect_J_device4, fill: false,},
                { label: "K", data: spect_K_device4, fill: false,},
                { label: "L", data: spect_L_device4, fill: false,},
            ]};
        chart_r_w.data = {datasets: [
                { label: "R", data: spect_R_device4, fill: false,},
                { label: "S", data: spect_S_device4, fill: false,},
                { label: "T", data: spect_T_device4, fill: false,},
                { label: "U", data: spect_U_device4, fill: false,},
                { label: "V", data: spect_V_device4, fill: false,},
                { label: "W", data: spect_W_device4, fill: false,},
            ]};

        avgTemperatureData = sum_temperatureThermocoupleData_4 / cnt_temperatureThermocoupleData_4; minTemperatureData = min_temperatureThermocoupleData_4; maxTemperatureData = max_temperatureThermocoupleData_4;
        avgPHData = sum_ph_ValueData_4 / cnt_ph_ValueData_4; minPHData = min_ph_ValueData_4; maxPHData = max_ph_ValueData_4;
    }
     */

    try{
        if(displayMinMaxAvg) {
            chart_temperature.annotation.elements['avg'].options.value = avgTemperatureData;
            chart_temperature.annotation.elements['avg'].options.label.content = "Átl.: "+avgTemperatureData.toFixed(2);
            chart_temperature.annotation.elements['min'].options.value = minTemperatureData;
            chart_temperature.annotation.elements['min'].options.label.content = "Min.: "+minTemperatureData.toFixed(2);
            chart_temperature.annotation.elements['max'].options.value = maxTemperatureData;
            chart_temperature.annotation.elements['max'].options.label.content = "Max.: "+maxTemperatureData.toFixed(2);

            chart_ph.annotation.elements['avg'].options.value = avgPHData;
            chart_ph.annotation.elements['avg'].options.label.content = "Átl.: "+avgPHData.toFixed(2);
            chart_ph.annotation.elements['min'].options.value = minPHData;
            chart_ph.annotation.elements['min'].options.label.content = "Min.: "+minPHData.toFixed(2);
            chart_ph.annotation.elements['max'].options.value = maxPHData;
            chart_ph.annotation.elements['max'].options.label.content = "Max.: "+maxPHData.toFixed(2);
        }


        chart_temperature.update({preservation: true});
        chart_ph.update({preservation: true});
        chart_a_f.update({preservation: true});
        chart_g_l.update({preservation: true});
        chart_r_w.update({preservation: true});
    } catch (e) {console.log(e);}

}


//endregion

//region Display data
function displayData(deviceToDisplay) {
    selectedDeviceId = deviceToDisplay;$("#deviceIdLabel").text(deviceToDisplay);showData(selectedDeviceId);needToRefreshSzurkaloTimeline = true;
}

function showData(deviceToDisplay) {

    if(deviceToDisplay != selectedDeviceId) {
        selectedDeviceId = deviceToDisplay;
        dataSet_rfid = [];
        let device = getDeviceById(deviceToDisplay);
        let icon_className = 'fab fa-bluetooth ';
        if(device.connectionStatus == "CONNECTED") icon_className += 'goodColor';
        else icon_className += 'badColor';
        let iconItem = "<i class='"+icon_className+"'></i>"
        $("#deviceIdLabel").html(iconItem + " " + device.deviceName);
    }

    refreshSzurkalogepTartalom(measurements_device1);

    /*
    switch(selectedDeviceId) {
        case "egy":     refreshSzurkalogepTartalom(measurements_device1); break;
        case "ketto":   refreshSzurkalogepTartalom(measurements_device2); break;
        case "harom":   refreshSzurkalogepTartalom(measurements_device3); break;
        case "negy":    refreshSzurkalogepTartalom(measurements_device4); break;
        default:        console.log("Unknown deviceId"); break;
    }
     */

    processData(selectedDeviceId);
}

function refreshSzurkalogepTartalom(measurements) {
    if(needToRefreshSzurkaloTimeline) {
        let newContent = "";

        let timeStampMax = Date.now(), timeStampMin = timeStampMax-dataDurationInMilliseconds;

        measurements.forEach((measurement) => {
            if(measurement.timeStamp >= timeStampMin && measurement.timeStamp <= timeStampMax) {

                /*
                let rfid = "";
                if(measurement.hasOwnProperty("rfid")) rfid = measurement.rfid;

                newContent += "<li class='timeline-item bg-white rounded ml-3 p-4 shadow animate__animated animate__slideInDown'>";
                newContent +=   "<div class='timeline-arrow'></div>";
                newContent +=   "<h2 class='h5 mb-0'>Tálca azonosító: " + rfid +"</h2>";

                //newContent +=   "<span class='small text-gray'><i class='fa-solid fa-clock'></i>&nbsp;" + moment(measurement.timeStamp).format("YYYY.MM.DD. HH:mm:ss") + "</span>";
                newContent +=   "<p class='text-small mt-2 font-weight-light'><i class='fa-solid fa-clock'></i>&nbsp;" + moment(measurement.timeStamp).format("YYYY.MM.DD. HH:mm:ss") + "</p>";

                if(measurement.hasOwnProperty("ph_Value")) newContent +=   "<p class='text-small mt-2 font-weight-light'><i class='fa-solid fa-thermometer'></i> " + measurement.ph_Value.toFixed(2) + "</p>";
                if(measurement.hasOwnProperty("temperatureThermocouple")) newContent +=   "<p class='text-small mt-2 font-weight-light'><i class='fa-solid fa-temperature-half'></i> " + measurement.temperatureThermocouple.toFixed(2) + "</p>";

                newContent += "</li>";

                 */

                let rfid = "";
                if(measurement.hasOwnProperty("rfid")) rfid = measurement.rfid;

                let quality = "bad";
                if(measurement.hasOwnProperty("ph_Value") && measurement.hasOwnProperty("temperatureThermocouple") && measurement.ph_Value > 0.5 && measurement.temperatureThermocouple > 0.5) quality = "good";

                newContent += "<li class='timeline-item " + quality+ " bg-white rounded ml-3 p-4 shadow animate__animated animate__slideInDown'>";
                newContent +=   "<div class='timeline-arrow'></div>";
                newContent +=   "<h2 class='h5 mb-0'>Tálca azonosító: " + rfid +"</h2>";

                //newContent +=   "<span class='small text-gray'><i class='fa-solid fa-clock'></i>&nbsp;" + moment(measurement.timeStamp).format("YYYY.MM.DD. HH:mm:ss") + "</span>";
                newContent +=   "<p class='text-small mt-2 font-weight-light'><i class='fa-solid fa-clock'></i>&nbsp;" + moment(measurement.timeStamp).format("YYYY.MM.DD. HH:mm:ss") + "</p>";

                if(measurement.hasOwnProperty("ph_Value")) {
                    let phQuality = "badColor";
                    if(measurement.ph_Value > 0.5) phQuality = "goodColor";
                    newContent += "<p class='text-small mt-2 font-weight-light "+phQuality+"'><i class='fa-solid fa-thermometer'></i> " + measurement.ph_Value.toFixed(2) + "</p>";
                }
                if(measurement.hasOwnProperty("temperatureThermocouple")) {
                    let tempQuality = "badColor";
                    if(measurement.temperatureThermocouple > 0.5) tempQuality = "goodColor";
                    newContent += "<p class='text-small mt-2 font-weight-light "+tempQuality+" '><i class='fa-solid fa-temperature-half'></i> " + measurement.temperatureThermocouple.toFixed(2) + "</p>";
                }

                newContent += "</li>";
            }
        });

        $("#szurkalogepTimeline").html(newContent);
        resizePanel();

        needToRefreshSzurkaloTimeline = false;
    }
}

function refreshChartDuration(seconds) {

    dataDurationInMilliseconds = seconds*1000;

    $("#dataDuration_10s" ).removeClass('btn-outline-primary');
    $("#dataDuration_01m"   ).removeClass('btn-outline-primary');
    $("#dataDuration_05m"   ).removeClass('btn-outline-primary');
    $("#dataDuration_10m"  ).removeClass('btn-outline-primary');

    if(seconds == 10) {
        $("#dataDuration_10s").addClass('btn-primary');
        $("#dataDuration_01m").addClass('btn-outline-primary');
        $("#dataDuration_05m").addClass('btn-outline-primary');
        $("#dataDuration_10m").addClass('btn-outline-primary');

    } else if(seconds == 60) {
        $("#dataDuration_10s").addClass('btn-outline-primary');
        $("#dataDuration_01m").addClass('btn-primary');
        $("#dataDuration_05m").addClass('btn-outline-primary');
        $("#dataDuration_10m").addClass('btn-outline-primary');

    } else if(seconds == 5*60) {
        $("#dataDuration_10s").addClass('btn-outline-primary');
        $("#dataDuration_01m").addClass('btn-outline-primary');
        $("#dataDuration_05m").addClass('btn-primary');
        $("#dataDuration_10m").addClass('btn-outline-primary');
    } else if(seconds == 10*60) {
        $("#dataDuration_10s").addClass('btn-outline-primary');
        $("#dataDuration_01m").addClass('btn-outline-primary');
        $("#dataDuration_05m").addClass('btn-outline-primary');
        $("#dataDuration_10m").addClass('btn-primary');
    }

    chart_temperature.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_ph.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_a_f.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_g_l.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_r_w.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
}
//endregion

function resizePanel() {

    let navHeader = $("#navHeader")[0];
    let body = $(".main-body")[0];
    let docH = $(window).height() - navHeader.clientHeight - (body.offsetTop*2);

    $('#szurkalogepDataDisplayPanel').css({'height': (docH)+'px'});

}

function refreshEnumerationUsersOnSzurkalogepLive(caller) {
    if(caller == "devices") {
        rebuildDeviceList();
        if(selectedDeviceId == null) {
            devices.forEach(item=> {
                if(item.deviceType == layoutType) {
                    if(selectedDeviceId == null) showData(item.deviceId);
                }
            });
        }
    }
}