'use strict';
let dataSet_TableUpdateTimes = [];

jQuery(document).ready(function ($) {

    referenceIdForEvents = 0;

    enumerationRefreshCallbacks.push(refreshEnumerationsOnEventsPage);
    usersRefreshedCallbacks.push(refreshUsersOnEventsPage);

    resizePanel();
    $(window).bind('resize', function(){resizePanel();});

    refreshTableUpdateTimes();
    setInterval(function(){ refreshTableUpdateTimes(); }, 5000);
});

//region Download / Refresh data
function refreshTableUpdateTimes() {
    $.ajax({
        url: "../generalCommunication/tableupdatetimes",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {

            if(resp) {

                let tableUpdateTimes = resp.tableUpdateTimes;
                sessionRefreshedAt = resp.sessionRefreshedAt;

                for (let key in tableUpdateTimes) {
                    if (!(key in dataSet_TableUpdateTimes) || tableUpdateTimes[key] > dataSet_TableUpdateTimes[key]) {
                        dataSet_TableUpdateTimes[key] = tableUpdateTimes[key];
                        refreshItem(key);
                    }
                }
            } else {
                dataSet_TableUpdateTimes = [];
            }


        }
    });
}
function refreshItem(key) {
    switch(key) {
        case "kvp":     refreshKVPs();break;
        case "event":   refreshEvents();break;
        case "user":    refreshUsers();break;
        case "todo":            refreshToDosOfUser(username);break;
        case "notification":    refreshNotificationsOfUser(username); break;
        default:        refreshEnumerationData(key); break;
    }
}

//endregion
function resizePanel() {
    let navHeader = $("#navHeader")[0];
    let body = $(".main-body")[0];
    let docH = $(window).height() - navHeader.clientHeight - (body.offsetTop*2);

    $('#eventsPanel').css({'height': (docH)+'px'});

    $('#events').closest('.dataTables_scrollBody').css('max-height', docH - 220+'px');
    /*paging:         false, info: false,*/
    $('#events').DataTable().draw();
}

function refreshEnumerationsOnEventsPage(caller) {$('#events').DataTable().ajax.reload();}
function refreshUsersOnEventsPage() {$('#events').DataTable().ajax.reload();}