'use strict';

let dataSet_TableUpdateTimes = [],

    dataSet_DecaWaveData = [],

    mapWidth_px = 950, mapHeight_px = 500,
    mapWidth_m = 3.8, mapHeight_m = 2.0,

    dateFrom = 0, dateTo = 0,
    timeStampAtChartLoad = 0,

    xscale,  yscale,  map,
    imagelayer,  heatmap,  vectorfield,  pathplot,  overlays,
    mapdata = {},

    dataSet_AtmosphericData = [],

    dataSet_temperature = [],
    dataSet_humidity = [],
    dataSet_pressure = [],

    dataSet_spect_A = [],
    dataSet_spect_B = [],
    dataSet_spect_C = [],
    dataSet_spect_D = [],
    dataSet_spect_E = [],
    dataSet_spect_F = [],
    dataSet_spect_G = [],
    dataSet_spect_H = [],
    dataSet_spect_I = [],
    dataSet_spect_J = [],
    dataSet_spect_K = [],
    dataSet_spect_L = [],
    dataSet_spect_R = [],
    dataSet_spect_S = [],
    dataSet_spect_T = [],
    dataSet_spect_U = [],
    dataSet_spect_V = [],
    dataSet_spect_W = [],

    dataSet_ph_Value = [],
    dataSet_ph_Voltage = [],

    dataSet_button_Green = [],
    dataSet_button_Red = [],

    dataSet_hr_confidence = [],
    dataSet_hr_extStatus = [],
    dataSet_hr_heartRate = [],
    dataSet_hr_irLed = [],
    dataSet_hr_oxygen = [],
    dataSet_hr_redLed = [],
    dataSet_hr_rValue = [],
    dataSet_hr_status = [],

    dataSet_scale_AvgWeight = [],
    dataSet_scale_CalibrationDate = [],
    dataSet_scale_CalibrationFactor = [],
    dataSet_scale_Reading = [],
    dataSet_scale_Weight = [],
    dataSet_scale_ZeroOffset = [],

    dataSet_pwm = [],

    dataSet_voiceRecognition = [],

    chart_device1,
    chart_device2,
    chart_device3,
    chart_device4,

    selectedDataSource = "temperature",

    dataDurationInMilliseconds = 1*60*1000,

    timeToBakcAtStart = -10 // !! minute
;

$(document).ready(function() {

    //dateTo      = moment().endOf('day').valueOf();
    //dateFrom    = moment().endOf('day').subtract(1,'day').valueOf();

    //dateFrom = 1643203980000; //14:33
    dateFrom = 1643204040000; //14:34

    dateTo   = 1643204100000; //14:35
    //dateTo   = 1643204160000; //14:36

    $('#dateFrom').val(moment(dateFrom).format('YYYY-MM-DDTHH:mm'));
    $('#dateTo').val(  moment(dateTo)  .format('YYYY-MM-DDTHH:mm'));

    $('#refreshHistoricalData').on('click', function () {
        dateTo      = moment($('#dateTo').val()).valueOf();
        dateFrom    = moment($('#dateFrom').val()).valueOf();
        refreshItems();
    });

    $('#exportHistoricalData').on('click', function () {
        dateTo      = moment($('#dateTo').val()).valueOf();
        dateFrom    = moment($('#dateFrom').val()).valueOf();
        let win = window.open('/data/everythingBetweenTimeStamps?from='+dateFrom+'&to='+dateTo, '_blank');
        if (win) {win.focus();}
        else {alert('Please allow popups for this website');}
    });

    var colorSchemes = Chart.colorschemes;


    $('#btnSaveSettings').on('click', function () {saveSettings();});
    $('#modalSettings').on('shown.bs.modal', function (e) {$('#modalSettings_Pos_1_x').focus();});

    //region Charts
    chart_device1 = new Chart(document.getElementById("chart-line-1").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [{data: [], label: 'Dataset 1', type: 'line', fill: false,}, {data: [], label: 'Dataset 2', type: 'line', fill: false,}]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: true, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            scales: {
                xAxes: [{
                    type: 'time',
                    time: {
                        isoWeekday: true,
                        tooltipFormat: 'YYYY.MM.DD. HH:mm:ss',
                        displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}
                        },
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},

        }
    });
    chart_device2 = new Chart(document.getElementById("chart-line-2").getContext('2d'), {
            type: 'line',
            responsive: true,
            data: {datasets: [
                    {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                    {data: [], label: 'Dataset 2', type: 'line', fill: false,}
                ]},
            options: {
                barValueSpacing: 20,
                maintainAspectRatio: false,
                tooltips: {mode: 'nearest', intersect: false},
                hover: {mode: 'nearest', intersect: false},
                pan: {enabled: true, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
                zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
                scales: {
                    xAxes: [{
                        type: 'time',
                        time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    }]
                },
                plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
            }
        });
    chart_device3 = new Chart(document.getElementById("chart-line-3").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [
                {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                {data: [], label: 'Dataset 2', type: 'line', fill: false,}
            ]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: true, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'time',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
        }
    });
    chart_device4 = new Chart(document.getElementById("chart-line-4").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {datasets: [
                {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                {data: [], label: 'Dataset 2', type: 'line', fill: false,}
            ]},
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: true, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'time',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
        }
    });

    timeStampAtChartLoad = moment().valueOf();

    //endregion Charts

    //region Map
    xscale = d3.scale.linear().domain([0,mapWidth_m]).range([0,mapWidth_px]);
    yscale = d3.scale.linear().domain([0,mapHeight_m]).range([0,mapHeight_px]);

    map = d3.floorplan().xScale(xscale).yScale(yscale).panZoom(false);

    //map.drawText(g, 'a');

    imagelayer = d3.floorplan.imagelayer();                 // map
    heatmap = d3.floorplan.heatmap();                       // ?
    vectorfield = d3.floorplan.vectorfield();               //
    pathplot = d3.floorplan.pathplot();                     // tag útvonal
    overlays = d3.floorplan.overlays().editMode(true);

    mapdata[imagelayer.id()] = [{url: '../images/home.jpg', x: 0, y: 0, height: mapHeight_m, width: mapWidth_m}];

    map.addLayer(imagelayer)
        .addLayer(heatmap)
        .addLayer(vectorfield)
        .addLayer(pathplot)
        .addLayer(overlays);

    d3.select("#myMap").append("svg").attr("height", mapHeight_px).attr("width",mapWidth_px).attr("id","mapSVG").datum(mapdata).call(map);
    //endregion Map

    resizePanel();
    $(window).bind('resize', function(){resizePanel();});
});

function saveSettings() {
    $.ajax({
        url: '../data/kvps',
        method: 'PUT',
        data: {
            "pos_1_x": $('#modalSettings_Pos_1_x').val(),
            "pos_1_y": $('#modalSettings_Pos_1_y').val(),
            "pos_1_z": $('#modalSettings_Pos_1_z').val(),

            "pos_2_x": $('#modalSettings_Pos_2_x').val(),
            "pos_2_y": $('#modalSettings_Pos_2_y').val(),
            "pos_2_z": $('#modalSettings_Pos_2_z').val(),

            "pos_3_x": $('#modalSettings_Pos_3_x').val(),
            "pos_3_y": $('#modalSettings_Pos_3_y').val(),
            "pos_3_z": $('#modalSettings_Pos_3_z').val(),

            "pos_4_x": $('#modalSettings_Pos_4_x').val(),
            "pos_4_y": $('#modalSettings_Pos_4_y').val(),
            "pos_4_z": $('#modalSettings_Pos_4_z').val(),

            "mapWidth_m": $('#mapWidth_m').val(),
            "mapHeight_m": $('#mapHeight_m').val(),
            "mapWidth_px": $('#mapWidth_px').val(),
            "mapHeight_px": $('#mapHeight_px').val(),
            "map_path": $('#map_path').val(),
        },
        success: function () {
            $.toaster({heading: 'Siker!', text: "A beállítások mentése sikeres", icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: 10000, position: 'top-right'});
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A beállítások mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }
    });
}

function refreshSettingsModal() {
    $('#modalSettings_Pos_1_x').val(0);
    $('#modalSettings_Pos_1_y').val(0);
    $('#modalSettings_Pos_1_z').val(0);
    $('#modalSettings_Pos_2_x').val(0);
    $('#modalSettings_Pos_2_y').val(0);
    $('#modalSettings_Pos_2_z').val(0);
    $('#modalSettings_Pos_3_x').val(0);
    $('#modalSettings_Pos_3_y').val(0);
    $('#modalSettings_Pos_3_z').val(0);
    $('#modalSettings_Pos_4_x').val(0);
    $('#modalSettings_Pos_4_y').val(0);
    $('#modalSettings_Pos_4_z').val(0);

    $('#modalSettings_Pos_1_x').val(dataSet_KVPs["pos_1_x"]);
    $('#modalSettings_Pos_1_y').val(dataSet_KVPs["pos_1_y"]);
    $('#modalSettings_Pos_1_z').val(dataSet_KVPs["pos_1_z"]);
    $('#modalSettings_Pos_2_x').val(dataSet_KVPs["pos_2_x"]);
    $('#modalSettings_Pos_2_y').val(dataSet_KVPs["pos_2_y"]);
    $('#modalSettings_Pos_2_z').val(dataSet_KVPs["pos_2_z"]);
    $('#modalSettings_Pos_3_x').val(dataSet_KVPs["pos_3_x"]);
    $('#modalSettings_Pos_3_y').val(dataSet_KVPs["pos_3_y"]);
    $('#modalSettings_Pos_3_z').val(dataSet_KVPs["pos_3_z"]);
    $('#modalSettings_Pos_4_x').val(dataSet_KVPs["pos_4_x"]);
    $('#modalSettings_Pos_4_y').val(dataSet_KVPs["pos_4_y"]);
    $('#modalSettings_Pos_4_z').val(dataSet_KVPs["pos_4_z"]);


    $('#mapWidth_m').val(dataSet_KVPs["mapWidth_m"]);
    $('#mapHeight_m').val(dataSet_KVPs["mapHeight_m"]);

    $('#mapWidth_px').val(dataSet_KVPs["mapWidth_px"]);
    $('#mapHeight_px').val(dataSet_KVPs["mapHeight_px"]);

    $('#map_path').val(dataSet_KVPs["map_path"]);
}

function showData(dataToDisplay) {

    selectedDataSource = dataToDisplay;

    $('#breadcrumb-item-temp').css('color', '#3f4d67');
    $('#breadcrumb-item-scale').css('color', '#3f4d67');
    $('#breadcrumb-item-light').css('color', '#3f4d67');
    $('#breadcrumb-item-ph').css('color', '#3f4d67');
    $('#breadcrumb-item-btn').css('color', '#3f4d67');

    switch (selectedDataSource) {
        case "temperature": processAtmosphericData();   $('#breadcrumb-item-temp').css('color',  '#04a9f5');  $('#header_text').text('Hőmérséklet');    break;
        case "scale":       processScaleData();         $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('Súly');           break;
        case "light":       processLightData();         $('#breadcrumb-item-light').css('color', '#04a9f5');  $('#header_text').text('Fény');  break;
        case "ph":          processPHData();            $('#breadcrumb-item-ph').css('color', '#04a9f5');     $('#header_text').text('PH érték');break;
        case "button":      processButtonData();        $('#breadcrumb-item-btn').css('color', '#04a9f5');    $('#header_text').text('Gombnyomás'); break;
        case "heartRate":   processHeartRateData();     $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('Pulzus');   break;
        case "pwm":         processPWMData();           $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('PWM');   break;
        case "voice":       processVoiceData();         $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('Hang');   break;
    }
}

//region Download / Refresh data
function ageData() {
    let youngEnough = false;
    while (!youngEnough && dataSet_DecaWaveData.length > 0) {
        if ( (Date.now() - dataSet_DecaWaveData[0].timeStamp) < dataDurationInMilliseconds  )
            youngEnough = true;
        dataSet_DecaWaveData.shift();
    }
}

function refreshItems() {

    refreshKVPs();
    refreshDecaWaveData();

    refreshData_temperature();
    refreshData_humidity();

    //refreshData_pressure();
    refreshData_spect_A();
    refreshData_spect_B();
    refreshData_spect_C();
    refreshData_spect_D();
    refreshData_spect_E();
    refreshData_spect_F();
    refreshData_spect_G();
    refreshData_spect_H();
    refreshData_spect_I();
    refreshData_spect_J();
    refreshData_spect_K();
    refreshData_spect_L();
    refreshData_spect_R();
    refreshData_spect_S();
    refreshData_spect_T();
    refreshData_spect_U();
    refreshData_spect_V();
    refreshData_spect_W();
    refreshData_ph_Value();
    refreshData_ph_Voltage();
    refreshData_button_Green();
    refreshData_button_Red();
    refreshData_hr_confidence();
    refreshData_hr_extStatus();
    refreshData_hr_heartRate();
    refreshData_hr_irLed();
    refreshData_hr_oxygen();
    refreshData_hr_redLed();
    refreshData_hr_rValue();
    refreshData_hr_status();
    refreshData_scale_AvgWeight();
    refreshData_scale_Weight();
    refreshData_scale_CalibrationDate();
    refreshData_scale_CalibrationFactor();
    refreshData_scale_Reading();
    refreshData_scale_ZeroOffset();
    refreshData_pwm();
    refreshData_voiceRecognition();

    //refreshEnumeration();

}

function refreshDecaWaveData() {
    $.ajax({
        url: "../data/decaWaveTagPositionsBetweenTimeStamps",
        data: { from: dateFrom, to: dateTo },
        method: 'GET',
        dataType: 'json',
        success: function(resp) {
            if(resp) { dataSet_DecaWaveData = resp;}

            let mc_tag0 = {timeStamp:0,x:0, y:0, z:0}, mr_tag0 = {timeStamp:0,x:0, y:0, z:0},
                mc_tag1 = {timeStamp:0,x:0, y:0, z:0}, mr_tag1 = {timeStamp:0,x:0, y:0, z:0},
                mc_tag2 = {timeStamp:0,x:0, y:0, z:0}, mr_tag2 = {timeStamp:0,x:0, y:0, z:0},
                mc_tag3 = {timeStamp:0,x:0, y:0, z:0}, mr_tag3 = {timeStamp:0,x:0, y:0, z:0}
            ;

            let points_mc_tag0 = [], points_mc_tag1 = [], points_mc_tag2 = [], points_mc_tag3 = [],
                points_mr_tag0 = [], points_mr_tag1 = [], points_mr_tag2 = [], points_mr_tag3 = []
            ;

            dataSet_DecaWaveData.forEach((data) => {
                let pos = JSON.parse(data.pos);

                pos.x = parseFloat(pos.x);
                pos.y = parseFloat(pos.y);
                pos.z = parseFloat(pos.z);

                if(data.msgType == "b'mc'") {
                    if(pos.x < 100 && pos.x > -100 && pos.y<100 && pos.x > -100) {
                        switch (data.tag) {
                            case "0" :
                                if(data.timeStamp > mc_tag0.timeStamp) mc_tag0 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag0.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "1" :
                                if(data.timeStamp > mc_tag1.timeStamp) mc_tag1 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag1.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "2" :
                                if(data.timeStamp > mc_tag2.timeStamp) mc_tag2 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag2.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "3" :
                                if(data.timeStamp > mc_tag3.timeStamp) mc_tag3 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag3.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            default  : console.log("Unknown deviceId"); break;
                        }
                    }
                } else if(data.msgType == "b'mr'") {

                    if(pos.x < 100 && pos.x > -100 && pos.y<100 && pos.x > -100) {
                        switch (data.tag) {
                            case "0" :
                                if( data.timeStamp > mr_tag0.timeStamp) mr_tag0 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag0.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "1" :
                                if( data.timeStamp > mr_tag1.timeStamp) mr_tag1 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag1.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "2" :
                                if( data.timeStamp > mr_tag2.timeStamp) mr_tag2 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag2.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "3" :
                                if( data.timeStamp > mr_tag3.timeStamp) mr_tag3 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag3.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            default  :
                                console.log("Unknown deviceId");
                                break;
                        }
                    }
                }
            });

            let tempPathPlot = [
                {"id": "flt-1", "classes": "device_1_mc", "points": points_mc_tag0,},
                {"id": "flt-3", "classes": "device_2_mc", "points": points_mc_tag1,},
                {"id": "flt-5", "classes": "device_3_mc", "points": points_mc_tag2,},
                {"id": "flt-7", "classes": "device_4_mc", "points": points_mc_tag3,},

                
                {"id": "flt-2", "classes": "device_1_mr", "points": points_mr_tag0,},
                {"id": "flt-4", "classes": "device_2_mr", "points": points_mr_tag1,},
                {"id": "flt-6", "classes": "device_3_mr", "points": points_mr_tag2,},
                {"id": "flt-8", "classes": "device_4_mr", "points": points_mr_tag3,},
            ];

            mapdata[pathplot.id()] = tempPathPlot;

            let polygons = [

                {"id": "mc_tag0", "class": "device_1_vertex",  "points": [ {"x":mc_tag0.x,"y":mc_tag0.y}]},
                {"id": "mc_tag1", "class": "device_2_vertex",  "points": [ {"x":mc_tag1.x,"y":mc_tag1.y}]},
                {"id": "mc_tag2", "class": "device_3_vertex",  "points": [ {"x":mc_tag2.x,"y":mc_tag2.y}]},
                {"id": "mc_tag3", "class": "device_4_vertex",  "points": [ {"x":mc_tag3.x,"y":mc_tag3.y}]},

                {"id": "anchor_0", "class": "anchor_1_vertex", "points": [ {"x":dataSet_KVPs.pos_1_x,"y":dataSet_KVPs.pos_1_y}]},
                {"id": "anchor_1", "class": "anchor_2_vertex", "points": [ {"x":dataSet_KVPs.pos_2_x,"y":dataSet_KVPs.pos_2_y}]},
                {"id": "anchor_2", "class": "anchor_3_vertex", "points": [ {"x":dataSet_KVPs.pos_3_x,"y":dataSet_KVPs.pos_3_y}]},
                {"id": "anchor_3", "class": "anchor_4_vertex", "points": [ {"x":dataSet_KVPs.pos_4_x,"y":dataSet_KVPs.pos_4_y}]},

                /*
                {"id": "mr_tag0", "name": "mr_tag0", "points": [ {"x":mr_tag0.x,"y":mr_tag0.y}]},
                {"id": "mr_tag1", "name": "mr_tag1", "points": [ {"x":mr_tag1.x,"y":mr_tag1.y}]},
                {"id": "mr_tag2", "name": "mr_tag2", "points": [ {"x":mr_tag2.x,"y":mr_tag2.y}]},
                {"id": "mr_tag3", "name": "mr_tag3", "points": [ {"x":mr_tag3.x,"y":mr_tag3.y}]},
                 */

            ];
            mapdata[overlays.id()] = {"polygons" : polygons};

            console.log("MC - " + "x: " + mc_tag0.x + ", y: " + mc_tag0.y +", z: " + mc_tag0.z);

            d3.select("#myMap").datum(mapdata).call(map);
        }
    });
}

//region AtmosphericData
let earliestTimeStamp = Number.MAX_SAFE_INTEGER,
    latestTimeStamp = Number.MIN_SAFE_INTEGER;

function processAtmosphericData() {

    let temperatureData_device1 = [],
        temperatureData_device2 = [],
        temperatureData_device3 = [],
        temperatureData_device4 = [],

        /*
        pressureData_device1    = [],
        pressureData_device2    = [],
        pressureData_device3    = [],
        pressureData_device4    = [],
        */

        humidityData_device1 = [],
        humidityData_device2 = [],
        humidityData_device3 = [],
        humidityData_device4 = []
        ;

    dataSet_temperature.forEach((tempData) => {
        if(tempData.timeStamp < earliestTimeStamp) earliestTimeStamp = tempData.timeStamp;
        if(tempData.timeStamp > latestTimeStamp) latestTimeStamp = tempData.timeStamp;

        switch(tempData.deviceId) {
            case "egy":     temperatureData_device1.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            case "ketto":   temperatureData_device2.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            case "harom":   temperatureData_device3.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            case "negy":    temperatureData_device4.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_humidity.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     humidityData_device1.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            case "ketto":   humidityData_device2.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            case "harom":   humidityData_device3.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            case "negy":    humidityData_device4.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    /*
    dataSet_pressure.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     pressureData_device1.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            case "ketto":   pressureData_device2.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            case "harom":   pressureData_device3.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            case "negy":    pressureData_device4.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

     */

    if(selectedDataSource == "temperature") {
        chart_device1.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device1,  fill: false},
                { label: "Páratartalom",data: humidityData_device1,     fill: false},
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device2,  fill: false},
                { label: "Páratartalom",data: humidityData_device2,     fill: false},
                //{ label: "Nyomás",      data: pressureData_device2,     fill: false},
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device3,  fill: false},
                { label: "Páratartalom",data: humidityData_device3,     fill: false},
                //{ label: "Nyomás",      data: pressureData_device3,     fill: false},
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device4,  fill: false},
                { label: "Páratartalom",data: humidityData_device4,     fill: false},
                //{ label: "Nyomás",      data: pressureData_device4,     fill: false},
            ]
        };
    }


    try{

        /*
        chart_device1.options.pan.rangeMin.x = timeStampAtChartLoad - latestTimeStamp;
        chart_device2.options.pan.rangeMin.x = timeStampAtChartLoad - latestTimeStamp;
        chart_device3.options.pan.rangeMin.x = timeStampAtChartLoad - latestTimeStamp;
        chart_device4.options.pan.rangeMin.x = timeStampAtChartLoad - latestTimeStamp;

        chart_device1.options.pan.rangeMax.x = timeStampAtChartLoad - earliestTimeStamp;
        chart_device2.options.pan.rangeMax.x = timeStampAtChartLoad - earliestTimeStamp;
        chart_device3.options.pan.rangeMax.x = timeStampAtChartLoad - earliestTimeStamp;
        chart_device4.options.pan.rangeMax.x = timeStampAtChartLoad - earliestTimeStamp;
*/


        chart_device1.update({duration: 0});
        chart_device2.update({duration: 0});
        chart_device3.update({duration: 0});
        chart_device4.update({duration: 0});

    } catch (e) {
        console.log(e);
    }





}

function refreshAtmosphericData() {
    $.ajax({url: "../data/atmosphericDataBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_AtmosphericData = dataSet_AtmosphericData.concat(resp);}}});
}
function refreshData_temperature() {
    $.ajax({url: "../data/temperatureBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) {dataSet_temperature = resp;showData(selectedDataSource);}}});
}
function refreshData_humidity() {
    $.ajax({url: "../data/humidityBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_humidity = resp;showData(selectedDataSource);}}});
}
function refreshData_pressure() {
    $.ajax({url: "../data/pressureBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_pressure = dataSet_pressure.concat(resp);showData(selectedDataSource);}}});
}
//endregion

//region LightData
function processLightData() {
    
    let spect_A_device1 = [], spect_A_device2 = [], spect_A_device3 = [], spect_A_device4 = [],
        spect_B_device1 = [], spect_B_device2 = [], spect_B_device3 = [], spect_B_device4 = [],
        spect_C_device1 = [], spect_C_device2 = [], spect_C_device3 = [], spect_C_device4 = [],
        spect_D_device1 = [], spect_D_device2 = [], spect_D_device3 = [], spect_D_device4 = [],
        spect_E_device1 = [], spect_E_device2 = [], spect_E_device3 = [], spect_E_device4 = [],
        spect_F_device1 = [], spect_F_device2 = [], spect_F_device3 = [], spect_F_device4 = [],
        spect_G_device1 = [], spect_G_device2 = [], spect_G_device3 = [], spect_G_device4 = [],
        spect_H_device1 = [], spect_H_device2 = [], spect_H_device3 = [], spect_H_device4 = [],
        spect_I_device1 = [], spect_I_device2 = [], spect_I_device3 = [], spect_I_device4 = [],
        spect_J_device1 = [], spect_J_device2 = [], spect_J_device3 = [], spect_J_device4 = [],
        spect_K_device1 = [], spect_K_device2 = [], spect_K_device3 = [], spect_K_device4 = [],
        spect_L_device1 = [], spect_L_device2 = [], spect_L_device3 = [], spect_L_device4 = [],
        spect_R_device1 = [], spect_R_device2 = [], spect_R_device3 = [], spect_R_device4 = [],
        spect_S_device1 = [], spect_S_device2 = [], spect_S_device3 = [], spect_S_device4 = [],
        spect_T_device1 = [], spect_T_device2 = [], spect_T_device3 = [], spect_T_device4 = [],
        spect_U_device1 = [], spect_U_device2 = [], spect_U_device3 = [], spect_U_device4 = [],
        spect_V_device1 = [], spect_V_device2 = [], spect_V_device3 = [], spect_V_device4 = [],
        spect_W_device1 = [], spect_W_device2 = [], spect_W_device3 = [], spect_W_device4 = []
    ;

    dataSet_spect_A.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_A_device1.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "ketto":   spect_A_device2.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "harom":   spect_A_device3.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "negy":    spect_A_device4.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_B.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_B_device1.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "ketto":   spect_B_device2.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "harom":   spect_B_device3.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "negy":    spect_B_device4.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_C.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_C_device1.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "ketto":   spect_C_device2.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "harom":   spect_C_device3.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "negy":    spect_C_device4.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_D.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_D_device1.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "ketto":   spect_D_device2.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "harom":   spect_D_device3.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "negy":    spect_D_device4.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_E.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_E_device1.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "ketto":   spect_E_device2.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "harom":   spect_E_device3.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "negy":    spect_E_device4.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_F.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_F_device1.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "ketto":   spect_F_device2.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "harom":   spect_F_device3.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "negy":    spect_F_device4.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_G.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_G_device1.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "ketto":   spect_G_device2.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "harom":   spect_G_device3.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "negy":    spect_G_device4.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_H.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_H_device1.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "ketto":   spect_H_device2.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "harom":   spect_H_device3.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "negy":    spect_H_device4.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_I.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_I_device1.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "ketto":   spect_I_device2.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "harom":   spect_I_device3.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "negy":    spect_I_device4.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_J.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_J_device1.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "ketto":   spect_J_device2.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "harom":   spect_J_device3.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "negy":    spect_J_device4.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_K.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_K_device1.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "ketto":   spect_K_device2.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "harom":   spect_K_device3.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "negy":    spect_K_device4.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_L.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_L_device1.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "ketto":   spect_L_device2.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "harom":   spect_L_device3.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "negy":    spect_L_device4.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_R.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_R_device1.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "ketto":   spect_R_device2.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "harom":   spect_R_device3.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "negy":    spect_R_device4.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_S.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_S_device1.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "ketto":   spect_S_device2.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "harom":   spect_S_device3.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "negy":    spect_S_device4.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_T.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_T_device1.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "ketto":   spect_T_device2.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "harom":   spect_T_device3.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "negy":    spect_T_device4.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_U.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_U_device1.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "ketto":   spect_U_device2.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "harom":   spect_U_device3.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "negy":    spect_U_device4.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_V.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_V_device1.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "ketto":   spect_V_device2.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "harom":   spect_V_device3.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "negy":    spect_V_device4.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_W.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_W_device1.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "ketto":   spect_W_device2.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "harom":   spect_W_device3.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "negy":    spect_W_device4.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "light") {
        chart_device1.data = {
            datasets: [
                { label: "A", data: spect_A_device1,  fill: false},
                { label: "B", data: spect_B_device1,  fill: false},
                { label: "C", data: spect_C_device1,  fill: false},
                { label: "D", data: spect_D_device1,  fill: false},
                { label: "E", data: spect_E_device1,  fill: false},
                { label: "F", data: spect_F_device1,  fill: false},
                { label: "G", data: spect_G_device1,  fill: false},
                { label: "H", data: spect_H_device1,  fill: false},
                { label: "I", data: spect_I_device1,  fill: false},
                { label: "J", data: spect_J_device1,  fill: false},
                { label: "K", data: spect_K_device1,  fill: false},
                { label: "L", data: spect_L_device1,  fill: false},
                { label: "R", data: spect_R_device1,  fill: false},
                { label: "S", data: spect_S_device1,  fill: false},
                { label: "T", data: spect_T_device1,  fill: false},
                { label: "U", data: spect_U_device1,  fill: false},
                { label: "V", data: spect_V_device1,  fill: false},
                { label: "W", data: spect_W_device1,  fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "A", data: spect_A_device2,  fill: false},
                { label: "B", data: spect_B_device2,  fill: false},
                { label: "C", data: spect_C_device2,  fill: false},
                { label: "D", data: spect_D_device2,  fill: false},
                { label: "E", data: spect_E_device2,  fill: false},
                { label: "F", data: spect_F_device2,  fill: false},
                { label: "G", data: spect_G_device2,  fill: false},
                { label: "H", data: spect_H_device2,  fill: false},
                { label: "I", data: spect_I_device2,  fill: false},
                { label: "J", data: spect_J_device2,  fill: false},
                { label: "K", data: spect_K_device2,  fill: false},
                { label: "L", data: spect_L_device2,  fill: false},
                { label: "R", data: spect_R_device2,  fill: false},
                { label: "S", data: spect_S_device2,  fill: false},
                { label: "T", data: spect_T_device2,  fill: false},
                { label: "U", data: spect_U_device2,  fill: false},
                { label: "V", data: spect_V_device2,  fill: false},
                { label: "W", data: spect_W_device2,  fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "A", data: spect_A_device3,  fill: false},
                { label: "B", data: spect_B_device3,  fill: false},
                { label: "C", data: spect_C_device3,  fill: false},
                { label: "D", data: spect_D_device3,  fill: false},
                { label: "E", data: spect_E_device3,  fill: false},
                { label: "F", data: spect_F_device3,  fill: false},
                { label: "G", data: spect_G_device3,  fill: false},
                { label: "H", data: spect_H_device3,  fill: false},
                { label: "I", data: spect_I_device3,  fill: false},
                { label: "J", data: spect_J_device3,  fill: false},
                { label: "K", data: spect_K_device3,  fill: false},
                { label: "L", data: spect_L_device3,  fill: false},
                { label: "R", data: spect_R_device3,  fill: false},
                { label: "S", data: spect_S_device3,  fill: false},
                { label: "T", data: spect_T_device3,  fill: false},
                { label: "U", data: spect_U_device3,  fill: false},
                { label: "V", data: spect_V_device3,  fill: false},
                { label: "W", data: spect_W_device3,  fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "A", data: spect_A_device4,  fill: false},
                { label: "B", data: spect_B_device4,  fill: false},
                { label: "C", data: spect_C_device4,  fill: false},
                { label: "D", data: spect_D_device4,  fill: false},
                { label: "E", data: spect_E_device4,  fill: false},
                { label: "F", data: spect_F_device4,  fill: false},
                { label: "G", data: spect_G_device4,  fill: false},
                { label: "H", data: spect_H_device4,  fill: false},
                { label: "I", data: spect_I_device4,  fill: false},
                { label: "J", data: spect_J_device4,  fill: false},
                { label: "K", data: spect_K_device4,  fill: false},
                { label: "L", data: spect_L_device4,  fill: false},
                { label: "R", data: spect_R_device4,  fill: false},
                { label: "S", data: spect_S_device4,  fill: false},
                { label: "T", data: spect_T_device4,  fill: false},
                { label: "U", data: spect_U_device4,  fill: false},
                { label: "V", data: spect_V_device4,  fill: false},
                { label: "W", data: spect_W_device4,  fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}

function refreshData_spect_A() {
    $.ajax({url: "../data/spect_ABetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_A = resp;showData(selectedDataSource);}}});
}
function refreshData_spect_B() {
    $.ajax({url: "../data/spect_BBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_B = resp;showData(selectedDataSource);}}});
}
function refreshData_spect_C() {
    $.ajax({url: "../data/spect_CBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_C = resp;showData(selectedDataSource);}}});
}
function refreshData_spect_D() {
    $.ajax({url: "../data/spect_DBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_D = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_E() {
    $.ajax({url: "../data/spect_EBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_E = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_F() {
    $.ajax({url: "../data/spect_FBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_F = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_G() {
    $.ajax({url: "../data/spect_GBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_G = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_H() {
    $.ajax({url: "../data/spect_HBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_H = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_I() {
    $.ajax({url: "../data/spect_IBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_I = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_J() {
    $.ajax({url: "../data/spect_JBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_J = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_K() {
    $.ajax({url: "../data/spect_KBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_K = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_L() {
    $.ajax({url: "../data/spect_LBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_L = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_R() {
    $.ajax({url: "../data/spect_RBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_R = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_S() {
    $.ajax({url: "../data/spect_SBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_S = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_T() {
    $.ajax({url: "../data/spect_TBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_T = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_U() {
    $.ajax({url: "../data/spect_UBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_U = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_V() {
    $.ajax({url: "../data/spect_VBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_V = (resp);showData(selectedDataSource);}}});
}
function refreshData_spect_W() {
    $.ajax({url: "../data/spect_WBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_W = (resp);showData(selectedDataSource);}}});
}
//endregion

//region PHData
function processPHData() {

    let PHValueData_device1 = [],
        PHValueData_device2 = [],
        PHValueData_device3 = [],
        PHValueData_device4 = []

        /*
        PHVoltageData_device1 = [],
        PHVoltageData_device2 = [],
        PHVoltageData_device3 = [],
        PHVoltageData_device4 = []
         */
    ;

    dataSet_ph_Value.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     PHValueData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "ketto":   PHValueData_device2.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "harom":   PHValueData_device3.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "negy":    PHValueData_device4.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_ph_Voltage.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     PHVoltageData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            case "ketto":   PHVoltageData_device2.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            case "harom":   PHVoltageData_device3.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            case "negy":    PHVoltageData_device4.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "ph") {
        chart_device1.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device1,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device2,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device3,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device4,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device4,     fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_ph_Value() {
    $.ajax({url: "../data/ph_ValueBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_ph_Value = (resp);showData(selectedDataSource);}}});
}
function refreshData_ph_Voltage() {
    $.ajax({url: "../data/ph_VoltageBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_ph_Voltage = (resp);showData(selectedDataSource);}}});
}
//endregion

//region ButtonData
function processButtonData() {

    let greenButtonData_device1 = [],
        greenButtonData_device2 = [],
        greenButtonData_device3 = [],
        greenButtonData_device4 = [],
        redButtonData_device1 = [],
        redButtonData_device2 = [],
        redButtonData_device3 = [],
        redButtonData_device4 = []
    ;

    dataSet_button_Green.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     greenButtonData_device1.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            case "ketto":   greenButtonData_device2.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            case "harom":   greenButtonData_device3.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            case "negy":    greenButtonData_device4.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_button_Red.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     redButtonData_device1.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            case "ketto":   redButtonData_device2.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            case "harom":   redButtonData_device3.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            case "negy":    redButtonData_device4.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "button") {
        chart_device1.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device1,  fill: false},
                { label: "Piros",  data: redButtonData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device2,  fill: false},
                { label: "Piros",  data: redButtonData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device3,  fill: false},
                { label: "Piros",  data: redButtonData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device4,  fill: false},
                { label: "Piros",  data: redButtonData_device4,     fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_button_Green() {
    $.ajax({url: "../data/button_GreenBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_button_Green = (resp);showData(selectedDataSource);}}});
}
function refreshData_button_Red() {
    $.ajax({url: "../data/button_RedBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_button_Red = (resp);showData(selectedDataSource);}}});
}
//endregion

//region HeartRateData
function processHeartRateData() {

    let hr_confidenceData_device1 = [], hr_confidenceData_device2 = [], hr_confidenceData_device3 = [], hr_confidenceData_device4 = [],
        hr_extStatusData_device1 = [], hr_extStatusData_device2 = [], hr_extStatusData_device3 = [], hr_extStatusData_device4 = [],
        hr_statusData_device1 = [], hr_statusData_device2 = [], hr_statusData_device3 = [], hr_statusData_device4 = [],
        hr_heartRateData_device1 = [], hr_heartRateData_device2 = [], hr_heartRateData_device3 = [], hr_heartRateData_device4 = [],
        hr_irLedData_device1 = [], hr_irLedData_device2 = [], hr_irLedData_device3 = [], hr_irLedData_device4 = [],
        hr_redLedData_device1 = [], hr_redLedData_device2 = [], hr_redLedData_device3 = [], hr_redLedData_device4 = [],
        hr_oxygenData_device1 = [], hr_oxygenData_device2 = [], hr_oxygenData_device3 = [], hr_oxygenData_device4 = [],
        hr_rValueData_device1 = [], hr_rValueData_device2 = [], hr_rValueData_device3 = [], hr_rValueData_device4 = []
    ;

    dataSet_hr_confidence.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_confidenceData_device1.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            case "ketto":   hr_confidenceData_device2.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            case "harom":   hr_confidenceData_device3.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            case "negy":    hr_confidenceData_device4.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_status.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_statusData_device1.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            case "ketto":   hr_statusData_device2.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            case "harom":   hr_statusData_device3.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            case "negy":    hr_statusData_device4.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_extStatus.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_extStatusData_device1.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            case "ketto":   hr_extStatusData_device2.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            case "harom":   hr_extStatusData_device3.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            case "negy":    hr_extStatusData_device4.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_heartRate.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_heartRateData_device1.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            case "ketto":   hr_heartRateData_device2.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            case "harom":   hr_heartRateData_device3.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            case "negy":    hr_heartRateData_device4.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_redLed.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_redLedData_device1.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            case "ketto":   hr_redLedData_device2.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            case "harom":   hr_redLedData_device3.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            case "negy":    hr_redLedData_device4.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_irLed.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_irLedData_device1.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            case "ketto":   hr_irLedData_device2.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            case "harom":   hr_irLedData_device3.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            case "negy":    hr_irLedData_device4.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_oxygen.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_oxygenData_device1.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            case "ketto":   hr_oxygenData_device2.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            case "harom":   hr_oxygenData_device3.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            case "negy":    hr_oxygenData_device4.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_rValue.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_rValueData_device1.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            case "ketto":   hr_rValueData_device2.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            case "harom":   hr_rValueData_device3.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            case "negy":    hr_rValueData_device4.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "heartRate") {
        chart_device1.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device1,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device1,  fill: false},

                { label: "Konfidenca",  data: hr_confidenceData_device1,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device1,     fill: false},
                { label: "Státusz",     data: hr_statusData_device1,     fill: false},

                { label: "R érték",     data: hr_rValueData_device1,     fill: false},

                { label: "Infra LED",   data: hr_irLedData_device1,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device2,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device2,  fill: false},

                { label: "Konfidenca",  data: hr_confidenceData_device2,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device2,     fill: false},
                { label: "Státusz",     data: hr_statusData_device2,     fill: false},

                { label: "R érték",     data: hr_rValueData_device2,     fill: false},

                { label: "Infra LED",   data: hr_irLedData_device2,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device3,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device3,  fill: false},

                { label: "Konfidenca",  data: hr_confidenceData_device3,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device3,     fill: false},
                { label: "Státusz",     data: hr_statusData_device3,     fill: false},
                { label: "R érték",     data: hr_rValueData_device3,     fill: false},

                { label: "Infra LED+",  data: hr_irLedData_device3,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device4,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device4,  fill: false},
                { label: "Konfidenca",  data: hr_confidenceData_device4,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device4,     fill: false},
                { label: "Státusz",     data: hr_statusData_device4,     fill: false},

                { label: "R érték",     data: hr_rValueData_device4,     fill: false},

                { label: "Infra LED+",  data: hr_irLedData_device4,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device4,     fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_hr_confidence() {
    $.ajax({url: "../data/hr_confidenceBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_confidence = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_extStatus() {
    $.ajax({url: "../data/hr_extStatusBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_extStatus = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_heartRate() {
    $.ajax({url: "../data/hr_heartRateBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_heartRate = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_irLed() {
    $.ajax({url: "../data/hr_irLedBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_irLed = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_oxygen() {
    $.ajax({url: "../data/hr_oxygenBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_oxygen = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_redLed() {
    $.ajax({url: "../data/hr_redLedBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_redLed = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_rValue() {
    $.ajax({url: "../data/hr_rValueBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_rValue = (resp);showData(selectedDataSource);}}});
}
function refreshData_hr_status() {
    $.ajax({url: "../data/hr_statusBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_status = (resp);showData(selectedDataSource);}}});
}
//endregion

//region ScaleData
function processScaleData() {

    let scale_AvgWeightData_device1 = [], scale_AvgWeightData_device2 = [], scale_AvgWeightData_device3 = [], scale_AvgWeightData_device4 = [],
        scale_WeightData_device1 = [], scale_WeightData_device2 = [], scale_WeightData_device3 = [], scale_WeightData_device4 = [],
        scale_ReadingData_device1 = [], scale_ReadingData_device2 = [], scale_ReadingData_device3 = [], scale_ReadingData_device4 = [],
        scale_ZeroOffsetData_device1 = [], scale_ZeroOffsetData_device2 = [], scale_ZeroOffsetData_device3 = [], scale_ZeroOffsetData_device4 = [],
        scale_CalibrationFactorData_device1 = [], scale_CalibrationFactorData_device2 = [], scale_CalibrationFactorData_device3 = [], scale_CalibrationFactorData_device4 = []
    ;

    dataSet_scale_AvgWeight.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_AvgWeightData_device1.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            case "ketto":   scale_AvgWeightData_device2.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            case "harom":   scale_AvgWeightData_device3.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            case "negy":    scale_AvgWeightData_device4.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_Reading.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_ReadingData_device1.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            case "ketto":   scale_ReadingData_device2.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            case "harom":   scale_ReadingData_device3.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            case "negy":    scale_ReadingData_device4.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_Weight.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_WeightData_device1.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            case "ketto":   scale_WeightData_device2.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            case "harom":   scale_WeightData_device3.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            case "negy":    scale_WeightData_device4.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_ZeroOffset.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_ZeroOffsetData_device1.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            case "ketto":   scale_ZeroOffsetData_device2.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            case "harom":   scale_ZeroOffsetData_device3.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            case "negy":    scale_ZeroOffsetData_device4.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_CalibrationFactor.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_CalibrationFactorData_device1.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            case "ketto":   scale_CalibrationFactorData_device2.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            case "harom":   scale_CalibrationFactorData_device3.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            case "negy":    scale_CalibrationFactorData_device4.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "scale") {
        chart_device1.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device1,  fill: false},
                { label: "Súly",      data: scale_WeightData_device1,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device1,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device1,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device2,  fill: false},
                { label: "Súly",      data: scale_WeightData_device2,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device2,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device2,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device3,  fill: false},
                { label: "Súly",      data: scale_WeightData_device3,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device3,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device3,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device4,  fill: false},
                { label: "Súly",      data: scale_WeightData_device4,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device4,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device4,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device4,     fill: false},
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_scale_AvgWeight() {
    $.ajax({url: "../data/scale_AvgWeightBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_AvgWeight = (resp);showData(selectedDataSource);}}});
}
function refreshData_scale_CalibrationDate() {
    $.ajax({url: "../data/scale_CalibrationDateBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_CalibrationDate = (resp);showData(selectedDataSource);}}});
}
function refreshData_scale_CalibrationFactor() {
    $.ajax({url: "../data/scale_CalibrationFactorBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_CalibrationFactor = (resp);showData(selectedDataSource);}}});
}
function refreshData_scale_Reading() {
    $.ajax({url: "../data/scale_ReadingBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_Reading = (resp);showData(selectedDataSource);}}});
}
function refreshData_scale_Weight() {
    $.ajax({url: "../data/scale_WeightBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_Weight = (resp);showData(selectedDataSource);}}});
}
function refreshData_scale_ZeroOffset() {
    $.ajax({url: "../data/scale_ZeroOffsetBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_ZeroOffset = (resp);showData(selectedDataSource);}}});
}
//endregion

//region PWMData
function processPWMData() {

    let pwmData_device1 = [],
        pwmData_device2 = [],
        pwmData_device3 = [],
        pwmData_device4 = []
    ;

    dataSet_pwm.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     pwmData_device1.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            case "ketto":   pwmData_device2.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            case "harom":   pwmData_device3.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            case "negy":    pwmData_device4.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "pwm") {
        chart_device1.data = {datasets: [{ label: "PWM", data: pwmData_device1,  fill: false}]};
        chart_device2.data = {datasets: [{ label: "PWM", data: pwmData_device2,  fill: false}]};
        chart_device3.data = {datasets: [{ label: "PWM", data: pwmData_device3,  fill: false}]};
        chart_device4.data = {datasets: [{ label: "PWM", data: pwmData_device4,  fill: false}]};

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_pwm() {
    let timeStamp = dataSet_TableUpdateTimes["pwm"];
    if (dataSet_pwm.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/pwmBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_pwm = dataSet_pwm.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region VoiceData
function processVoiceData() {

    let voiceRecognitionData_device1 = [],
        voiceRecognitionData_device2 = [],
        voiceRecognitionData_device3 = [],
        voiceRecognitionData_device4 = []
    ;

    dataSet_voiceRecognition.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     voiceRecognitionData_device1.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            case "ketto":   voiceRecognitionData_device2.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            case "harom":   voiceRecognitionData_device3.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            case "negy":    voiceRecognitionData_device4.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "voice") {
        chart_device1.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device1,  fill: false}]};
        chart_device2.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device2,  fill: false}]};
        chart_device3.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device3,  fill: false}]};
        chart_device4.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device4,  fill: false}]};

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_voiceRecognition() {
    let timeStamp = dataSet_TableUpdateTimes["voiceRecognition"];
    if (dataSet_voiceRecognition.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/voiceRecognitionBetweenTimeStamps", data: { from: dateFrom, to: dateTo }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_voiceRecognition = dataSet_voiceRecognition.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//endregion


function resizePanel() {
    let mapContainer = $("#mapContainer")[0];
    let myMap = $("#myMap")[0];

    //$('#myMap').css('height', mapContainer.clientHeight+'px');
    $('#mapSVG').attr('width', mapContainer.clientWidth+'px');
    $('.map-layers').attr('width', mapContainer.clientWidth+'px');
}
