'use strict';

let dataSet_TableUpdateTimes = [],

    dataSet_DecaWaveData = [],

    mapWidth_px = 950, mapHeight_px = 500,
    mapWidth_m = 3.8, mapHeight_m = 2.0,

    xscale,  yscale,  map,
    imagelayer,  heatmap,  vectorfield,  pathplot,  overlays,
    mapdata = {},

    dataSet_AtmosphericData = [],

    dataSet_temperature = [],
    dataSet_humidity = [],
    dataSet_pressure = [],

    dataSet_spect_A = [],
    dataSet_spect_B = [],
    dataSet_spect_C = [],
    dataSet_spect_D = [],
    dataSet_spect_E = [],
    dataSet_spect_F = [],
    dataSet_spect_G = [],
    dataSet_spect_H = [],
    dataSet_spect_I = [],
    dataSet_spect_J = [],
    dataSet_spect_K = [],
    dataSet_spect_L = [],
    dataSet_spect_R = [],
    dataSet_spect_S = [],
    dataSet_spect_T = [],
    dataSet_spect_U = [],
    dataSet_spect_V = [],
    dataSet_spect_W = [],

    dataSet_ph_Value = [],
    dataSet_ph_Voltage = [],

    dataSet_button_Green = [],
    dataSet_button_Red = [],

    dataSet_hr_confidence = [],
    dataSet_hr_extStatus = [],
    dataSet_hr_heartRate = [],
    dataSet_hr_irLed = [],
    dataSet_hr_oxygen = [],
    dataSet_hr_redLed = [],
    dataSet_hr_rValue = [],
    dataSet_hr_status = [],

    dataSet_scale_AvgWeight = [],
    dataSet_scale_CalibrationDate = [],
    dataSet_scale_CalibrationFactor = [],
    dataSet_scale_Reading = [],
    dataSet_scale_Weight = [],
    dataSet_scale_ZeroOffset = [],

    dataSet_pwm = [],

    dataSet_voiceRecognition = [],

    chart_device1,
    chart_device2,
    chart_device3,
    chart_device4,

    selectedDataSource = "temperature",

    dataDurationInMilliseconds = 10*1000,

    timeToBakcAtStart = -10 // !! minute
;

$(document).ready(function() {
    var colorSchemes = Chart.colorschemes;

    $('#dataDuration_10s').on('click', function () {refreshChartDuration(10);});
    $('#dataDuration_01m').on('click', function () {refreshChartDuration(1*60);});
    $('#dataDuration_05m').on('click', function () {refreshChartDuration(5*60);});
    $('#dataDuration_10m').on('click', function () {refreshChartDuration(10*60);});



    $('#btnSaveSettings').on('click', function () {saveSettings();});
    $('#modalSettings').on('shown.bs.modal', function (e) {$('#modalSettings_Pos_1_x').focus();});

    //region Charts
    chart_device1 = new Chart(document.getElementById("chart-line-1").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {
            datasets: [
                {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                {data: [], label: 'Dataset 2', type: 'line', fill: false,}
                ]
        },
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, angeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {
                        isoWeekday: true,
                        tooltipFormat: 'YYYY.MM.DD. HH:mm:ss',
                        displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}
                        },
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {}
                    }
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},

        }
    });
    chart_device2 = new Chart(document.getElementById("chart-line-2").getContext('2d'),
        {
            type: 'line',
            responsive: true,
            data: {
                datasets: [
                    {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                    {data: [], label: 'Dataset 2', type: 'line', fill: false,}
                ]
            },
            options: {
                barValueSpacing: 20,
                maintainAspectRatio: false,
                tooltips: {mode: 'nearest', intersect: false},
                hover: {mode: 'nearest', intersect: false},
                pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
                zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
                scales: {
                    xAxes: [{
                        type: 'realtime',
                        time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                        realtime: {
                            delay: 2000,
                            duration: dataDurationInMilliseconds,
                            refresh: 1000,
                            onRefresh: function(chart) {

                               /* chart.data.datasets.forEach(function(dataset) {
                                    dataset.data.push({
                                        x: Date.now(),
                                        y: Math.random()
                                    });
                                });*/

                            }
                        }
                    }]
                },
                plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
            }
        });
    chart_device3 = new Chart(document.getElementById("chart-line-3").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {
            datasets: [
                {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                {data: [], label: 'Dataset 2', type: 'line', fill: false,}
            ]
        },
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {

                            /*chart.data.datasets.forEach(function(dataset) {
                                dataset.data.push({
                                    x: Date.now(),
                                    y: Math.random()
                                });
                            });*/

                        }
                    }
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
        }
    });
    chart_device4 = new Chart(document.getElementById("chart-line-4").getContext('2d'), {
        type: 'line',
        responsive: true,
        data: {
            datasets: [
                {data: [], label: 'Dataset 1', type: 'line', fill: false,},
                {data: [], label: 'Dataset 2', type: 'line', fill: false,}
            ]
        },
        options: {
            barValueSpacing: 20,
            maintainAspectRatio: false,
            tooltips: {mode: 'nearest', intersect: false},
            hover: {mode: 'nearest', intersect: false},
            pan: {enabled: false, mode: 'x', rangeMax: {x: 4000}, rangeMin: {x: 0}},
            zoom: {enabled: false, mode: 'x', rangeMax: {x: 20000}, rangeMin: {x: 1000}},
            scales: {
                xAxes: [{
                    type: 'realtime',
                    time: {isoWeekday: true, tooltipFormat: 'YYYY.MM.DD. HH:mm:ss.SSS', displayFormats: {'millisecond': 'HH:mm:ss', 'second': 'HH:mm:ss', 'minute': 'HH:mm:ss', 'hour': 'MM.DD. HH:mm:ss', 'day': 'MM.DD. HH:mm', 'week': 'MM.DD.', 'month': 'YYYY.MM.DD.', 'quarter': 'YYYY.MM.DD.', 'year': 'YYYY.',}},
                    realtime: {
                        delay: 2000,
                        duration: dataDurationInMilliseconds,
                        refresh: 1000,
                        onRefresh: function(chart) {

                            /*chart.data.datasets.forEach(function(dataset) {
                                dataset.data.push({
                                    x: Date.now(),
                                    y: Math.random()
                                });
                            });*/

                        }
                    }
                }]
            },
            plugins: {colorschemes: {scheme: 'tableau.Tableau20'}},
        }
    });
    //endregion Charts

    //region Map

    xscale = d3.scale.linear().domain([0,mapWidth_m]).range([0,mapWidth_px]);
    yscale = d3.scale.linear().domain([0,mapHeight_m]).range([0,mapHeight_px]);

    map = d3.floorplan().xScale(xscale).yScale(yscale).panZoom(false);


    //map.drawText(g, 'a');

    imagelayer = d3.floorplan.imagelayer();                 // map
    heatmap = d3.floorplan.heatmap();                       // ?
    vectorfield = d3.floorplan.vectorfield();               //
    pathplot = d3.floorplan.pathplot();                     // tag útvonal
    overlays = d3.floorplan.overlays().editMode(true);      // tag és horgony pozíciók

    mapdata[imagelayer.id()] = [{url: '../images/home.jpg', x: 0, y: 0, height: mapHeight_m, width: mapWidth_m}];

    map.addLayer(imagelayer)
        .addLayer(heatmap)
        .addLayer(vectorfield)
        .addLayer(pathplot)
        .addLayer(overlays);
    
    d3.select("#myMap")
        .append("svg")
        .attr("height", mapHeight_px)
        .attr("width",mapWidth_px)
        .attr("id","mapSVG")
        .datum(mapdata)
        .call(map);
        

    //endregion Map

    refreshTableUpdateTimes();

    setInterval(function(){ refreshTableUpdateTimes(); }, 1000);

    setInterval(function(){

        ageData();

        /*
        chart_device1.update({preservation: true});
        chart_device2.update({preservation: true});
        chart_device3.update({preservation: true});
        chart_device4.update({preservation: true});
         */


    }, 1000);

    showData(selectedDataSource);

    resizePanel();
    $(window).bind('resize', function(){resizePanel();});
});

function saveSettings() {
    $.ajax({
        url: '../data/kvps',
        method: 'PUT',
        data: {
            "pos_1_x": $('#modalSettings_Pos_1_x').val(),
            "pos_1_y": $('#modalSettings_Pos_1_y').val(),
            "pos_1_z": $('#modalSettings_Pos_1_z').val(),

            "pos_2_x": $('#modalSettings_Pos_2_x').val(),
            "pos_2_y": $('#modalSettings_Pos_2_y').val(),
            "pos_2_z": $('#modalSettings_Pos_2_z').val(),

            "pos_3_x": $('#modalSettings_Pos_3_x').val(),
            "pos_3_y": $('#modalSettings_Pos_3_y').val(),
            "pos_3_z": $('#modalSettings_Pos_3_z').val(),

            "pos_4_x": $('#modalSettings_Pos_4_x').val(),
            "pos_4_y": $('#modalSettings_Pos_4_y').val(),
            "pos_4_z": $('#modalSettings_Pos_4_z').val(),

            "mapWidth_m": $('#mapWidth_m').val(),
            "mapHeight_m": $('#mapHeight_m').val(),
            "mapWidth_px": $('#mapWidth_px').val(),
            "mapHeight_px": $('#mapHeight_px').val(),
            "map_path": $('#map_path').val(),
        },
        success: function () {
            $.toaster({heading: 'Siker!', text: "A beállítások mentése sikeres", icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: 10000, position: 'top-right'});
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A beállítások mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }
    });
}

function refreshChartDuration(seconds) {

    dataDurationInMilliseconds = seconds*1000;

    $("#dataDuration_10s" ).removeClass('btn-outline-primary');
    $("#dataDuration_01m"   ).removeClass('btn-outline-primary');
    $("#dataDuration_05m"   ).removeClass('btn-outline-primary');
    $("#dataDuration_10m"  ).removeClass('btn-outline-primary');

    if(seconds == 10) {
        $("#dataDuration_10s").addClass('btn-primary');
        $("#dataDuration_01m").addClass('btn-outline-primary');
        $("#dataDuration_05m").addClass('btn-outline-primary');
        $("#dataDuration_10m").addClass('btn-outline-primary');

    } else if(seconds == 60) {
        $("#dataDuration_10s").addClass('btn-outline-primary');
        $("#dataDuration_01m").addClass('btn-primary');
        $("#dataDuration_05m").addClass('btn-outline-primary');
        $("#dataDuration_10m").addClass('btn-outline-primary');

    } else if(seconds == 5*60) {
        $("#dataDuration_10s").addClass('btn-outline-primary');
        $("#dataDuration_01m").addClass('btn-outline-primary');
        $("#dataDuration_05m").addClass('btn-primary');
        $("#dataDuration_10m").addClass('btn-outline-primary');
    } else if(seconds == 10*60) {
        $("#dataDuration_10s").addClass('btn-outline-primary');
        $("#dataDuration_01m").addClass('btn-outline-primary');
        $("#dataDuration_05m").addClass('btn-outline-primary');
        $("#dataDuration_10m").addClass('btn-primary');
    }





    chart_device1.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_device2.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_device3.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
    chart_device4.options.scales.xAxes[0].realtime.duration = dataDurationInMilliseconds;
}

function refreshSettingsModal() {
    $('#modalSettings_Pos_1_x').val(0);
    $('#modalSettings_Pos_1_y').val(0);
    $('#modalSettings_Pos_1_z').val(0);
    $('#modalSettings_Pos_2_x').val(0);
    $('#modalSettings_Pos_2_y').val(0);
    $('#modalSettings_Pos_2_z').val(0);
    $('#modalSettings_Pos_3_x').val(0);
    $('#modalSettings_Pos_3_y').val(0);
    $('#modalSettings_Pos_3_z').val(0);
    $('#modalSettings_Pos_4_x').val(0);
    $('#modalSettings_Pos_4_y').val(0);
    $('#modalSettings_Pos_4_z').val(0);

    $('#modalSettings_Pos_1_x').val(dataSet_KVPs["pos_1_x"]);
    $('#modalSettings_Pos_1_y').val(dataSet_KVPs["pos_1_y"]);
    $('#modalSettings_Pos_1_z').val(dataSet_KVPs["pos_1_z"]);
    $('#modalSettings_Pos_2_x').val(dataSet_KVPs["pos_2_x"]);
    $('#modalSettings_Pos_2_y').val(dataSet_KVPs["pos_2_y"]);
    $('#modalSettings_Pos_2_z').val(dataSet_KVPs["pos_2_z"]);
    $('#modalSettings_Pos_3_x').val(dataSet_KVPs["pos_3_x"]);
    $('#modalSettings_Pos_3_y').val(dataSet_KVPs["pos_3_y"]);
    $('#modalSettings_Pos_3_z').val(dataSet_KVPs["pos_3_z"]);
    $('#modalSettings_Pos_4_x').val(dataSet_KVPs["pos_4_x"]);
    $('#modalSettings_Pos_4_y').val(dataSet_KVPs["pos_4_y"]);
    $('#modalSettings_Pos_4_z').val(dataSet_KVPs["pos_4_z"]);


    $('#mapWidth_m').val(dataSet_KVPs["mapWidth_m"]);
    $('#mapHeight_m').val(dataSet_KVPs["mapHeight_m"]);

    $('#mapWidth_px').val(dataSet_KVPs["mapWidth_px"]);
    $('#mapHeight_px').val(dataSet_KVPs["mapHeight_px"]);

    $('#map_path').val(dataSet_KVPs["map_path"]);
}

function showData(dataToDisplay) {

    selectedDataSource = dataToDisplay;

    $('#breadcrumb-item-temp').css('color', '#3f4d67');
    $('#breadcrumb-item-scale').css('color', '#3f4d67');
    $('#breadcrumb-item-light').css('color', '#3f4d67');
    $('#breadcrumb-item-ph').css('color', '#3f4d67');
    $('#breadcrumb-item-btn').css('color', '#3f4d67');

    switch (selectedDataSource) {
        case "temperature": processAtmosphericData();   $('#breadcrumb-item-temp').css('color',  '#04a9f5');  $('#header_text').text('Hőmérséklet');    break;
        case "scale":       processScaleData();         $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('Súly');           break;
        case "light":       processLightData();         $('#breadcrumb-item-light').css('color', '#04a9f5');  $('#header_text').text('Fény');  break;
        case "ph":          processPHData();            $('#breadcrumb-item-ph').css('color', '#04a9f5');     $('#header_text').text('PH érték');break;
        case "button":      processButtonData();        $('#breadcrumb-item-btn').css('color', '#04a9f5');    $('#header_text').text('Gombnyomás'); break;
        case "heartRate":   processHeartRateData();     $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('Pulzus');   break;
        case "pwm":         processPWMData();           $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('PWM');   break;
        case "voice":       processVoiceData();         $('#breadcrumb-item-scale').css('color', '#04a9f5');  $('#header_text').text('Hang');   break;
    }
}

//region Download / Refresh data
function ageData() {

    let youngEnough = false;
    while (!youngEnough && dataSet_DecaWaveData.length > 0) {
        if ( (Date.now() - dataSet_DecaWaveData[0].timeStamp) < dataDurationInMilliseconds  )
            youngEnough = true;
        dataSet_DecaWaveData.shift();
    }



}

function refreshTableUpdateTimes() {
    $.ajax({
        url: "../generalCommunication/tableupdatetimes",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {

            if(resp) {

                let tableUpdateTimes = resp.tableUpdateTimes;

                for (let key in tableUpdateTimes) {
                    if (!(key in dataSet_TableUpdateTimes) || tableUpdateTimes[key] > dataSet_TableUpdateTimes[key]) {
                        refreshItem(key);
                        dataSet_TableUpdateTimes[key] = tableUpdateTimes[key];
                    }
                }
            } else {
                dataSet_TableUpdateTimes = [];
            }
        }
    });
}

function refreshItem(key) {
    switch(key) {
        case "kvp":                 refreshKVPs(); break;
        case "decaWave":            refreshDecaWaveData(); break;

        case "atmosphericData":     if(selectedDataSource == "temperature") refreshAtmosphericData(); break;
        case "temperature":         if(selectedDataSource == "temperature") refreshData_temperature(); break;
        case "humidity":            if(selectedDataSource == "temperature") refreshData_humidity(); break;
        case "pressure":            if(selectedDataSource == "temperature") refreshData_pressure(); break;

        case "spect_A":            if(selectedDataSource == "light") refreshData_spect_A(); break;
        case "spect_B":            if(selectedDataSource == "light") refreshData_spect_B(); break;
        case "spect_C":            if(selectedDataSource == "light") refreshData_spect_C(); break;
        case "spect_D":            if(selectedDataSource == "light") refreshData_spect_D(); break;
        case "spect_E":            if(selectedDataSource == "light") refreshData_spect_E(); break;
        case "spect_F":            if(selectedDataSource == "light") refreshData_spect_F(); break;
        case "spect_G":            if(selectedDataSource == "light") refreshData_spect_G(); break;
        case "spect_H":            if(selectedDataSource == "light") refreshData_spect_H(); break;
        case "spect_I":            if(selectedDataSource == "light") refreshData_spect_I(); break;
        case "spect_J":            if(selectedDataSource == "light") refreshData_spect_J(); break;
        case "spect_K":            if(selectedDataSource == "light") refreshData_spect_K(); break;
        case "spect_L":            if(selectedDataSource == "light") refreshData_spect_L(); break;
        case "spect_R":            if(selectedDataSource == "light") refreshData_spect_R(); break;
        case "spect_S":            if(selectedDataSource == "light") refreshData_spect_S(); break;
        case "spect_T":            if(selectedDataSource == "light") refreshData_spect_T(); break;
        case "spect_U":            if(selectedDataSource == "light") refreshData_spect_U(); break;
        case "spect_V":            if(selectedDataSource == "light") refreshData_spect_V(); break;
        case "spect_W":            if(selectedDataSource == "light") refreshData_spect_W(); break;

        case "ph_Value":            if(selectedDataSource == "ph") refreshData_ph_Value(); break;
        case "ph_Voltage":          if(selectedDataSource == "ph") refreshData_ph_Voltage(); break;

        case "button_Green":        if(selectedDataSource == "button") refreshData_button_Green(); break;
        case "button_Red":          if(selectedDataSource == "button") refreshData_button_Red(); break;

        case "hr_confidence":       if(selectedDataSource == "heartRate") refreshData_hr_confidence(); break;
        case "hr_extStatus":        if(selectedDataSource == "heartRate") refreshData_hr_extStatus(); break;
        case "hr_heartRate":        if(selectedDataSource == "heartRate") refreshData_hr_heartRate(); break;
        case "hr_oxygen":           if(selectedDataSource == "heartRate") refreshData_hr_oxygen(); break;
        case "hr_irLed":            if(selectedDataSource == "heartRate") refreshData_hr_irLed(); break;

        case "hr_redLed":           if(selectedDataSource == "heartRate") refreshData_hr_redLed(); break;
        case "hr_rValue":           if(selectedDataSource == "heartRate") refreshData_hr_rValue(); break;
        case "hr_status":           if(selectedDataSource == "heartRate") refreshData_hr_status(); break;

        case "scale_AvgWeight":          if(selectedDataSource == "scale") refreshData_scale_AvgWeight(); break;
        case "scale_Weight":             if(selectedDataSource == "scale") refreshData_scale_Weight(); break;
        case "scale_CalibrationDate":    if(selectedDataSource == "scale") refreshData_scale_CalibrationDate(); break;
        case "scale_CalibrationFactor":  if(selectedDataSource == "scale") refreshData_scale_CalibrationFactor(); break;
        case "scale_Reading":            if(selectedDataSource == "scale") refreshData_scale_Reading(); break;
        case "scale_ZeroOffset":         if(selectedDataSource == "scale") refreshData_scale_ZeroOffset(); break;

        case "pwm":                      if(selectedDataSource == "pwm") refreshData_pwm(); break;

        case "voiceRecognition":         if(selectedDataSource == "voice") refreshData_voiceRecognition(); break;

        default:                    refreshEnumerationData(key); break;
    }
}

function refreshDecaWaveData() {

    let timeStamp = dataSet_TableUpdateTimes["decaWave"];
    if (dataSet_DecaWaveData.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;


    $.ajax({
        url: "../data/decaWaveTagPositionsAfterTimeStamp",
        //data: { timeStamp: 0 },
        data: { timeStamp: timeStamp },
        method: 'GET',
        dataType: 'json',
        success: function(resp) {


            if(resp) { dataSet_DecaWaveData = dataSet_DecaWaveData.concat(resp);}
            //else { dataSet_DecaWaveData = [];}



            let mc_tag0 = {timeStamp:0,x:0, y:0, z:0},  mr_tag0 = {timeStamp:0,x:0, y:0, z:0}, mc_tag0_kalman_f = {timeStamp:0,x:0, y:0, z:0}, mc_tag0_kalman_c = {timeStamp:0,x:0, y:0, z:0},
                mc_tag1 = {timeStamp:0,x:0, y:0, z:0},  mr_tag1 = {timeStamp:0,x:0, y:0, z:0}, mc_tag1_kalman_f = {timeStamp:0,x:0, y:0, z:0}, mc_tag1_kalman_c = {timeStamp:0,x:0, y:0, z:0},
                mc_tag2 = {timeStamp:0,x:0, y:0, z:0},  mr_tag2 = {timeStamp:0,x:0, y:0, z:0}, mc_tag2_kalman_f = {timeStamp:0,x:0, y:0, z:0}, mc_tag2_kalman_c = {timeStamp:0,x:0, y:0, z:0},
                mc_tag3 = {timeStamp:0,x:0, y:0, z:0},  mr_tag3 = {timeStamp:0,x:0, y:0, z:0}, mc_tag3_kalman_f = {timeStamp:0,x:0, y:0, z:0}, mc_tag3_kalman_c = {timeStamp:0,x:0, y:0, z:0}
            ;

            let points_mc_tag0 = [], points_mc_tag1 = [], points_mc_tag2 = [], points_mc_tag3 = [],
                points_mr_tag0 = [], points_mr_tag1 = [], points_mr_tag2 = [], points_mr_tag3 = [],

                points_mc_tag0_kalman_c = [], points_mc_tag0_kalman_f = [],
                points_mc_tag1_kalman_c = [], points_mc_tag1_kalman_f = [],
                points_mc_tag2_kalman_c = [], points_mc_tag2_kalman_f = [],
                points_mc_tag3_kalman_c = [], points_mc_tag3_kalman_f = []
            ;

            dataSet_DecaWaveData.forEach((data) => {
                let pos = JSON.parse(data.pos);

                pos.x = parseFloat(pos.x);
                pos.y = parseFloat(pos.y);
                pos.z = parseFloat(pos.z);

                if(data.msgType == "b'mc'") {
                    if(pos.x < 100 && pos.x > -100 && pos.y<100 && pos.x > -100) {
                        switch (data.tag) {
                            case "0" :

                                if(data.timeStamp > mc_tag0.timeStamp) mc_tag0 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};

                                if(data.timeStamp > mc_tag0_kalman_f.timeStamp) mc_tag0_kalman_f = {timeStamp:data.timeStamp, x:(pos.position_kalman_calculated_x), y:(pos.position_kalman_calculated_y)};
                                if(data.timeStamp > mc_tag0_kalman_c.timeStamp) mc_tag0_kalman_c = {timeStamp:data.timeStamp, x:(pos.position_kalman_filtered_x), y:(pos.position_kalman_filtered_y)};

                                points_mc_tag0.push({"x": (pos.x), "y": (pos.y),});

                                points_mc_tag0_kalman_c.push({"x": (pos.position_kalman_calculated_x), "y": (pos.position_kalman_calculated_y),});
                                points_mc_tag0_kalman_f.push({"x": (pos.position_kalman_filtered_x), "y": (pos.position_kalman_filtered_y),});

                                break;
                            case "1" :
                                if(data.timeStamp > mc_tag1.timeStamp) mc_tag1 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag1.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "2" :
                                if(data.timeStamp > mc_tag2.timeStamp) mc_tag2 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag2.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "3" :
                                if(data.timeStamp > mc_tag3.timeStamp) mc_tag3 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mc_tag3.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            default  : console.log("Unknown deviceId"); break;
                        }
                    }
                } else if(data.msgType == "b'mr'") {

                    if(pos.x < 100 && pos.x > -100 && pos.y<100 && pos.x > -100) {
                        switch (data.tag) {
                            case "0" :
                                if( data.timeStamp > mr_tag0.timeStamp) mr_tag0 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag0.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "1" :
                                if( data.timeStamp > mr_tag1.timeStamp) mr_tag1 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag1.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "2" :
                                if( data.timeStamp > mr_tag2.timeStamp) mr_tag2 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag2.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            case "3" :
                                if( data.timeStamp > mr_tag3.timeStamp) mr_tag3 = {timeStamp:data.timeStamp, x:(pos.x), y:(pos.y), z:(pos.z)};
                                points_mr_tag3.push({"x": (pos.x), "y": (pos.y),});
                                break;
                            default  :
                                console.log("Unknown deviceId");
                                break;
                        }
                    }
                }
            });


            let tempPathPlot = [
                {"id": "flt-1", "classes": "device_1_mc", "points": points_mc_tag0,},
                {"id": "flt-3", "classes": "device_2_mc", "points": points_mc_tag1,},
                {"id": "flt-5", "classes": "device_3_mc", "points": points_mc_tag2,},
                {"id": "flt-7", "classes": "device_4_mc", "points": points_mc_tag3,},



                {"id": "flt-11", "classes": "device_1_mc_k_c", "points": points_mc_tag0_kalman_c,},
                {"id": "flt-12", "classes": "device_2_mc_k_f", "points": points_mc_tag0_kalman_f,},

                /*
                {"id": "flt-2", "classes": "device_1_mr", "points": points_mr_tag0,},
                {"id": "flt-4", "classes": "device_2_mr", "points": points_mr_tag1,},
                {"id": "flt-6", "classes": "device_3_mr", "points": points_mr_tag2,},
                {"id": "flt-8", "classes": "device_4_mr", "points": points_mr_tag3,},
                 */
            ];


            mapdata[pathplot.id()] = tempPathPlot;


            let polygons = [

                {"id": "mc_tag0", "class": "device_1_vertex",  "points": [ {"x":mc_tag0.x,"y":mc_tag0.y}]},
                {"id": "mc_tag1", "class": "device_2_vertex",  "points": [ {"x":mc_tag1.x,"y":mc_tag1.y}]},
                {"id": "mc_tag2", "class": "device_3_vertex",  "points": [ {"x":mc_tag2.x,"y":mc_tag2.y}]},
                {"id": "mc_tag3", "class": "device_4_vertex",  "points": [ {"x":mc_tag3.x,"y":mc_tag3.y}]},


                {"id": "anchor_0", "class": "anchor_1_vertex", "points": [ {"x":dataSet_KVPs.pos_1_x,"y":dataSet_KVPs.pos_1_y}]},
                {"id": "anchor_1", "class": "anchor_2_vertex", "points": [ {"x":dataSet_KVPs.pos_2_x,"y":dataSet_KVPs.pos_2_y}]},
                {"id": "anchor_2", "class": "anchor_3_vertex", "points": [ {"x":dataSet_KVPs.pos_3_x,"y":dataSet_KVPs.pos_3_y}]},
                {"id": "anchor_3", "class": "anchor_4_vertex", "points": [ {"x":dataSet_KVPs.pos_4_x,"y":dataSet_KVPs.pos_4_y}]},


                {"id": "mc_tag0_kalman_c", "class": "mc_tag0_kalman_c_vertex",  "points": [ {"x":mc_tag0_kalman_c.x,"y":mc_tag0_kalman_c.y}]},
                {"id": "mc_tag0_kalman_f", "class": "mc_tag0_kalman_f_vertex",  "points": [ {"x":mc_tag0_kalman_f.x,"y":mc_tag0_kalman_f.y}]},

                /*
                {"id": "mr_tag0", "name": "mr_tag0", "points": [ {"x":mr_tag0.x,"y":mr_tag0.y}]},
                {"id": "mr_tag1", "name": "mr_tag1", "points": [ {"x":mr_tag1.x,"y":mr_tag1.y}]},
                {"id": "mr_tag2", "name": "mr_tag2", "points": [ {"x":mr_tag2.x,"y":mr_tag2.y}]},
                {"id": "mr_tag3", "name": "mr_tag3", "points": [ {"x":mr_tag3.x,"y":mr_tag3.y}]},
                 */

            ];
            mapdata[overlays.id()] = {"polygons" : polygons};

            console.log("MC - " + "x: " + (mc_tag0.x).toFixed(2) + ", y: " + (mc_tag0.y).toFixed(2) +", z: " + (mc_tag0.z).toFixed(2));
            console.log("KA - " + "x: " + parseFloat(mc_tag0_kalman_c.x).toFixed(2) + ", y: " + parseFloat(mc_tag0_kalman_c.y).toFixed(2));

            d3.select("#myMap").datum(mapdata).call(map);
        }
    });
}

//region AtmosphericData
function processAtmosphericData() {
    
    let temperatureData_device1 = [],
        temperatureData_device2 = [],
        temperatureData_device3 = [],
        temperatureData_device4 = [],

        /*
        pressureData_device1    = [],
        pressureData_device2    = [],
        pressureData_device3    = [],
        pressureData_device4    = [],
        */

        humidityData_device1 = [],
        humidityData_device2 = [],
        humidityData_device3 = [],
        humidityData_device4 = []
        ;

    dataSet_temperature.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     temperatureData_device1.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            case "ketto":   temperatureData_device2.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            case "harom":   temperatureData_device3.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            case "negy":    temperatureData_device4.push({ x: tempData.timeStamp, y: tempData.temperature}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_humidity.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     humidityData_device1.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            case "ketto":   humidityData_device2.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            case "harom":   humidityData_device3.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            case "negy":    humidityData_device4.push({ x: tempData.timeStamp, y: tempData.humidity}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    /*
    dataSet_pressure.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     pressureData_device1.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            case "ketto":   pressureData_device2.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            case "harom":   pressureData_device3.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            case "negy":    pressureData_device4.push({ x: tempData.timeStamp, y: tempData.pressure}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

     */

    if(selectedDataSource == "temperature") {
        chart_device1.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device1,  fill: false},
                { label: "Páratartalom",data: humidityData_device1,     fill: false},
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device2,  fill: false},
                { label: "Páratartalom",data: humidityData_device2,     fill: false},
                //{ label: "Nyomás",      data: pressureData_device2,     fill: false},
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device3,  fill: false},
                { label: "Páratartalom",data: humidityData_device3,     fill: false},
                //{ label: "Nyomás",      data: pressureData_device3,     fill: false},
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Hőmérséklet", data: temperatureData_device4,  fill: false},
                { label: "Páratartalom",data: humidityData_device4,     fill: false},
                //{ label: "Nyomás",      data: pressureData_device4,     fill: false},
            ]
        };
    }


    try{
        chart_device1.update({preservation: true});
        chart_device2.update({preservation: true});
        chart_device3.update({preservation: true});
        chart_device4.update({preservation: true});
    } catch (e) {
        console.log(e);
    }

}

function refreshAtmosphericData() {
    let timeStamp = dataSet_TableUpdateTimes["atmosphericData"];
    if (dataSet_AtmosphericData.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/atmosphericDataAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_AtmosphericData = dataSet_AtmosphericData.concat(resp);}}});
}
function refreshData_temperature() {
    let timeStamp = dataSet_TableUpdateTimes["temperature"];
    if (dataSet_temperature.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/temperatureAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_temperature = dataSet_temperature.concat(resp);showData(selectedDataSource);}}});
}
function refreshData_humidity() {
    let timeStamp = dataSet_TableUpdateTimes["humidity"];
    if (dataSet_humidity.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/humidityAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_humidity = dataSet_humidity.concat(resp);showData(selectedDataSource);}}});
}
function refreshData_pressure() {
    let timeStamp = dataSet_TableUpdateTimes["pressure"];
    if (dataSet_pressure.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/pressureAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_pressure = dataSet_pressure.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region LightData
function processLightData() {
    
    let spect_A_device1 = [], spect_A_device2 = [], spect_A_device3 = [], spect_A_device4 = [],
        spect_B_device1 = [], spect_B_device2 = [], spect_B_device3 = [], spect_B_device4 = [],
        spect_C_device1 = [], spect_C_device2 = [], spect_C_device3 = [], spect_C_device4 = [],
        spect_D_device1 = [], spect_D_device2 = [], spect_D_device3 = [], spect_D_device4 = [],
        spect_E_device1 = [], spect_E_device2 = [], spect_E_device3 = [], spect_E_device4 = [],
        spect_F_device1 = [], spect_F_device2 = [], spect_F_device3 = [], spect_F_device4 = [],
        spect_G_device1 = [], spect_G_device2 = [], spect_G_device3 = [], spect_G_device4 = [],
        spect_H_device1 = [], spect_H_device2 = [], spect_H_device3 = [], spect_H_device4 = [],
        spect_I_device1 = [], spect_I_device2 = [], spect_I_device3 = [], spect_I_device4 = [],
        spect_J_device1 = [], spect_J_device2 = [], spect_J_device3 = [], spect_J_device4 = [],
        spect_K_device1 = [], spect_K_device2 = [], spect_K_device3 = [], spect_K_device4 = [],
        spect_L_device1 = [], spect_L_device2 = [], spect_L_device3 = [], spect_L_device4 = [],
        spect_R_device1 = [], spect_R_device2 = [], spect_R_device3 = [], spect_R_device4 = [],
        spect_S_device1 = [], spect_S_device2 = [], spect_S_device3 = [], spect_S_device4 = [],
        spect_T_device1 = [], spect_T_device2 = [], spect_T_device3 = [], spect_T_device4 = [],
        spect_U_device1 = [], spect_U_device2 = [], spect_U_device3 = [], spect_U_device4 = [],
        spect_V_device1 = [], spect_V_device2 = [], spect_V_device3 = [], spect_V_device4 = [],
        spect_W_device1 = [], spect_W_device2 = [], spect_W_device3 = [], spect_W_device4 = []
    ;

    dataSet_spect_A.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_A_device1.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "ketto":   spect_A_device2.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "harom":   spect_A_device3.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            case "negy":    spect_A_device4.push({ x: tempData.timeStamp, y: tempData.spect_A}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_B.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_B_device1.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "ketto":   spect_B_device2.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "harom":   spect_B_device3.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            case "negy":    spect_B_device4.push({ x: tempData.timeStamp, y: tempData.spect_B}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_C.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_C_device1.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "ketto":   spect_C_device2.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "harom":   spect_C_device3.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            case "negy":    spect_C_device4.push({ x: tempData.timeStamp, y: tempData.spect_C}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_D.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_D_device1.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "ketto":   spect_D_device2.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "harom":   spect_D_device3.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            case "negy":    spect_D_device4.push({ x: tempData.timeStamp, y: tempData.spect_D}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_E.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_E_device1.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "ketto":   spect_E_device2.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "harom":   spect_E_device3.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            case "negy":    spect_E_device4.push({ x: tempData.timeStamp, y: tempData.spect_E}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_F.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_F_device1.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "ketto":   spect_F_device2.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "harom":   spect_F_device3.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            case "negy":    spect_F_device4.push({ x: tempData.timeStamp, y: tempData.spect_F}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_G.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_G_device1.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "ketto":   spect_G_device2.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "harom":   spect_G_device3.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            case "negy":    spect_G_device4.push({ x: tempData.timeStamp, y: tempData.spect_G}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_H.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_H_device1.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "ketto":   spect_H_device2.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "harom":   spect_H_device3.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            case "negy":    spect_H_device4.push({ x: tempData.timeStamp, y: tempData.spect_H}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_I.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_I_device1.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "ketto":   spect_I_device2.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "harom":   spect_I_device3.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            case "negy":    spect_I_device4.push({ x: tempData.timeStamp, y: tempData.spect_I}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_J.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_J_device1.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "ketto":   spect_J_device2.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "harom":   spect_J_device3.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            case "negy":    spect_J_device4.push({ x: tempData.timeStamp, y: tempData.spect_J}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_K.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_K_device1.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "ketto":   spect_K_device2.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "harom":   spect_K_device3.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            case "negy":    spect_K_device4.push({ x: tempData.timeStamp, y: tempData.spect_K}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_L.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_L_device1.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "ketto":   spect_L_device2.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "harom":   spect_L_device3.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            case "negy":    spect_L_device4.push({ x: tempData.timeStamp, y: tempData.spect_L}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_R.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_R_device1.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "ketto":   spect_R_device2.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "harom":   spect_R_device3.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            case "negy":    spect_R_device4.push({ x: tempData.timeStamp, y: tempData.spect_R}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_S.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_S_device1.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "ketto":   spect_S_device2.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "harom":   spect_S_device3.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            case "negy":    spect_S_device4.push({ x: tempData.timeStamp, y: tempData.spect_S}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_T.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_T_device1.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "ketto":   spect_T_device2.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "harom":   spect_T_device3.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            case "negy":    spect_T_device4.push({ x: tempData.timeStamp, y: tempData.spect_T}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_U.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_U_device1.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "ketto":   spect_U_device2.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "harom":   spect_U_device3.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            case "negy":    spect_U_device4.push({ x: tempData.timeStamp, y: tempData.spect_U}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_V.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_V_device1.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "ketto":   spect_V_device2.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "harom":   spect_V_device3.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            case "negy":    spect_V_device4.push({ x: tempData.timeStamp, y: tempData.spect_V}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_spect_W.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     spect_W_device1.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "ketto":   spect_W_device2.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "harom":   spect_W_device3.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            case "negy":    spect_W_device4.push({ x: tempData.timeStamp, y: tempData.spect_W}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "light") {
        chart_device1.data = {
            datasets: [
                { label: "A", data: spect_A_device1,  fill: false},
                { label: "B", data: spect_B_device1,  fill: false},
                { label: "C", data: spect_C_device1,  fill: false},
                { label: "D", data: spect_D_device1,  fill: false},
                { label: "E", data: spect_E_device1,  fill: false},
                { label: "F", data: spect_F_device1,  fill: false},
                { label: "G", data: spect_G_device1,  fill: false},
                { label: "H", data: spect_H_device1,  fill: false},
                { label: "I", data: spect_I_device1,  fill: false},
                { label: "J", data: spect_J_device1,  fill: false},
                { label: "K", data: spect_K_device1,  fill: false},
                { label: "L", data: spect_L_device1,  fill: false},
                { label: "R", data: spect_R_device1,  fill: false},
                { label: "S", data: spect_S_device1,  fill: false},
                { label: "T", data: spect_T_device1,  fill: false},
                { label: "U", data: spect_U_device1,  fill: false},
                { label: "V", data: spect_V_device1,  fill: false},
                { label: "W", data: spect_W_device1,  fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "A", data: spect_A_device2,  fill: false},
                { label: "B", data: spect_B_device2,  fill: false},
                { label: "C", data: spect_C_device2,  fill: false},
                { label: "D", data: spect_D_device2,  fill: false},
                { label: "E", data: spect_E_device2,  fill: false},
                { label: "F", data: spect_F_device2,  fill: false},
                { label: "G", data: spect_G_device2,  fill: false},
                { label: "H", data: spect_H_device2,  fill: false},
                { label: "I", data: spect_I_device2,  fill: false},
                { label: "J", data: spect_J_device2,  fill: false},
                { label: "K", data: spect_K_device2,  fill: false},
                { label: "L", data: spect_L_device2,  fill: false},
                { label: "R", data: spect_R_device2,  fill: false},
                { label: "S", data: spect_S_device2,  fill: false},
                { label: "T", data: spect_T_device2,  fill: false},
                { label: "U", data: spect_U_device2,  fill: false},
                { label: "V", data: spect_V_device2,  fill: false},
                { label: "W", data: spect_W_device2,  fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "A", data: spect_A_device3,  fill: false},
                { label: "B", data: spect_B_device3,  fill: false},
                { label: "C", data: spect_C_device3,  fill: false},
                { label: "D", data: spect_D_device3,  fill: false},
                { label: "E", data: spect_E_device3,  fill: false},
                { label: "F", data: spect_F_device3,  fill: false},
                { label: "G", data: spect_G_device3,  fill: false},
                { label: "H", data: spect_H_device3,  fill: false},
                { label: "I", data: spect_I_device3,  fill: false},
                { label: "J", data: spect_J_device3,  fill: false},
                { label: "K", data: spect_K_device3,  fill: false},
                { label: "L", data: spect_L_device3,  fill: false},
                { label: "R", data: spect_R_device3,  fill: false},
                { label: "S", data: spect_S_device3,  fill: false},
                { label: "T", data: spect_T_device3,  fill: false},
                { label: "U", data: spect_U_device3,  fill: false},
                { label: "V", data: spect_V_device3,  fill: false},
                { label: "W", data: spect_W_device3,  fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "A", data: spect_A_device4,  fill: false},
                { label: "B", data: spect_B_device4,  fill: false},
                { label: "C", data: spect_C_device4,  fill: false},
                { label: "D", data: spect_D_device4,  fill: false},
                { label: "E", data: spect_E_device4,  fill: false},
                { label: "F", data: spect_F_device4,  fill: false},
                { label: "G", data: spect_G_device4,  fill: false},
                { label: "H", data: spect_H_device4,  fill: false},
                { label: "I", data: spect_I_device4,  fill: false},
                { label: "J", data: spect_J_device4,  fill: false},
                { label: "K", data: spect_K_device4,  fill: false},
                { label: "L", data: spect_L_device4,  fill: false},
                { label: "R", data: spect_R_device4,  fill: false},
                { label: "S", data: spect_S_device4,  fill: false},
                { label: "T", data: spect_T_device4,  fill: false},
                { label: "U", data: spect_U_device4,  fill: false},
                { label: "V", data: spect_V_device4,  fill: false},
                { label: "W", data: spect_W_device4,  fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}

function refreshData_spect_A() {
    let timeStamp = dataSet_TableUpdateTimes["spect_A"];
    if (dataSet_spect_A.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_AAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_A = dataSet_spect_A.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_B() {
    let timeStamp = dataSet_TableUpdateTimes["spect_B"];
    if (dataSet_spect_B.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_BAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_B = dataSet_spect_B.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_C() {
    let timeStamp = dataSet_TableUpdateTimes["spect_C"];
    if (dataSet_spect_C.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_CAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_C = dataSet_spect_C.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_D() {
    let timeStamp = dataSet_TableUpdateTimes["spect_D"];
    if (dataSet_spect_D.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_DAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_D = dataSet_spect_D.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_E() {
    let timeStamp = dataSet_TableUpdateTimes["spect_E"];
    if (dataSet_spect_E.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_EAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_E = dataSet_spect_E.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_F() {
    let timeStamp = dataSet_TableUpdateTimes["spect_F"];
    if (dataSet_spect_F.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_FAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_F = dataSet_spect_F.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_G() {
    let timeStamp = dataSet_TableUpdateTimes["spect_G"];
    if (dataSet_spect_G.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_GAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_G = dataSet_spect_G.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_H() {
    let timeStamp = dataSet_TableUpdateTimes["spect_H"];
    if (dataSet_spect_H.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_HAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_H = dataSet_spect_H.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_I() {
    let timeStamp = dataSet_TableUpdateTimes["spect_I"];
    if (dataSet_spect_I.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_IAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_I = dataSet_spect_I.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_J() {
    let timeStamp = dataSet_TableUpdateTimes["spect_J"];
    if (dataSet_spect_J.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_JAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_J = dataSet_spect_J.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_K() {
    let timeStamp = dataSet_TableUpdateTimes["spect_K"];
    if (dataSet_spect_K.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_KAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_K = dataSet_spect_K.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_L() {
    let timeStamp = dataSet_TableUpdateTimes["spect_L"];
    if (dataSet_spect_L.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_LAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_L = dataSet_spect_L.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_R() {
    let timeStamp = dataSet_TableUpdateTimes["spect_R"];
    if (dataSet_spect_R.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_RAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_R = dataSet_spect_R.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_S() {
    let timeStamp = dataSet_TableUpdateTimes["spect_S"];
    if (dataSet_spect_S.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_SAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_S = dataSet_spect_S.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_T() {
    let timeStamp = dataSet_TableUpdateTimes["spect_T"];
    if (dataSet_spect_T.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_TAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_T = dataSet_spect_T.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_U() {
    let timeStamp = dataSet_TableUpdateTimes["spect_U"];
    if (dataSet_spect_U.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_UAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_U = dataSet_spect_U.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_V() {
    let timeStamp = dataSet_TableUpdateTimes["spect_V"];
    if (dataSet_spect_V.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_VAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_V = dataSet_spect_V.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_spect_W() {
    let timeStamp = dataSet_TableUpdateTimes["spect_W"];
    if (dataSet_spect_W.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/spect_WAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_spect_W = dataSet_spect_W.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region PHData
function processPHData() {

    let PHValueData_device1 = [],
        PHValueData_device2 = [],
        PHValueData_device3 = [],
        PHValueData_device4 = []

        /*
        PHVoltageData_device1 = [],
        PHVoltageData_device2 = [],
        PHVoltageData_device3 = [],
        PHVoltageData_device4 = []
         */
    ;

    dataSet_ph_Value.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     PHValueData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "ketto":   PHValueData_device2.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "harom":   PHValueData_device3.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            case "negy":    PHValueData_device4.push({ x: tempData.timeStamp, y: tempData.ph_Value}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_ph_Voltage.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     PHVoltageData_device1.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            case "ketto":   PHVoltageData_device2.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            case "harom":   PHVoltageData_device3.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            case "negy":    PHVoltageData_device4.push({ x: tempData.timeStamp, y: tempData.ph_Voltage}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "ph") {
        chart_device1.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device1,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device2,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device3,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "PH Érték",    data: PHValueData_device4,       fill: false},
                //{ label: "Feszültség",  data: PHVoltageData_device4,     fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_ph_Value() {
    let timeStamp = dataSet_TableUpdateTimes["ph_Value"];

    if (dataSet_ph_Value.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;

    $.ajax({url: "../data/ph_ValueAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_ph_Value = dataSet_ph_Value.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_ph_Voltage() {
    let timeStamp = dataSet_TableUpdateTimes["ph_Voltage"];
    if (dataSet_ph_Voltage.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/ph_VoltageAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_ph_Voltage = dataSet_ph_Voltage.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region ButtonData
function processButtonData() {

    let greenButtonData_device1 = [],
        greenButtonData_device2 = [],
        greenButtonData_device3 = [],
        greenButtonData_device4 = [],
        redButtonData_device1 = [],
        redButtonData_device2 = [],
        redButtonData_device3 = [],
        redButtonData_device4 = []
    ;

    dataSet_button_Green.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     greenButtonData_device1.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            case "ketto":   greenButtonData_device2.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            case "harom":   greenButtonData_device3.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            case "negy":    greenButtonData_device4.push({ x: tempData.timeStamp, y: tempData.button_Green}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_button_Red.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     redButtonData_device1.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            case "ketto":   redButtonData_device2.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            case "harom":   redButtonData_device3.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            case "negy":    redButtonData_device4.push({ x: tempData.timeStamp, y: tempData.button_Red}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "button") {
        chart_device1.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device1,  fill: false},
                { label: "Piros",  data: redButtonData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device2,  fill: false},
                { label: "Piros",  data: redButtonData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device3,  fill: false},
                { label: "Piros",  data: redButtonData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Zöld",   data: greenButtonData_device4,  fill: false},
                { label: "Piros",  data: redButtonData_device4,     fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_button_Green() {
    let timeStamp = dataSet_TableUpdateTimes["button_Green"];
    if (dataSet_button_Green.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/button_GreenAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_button_Green = dataSet_button_Green.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_button_Red() {
    let timeStamp = dataSet_TableUpdateTimes["button_Red"];
    if (dataSet_button_Red.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/button_RedAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_button_Red = dataSet_button_Red.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region HeartRateData
function processHeartRateData() {

    let hr_confidenceData_device1 = [], hr_confidenceData_device2 = [], hr_confidenceData_device3 = [], hr_confidenceData_device4 = [],
        hr_extStatusData_device1 = [], hr_extStatusData_device2 = [], hr_extStatusData_device3 = [], hr_extStatusData_device4 = [],
        hr_statusData_device1 = [], hr_statusData_device2 = [], hr_statusData_device3 = [], hr_statusData_device4 = [],
        hr_heartRateData_device1 = [], hr_heartRateData_device2 = [], hr_heartRateData_device3 = [], hr_heartRateData_device4 = [],
        hr_oxygenData_device1 = [], hr_oxygenData_device2 = [], hr_oxygenData_device3 = [], hr_oxygenData_device4 = [],
        hr_irLedData_device1 = [], hr_irLedData_device2 = [], hr_irLedData_device3 = [], hr_irLedData_device4 = [],
        hr_redLedData_device1 = [], hr_redLedData_device2 = [], hr_redLedData_device3 = [], hr_redLedData_device4 = [],

        hr_rValueData_device1 = [], hr_rValueData_device2 = [], hr_rValueData_device3 = [], hr_rValueData_device4 = []
    ;

    dataSet_hr_confidence.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_confidenceData_device1.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            case "ketto":   hr_confidenceData_device2.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            case "harom":   hr_confidenceData_device3.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            case "negy":    hr_confidenceData_device4.push({ x: tempData.timeStamp, y: tempData.hr_confidence}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_status.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_statusData_device1.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            case "ketto":   hr_statusData_device2.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            case "harom":   hr_statusData_device3.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            case "negy":    hr_statusData_device4.push({ x: tempData.timeStamp, y: tempData.hr_status}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_extStatus.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_extStatusData_device1.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            case "ketto":   hr_extStatusData_device2.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            case "harom":   hr_extStatusData_device3.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            case "negy":    hr_extStatusData_device4.push({ x: tempData.timeStamp, y: tempData.hr_extStatus}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_heartRate.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_heartRateData_device1.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            case "ketto":   hr_heartRateData_device2.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            case "harom":   hr_heartRateData_device3.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            case "negy":    hr_heartRateData_device4.push({ x: tempData.timeStamp, y: tempData.hr_heartRate}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_oxygen.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_oxygenData_device1.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            case "ketto":   hr_oxygenData_device2.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            case "harom":   hr_oxygenData_device3.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            case "negy":    hr_oxygenData_device4.push({ x: tempData.timeStamp, y: tempData.hr_oxygen}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_redLed.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_redLedData_device1.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            case "ketto":   hr_redLedData_device2.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            case "harom":   hr_redLedData_device3.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            case "negy":    hr_redLedData_device4.push({ x: tempData.timeStamp, y: tempData.hr_redLed}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_hr_irLed.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_irLedData_device1.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            case "ketto":   hr_irLedData_device2.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            case "harom":   hr_irLedData_device3.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            case "negy":    hr_irLedData_device4.push({ x: tempData.timeStamp, y: tempData.hr_irLed}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    dataSet_hr_rValue.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     hr_rValueData_device1.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            case "ketto":   hr_rValueData_device2.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            case "harom":   hr_rValueData_device3.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            case "negy":    hr_rValueData_device4.push({ x: tempData.timeStamp, y: tempData.hr_rValue}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "heartRate") {
        chart_device1.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device1,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device1,  fill: false},

                { label: "Konfidenca",  data: hr_confidenceData_device1,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device1,     fill: false},
                { label: "Státusz",     data: hr_statusData_device1,     fill: false},

                { label: "R érték",     data: hr_rValueData_device1,     fill: false},

                { label: "Infra LED",   data: hr_irLedData_device1,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device2,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device2,  fill: false},

                { label: "Konfidenca",  data: hr_confidenceData_device2,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device2,     fill: false},
                { label: "Státusz",     data: hr_statusData_device2,     fill: false},

                { label: "R érték",     data: hr_rValueData_device2,     fill: false},

                { label: "Infra LED",   data: hr_irLedData_device2,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device3,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device3,  fill: false},

                { label: "Konfidenca",  data: hr_confidenceData_device3,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device3,     fill: false},
                { label: "Státusz",     data: hr_statusData_device3,     fill: false},
                { label: "R érték",     data: hr_rValueData_device3,     fill: false},

                { label: "Infra LED+",  data: hr_irLedData_device3,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Pulzus",      data: hr_heartRateData_device4,  fill: false},
                { label: "Oxigén",      data: hr_oxygenData_device4,  fill: false},
                { label: "Konfidenca",  data: hr_confidenceData_device4,  fill: false},

                { label: "Státusz+",    data: hr_extStatusData_device4,     fill: false},
                { label: "Státusz",     data: hr_statusData_device4,     fill: false},

                { label: "R érték",     data: hr_rValueData_device4,     fill: false},

                { label: "Infra LED+",  data: hr_irLedData_device4,     fill: false},
                { label: "Piros LED",   data: hr_redLedData_device4,     fill: false}
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_hr_confidence() {
    let timeStamp = dataSet_TableUpdateTimes["hr_confidence"];
    if (dataSet_hr_confidence.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_confidenceAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_confidence = dataSet_hr_confidence.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_hr_extStatus() {
    let timeStamp = dataSet_TableUpdateTimes["hr_extStatus"];
    if (dataSet_hr_extStatus.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_extStatusAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_extStatus = dataSet_hr_extStatus.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_hr_heartRate() {
    let timeStamp = dataSet_TableUpdateTimes["hr_heartRate"];
    if (dataSet_hr_heartRate.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_heartRateAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_heartRate = dataSet_hr_heartRate.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_hr_oxygen() {
    let timeStamp = dataSet_TableUpdateTimes["hr_oxygen"];
    if (dataSet_hr_oxygen.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_oxygenAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_oxygen = dataSet_hr_oxygen.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_hr_irLed() {
    let timeStamp = dataSet_TableUpdateTimes["hr_irLed"];
    if (dataSet_hr_irLed.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_irLedAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_irLed = dataSet_hr_irLed.concat(resp);showData(selectedDataSource);}}});

}

function refreshData_hr_redLed() {
    let timeStamp = dataSet_TableUpdateTimes["hr_redLed"];
    if (dataSet_hr_redLed.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_redLedAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_redLed = dataSet_hr_redLed.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_hr_rValue() {
    let timeStamp = dataSet_TableUpdateTimes["hr_rValue"];
    if (dataSet_hr_rValue.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_rValueAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_rValue = dataSet_hr_rValue.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_hr_status() {
    let timeStamp = dataSet_TableUpdateTimes["hr_status"];
    if (dataSet_hr_status.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/hr_statusAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_hr_status = dataSet_hr_status.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region ScaleData
function processScaleData() {

    let scale_AvgWeightData_device1 = [], scale_AvgWeightData_device2 = [], scale_AvgWeightData_device3 = [], scale_AvgWeightData_device4 = [],
        scale_WeightData_device1 = [], scale_WeightData_device2 = [], scale_WeightData_device3 = [], scale_WeightData_device4 = [],
        scale_ReadingData_device1 = [], scale_ReadingData_device2 = [], scale_ReadingData_device3 = [], scale_ReadingData_device4 = [],
        scale_ZeroOffsetData_device1 = [], scale_ZeroOffsetData_device2 = [], scale_ZeroOffsetData_device3 = [], scale_ZeroOffsetData_device4 = [],
        scale_CalibrationFactorData_device1 = [], scale_CalibrationFactorData_device2 = [], scale_CalibrationFactorData_device3 = [], scale_CalibrationFactorData_device4 = []
    ;

    dataSet_scale_AvgWeight.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_AvgWeightData_device1.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            case "ketto":   scale_AvgWeightData_device2.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            case "harom":   scale_AvgWeightData_device3.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            case "negy":    scale_AvgWeightData_device4.push({ x: tempData.timeStamp, y: tempData.scale_AvgWeight}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_Reading.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_ReadingData_device1.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            case "ketto":   scale_ReadingData_device2.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            case "harom":   scale_ReadingData_device3.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            case "negy":    scale_ReadingData_device4.push({ x: tempData.timeStamp, y: tempData.scale_Reading}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_Weight.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_WeightData_device1.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            case "ketto":   scale_WeightData_device2.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            case "harom":   scale_WeightData_device3.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            case "negy":    scale_WeightData_device4.push({ x: tempData.timeStamp, y: tempData.scale_Weight}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_ZeroOffset.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_ZeroOffsetData_device1.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            case "ketto":   scale_ZeroOffsetData_device2.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            case "harom":   scale_ZeroOffsetData_device3.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            case "negy":    scale_ZeroOffsetData_device4.push({ x: tempData.timeStamp, y: tempData.scale_ZeroOffset}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });
    dataSet_scale_CalibrationFactor.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     scale_CalibrationFactorData_device1.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            case "ketto":   scale_CalibrationFactorData_device2.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            case "harom":   scale_CalibrationFactorData_device3.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            case "negy":    scale_CalibrationFactorData_device4.push({ x: tempData.timeStamp, y: tempData.scale_CalibrationFactor}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "scale") {
        chart_device1.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device1,  fill: false},
                { label: "Súly",      data: scale_WeightData_device1,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device1,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device1,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device1,     fill: false}
            ]
        };
        chart_device2.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device2,  fill: false},
                { label: "Súly",      data: scale_WeightData_device2,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device2,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device2,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device2,     fill: false}
            ]
        };
        chart_device3.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device3,  fill: false},
                { label: "Súly",      data: scale_WeightData_device3,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device3,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device3,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device3,     fill: false}
            ]
        };
        chart_device4.data = {
            datasets: [
                { label: "Súly átlag", data: scale_AvgWeightData_device4,  fill: false},
                { label: "Súly",      data: scale_WeightData_device4,     fill: false},
                //{ label: "Mérés",data: scale_ReadingData_device4,     fill: false},
                //{ label: "Zero Offset", data: scale_ZeroOffsetData_device4,  fill: false},
                //{ label: "Calibration Factor",      data: scale_CalibrationFactorData_device4,     fill: false},
            ]
        };

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_scale_AvgWeight() {
    let timeStamp = dataSet_TableUpdateTimes["scale_AvgWeight"];
    if (dataSet_scale_AvgWeight.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/scale_AvgWeightAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_AvgWeight = dataSet_scale_AvgWeight.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_scale_CalibrationDate() {
    let timeStamp = dataSet_TableUpdateTimes["scale_CalibrationDate"];
    if (dataSet_scale_CalibrationDate.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/scale_CalibrationDateAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_CalibrationDate = dataSet_scale_CalibrationDate.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_scale_CalibrationFactor() {
    let timeStamp = dataSet_TableUpdateTimes["scale_CalibrationFactor"];
    if (dataSet_scale_CalibrationFactor.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/scale_CalibrationFactorAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_CalibrationFactor = dataSet_scale_CalibrationFactor.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_scale_Reading() {
    let timeStamp = dataSet_TableUpdateTimes["scale_Reading"];
    if (dataSet_scale_Reading.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/scale_ReadingAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_Reading = dataSet_scale_Reading.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_scale_Weight() {
    let timeStamp = dataSet_TableUpdateTimes["scale_Weight"];
    if (dataSet_scale_Weight.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/scale_WeightAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_Weight = dataSet_scale_Weight.concat(resp);showData(selectedDataSource);}}});

}
function refreshData_scale_ZeroOffset() {
    let timeStamp = dataSet_TableUpdateTimes["scale_ZeroOffset"];
    if (dataSet_scale_ZeroOffset.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/scale_ZeroOffsetAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_scale_ZeroOffset = dataSet_scale_ZeroOffset.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region PWMData
function processPWMData() {

    let pwmData_device1 = [],
        pwmData_device2 = [],
        pwmData_device3 = [],
        pwmData_device4 = []
    ;

    dataSet_pwm.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     pwmData_device1.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            case "ketto":   pwmData_device2.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            case "harom":   pwmData_device3.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            case "negy":    pwmData_device4.push({ x: tempData.timeStamp, y: tempData.pwm}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "pwm") {
        chart_device1.data = {datasets: [{ label: "PWM", data: pwmData_device1,  fill: false}]};
        chart_device2.data = {datasets: [{ label: "PWM", data: pwmData_device2,  fill: false}]};
        chart_device3.data = {datasets: [{ label: "PWM", data: pwmData_device3,  fill: false}]};
        chart_device4.data = {datasets: [{ label: "PWM", data: pwmData_device4,  fill: false}]};

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_pwm() {
    let timeStamp = dataSet_TableUpdateTimes["pwm"];
    if (dataSet_pwm.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/pwmAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_pwm = dataSet_pwm.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//region VoiceData
function processVoiceData() {

    let voiceRecognitionData_device1 = [],
        voiceRecognitionData_device2 = [],
        voiceRecognitionData_device3 = [],
        voiceRecognitionData_device4 = []
    ;

    dataSet_voiceRecognition.forEach((tempData) => {
        switch(tempData.deviceId) {
            case "egy":     voiceRecognitionData_device1.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            case "ketto":   voiceRecognitionData_device2.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            case "harom":   voiceRecognitionData_device3.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            case "negy":    voiceRecognitionData_device4.push({ x: tempData.timeStamp, y: tempData.voiceRecognition}); break;
            default:        console.log("Unknown deviceId"); break;
        }
    });

    if(selectedDataSource == "voice") {
        chart_device1.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device1,  fill: false}]};
        chart_device2.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device2,  fill: false}]};
        chart_device3.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device3,  fill: false}]};
        chart_device4.data = {datasets: [{ label: "voice", data: voiceRecognitionData_device4,  fill: false}]};

        chart_device1.update(0);
        chart_device2.update(0);
        chart_device3.update(0);
        chart_device4.update(0);
    }
}
function refreshData_voiceRecognition() {
    let timeStamp = dataSet_TableUpdateTimes["voiceRecognition"];
    if (dataSet_voiceRecognition.length == 0) timeStamp = moment(Date.now()).add(timeToBakcAtStart,'m').unix()*1000;
    $.ajax({url: "../data/voiceRecognitionAfterTimeStamp", data: { timeStamp: timeStamp }, method: 'GET', dataType: 'json', success: function(resp) {if(resp) { dataSet_voiceRecognition = dataSet_voiceRecognition.concat(resp);showData(selectedDataSource);}}});

}
//endregion

//endregion

function refreshEnumerationUsersOnHomePage(caller) {
    /*if(caller == "statuses") $('#todosDataTable').DataTable().ajax.reload();
    refreshCalendar();*/
}

function resizePanel() {
    let mapContainer = $("#mapContainer")[0];
    let myMap = $("#myMap")[0];

    //$('#myMap').css('height', mapContainer.clientHeight+'px');
    $('#mapSVG').attr('width', mapContainer.clientWidth+'px');
    $('.map-layers').attr('width', mapContainer.clientWidth+'px');
}
