'use strict';
let dataSet_TableUpdateTimes = [],
    dataSet_TableUpdateTimes_mod = [],
    dataSet_PriceDefault = [],
    dataSet_AppointmentDefault = [],
    dataSet_ModuleTopicDefault = [],
    dataSet_Backups = [],
    dataSet_DefaultTodos = [],
    dataSet_EmailTemplates = [],

    memberRelevances = [],
    selectedLocationItem = 0,
    selectedMemberItem = 0,
    selectedDefaultPriceItem = 0,
    selectedDefaultAppointmentItem = 0,
    selectedDefaultTodoItem = 0,
    selectedEmailTemplateItem = 0,
    selectedDefaultModuleTopicItem = 0;

jQuery(document).ready(function ($) {

    memberRelevances.push({id: "jegyzo", title: "Jegyző"});
    memberRelevances.push({id: "bizottsag_elnoke", title: "Bizottság elnöke"});
    memberRelevances.push({id: "bizottsagi_tag", title: "Bizottsági tag"});
    memberRelevances.push({id: "bizottsagi_tag_kepzo", title: "Bizottsági tag (képző)"});
    memberRelevances.push({id: "vizsgaszervezo", title: "Vizsgaszervező"});
    memberRelevances.push({id: "tanar", title: "Oktató"});
    memberRelevances.push({id: "felugyelo", title: "Felügyelő"});
    memberRelevances.push({id: "kepviselo", title: "Képviselő"});

    kvpRefreshCallbacks.push(refreshKVPsOnSettingsPage);

    enumerationRefreshCallbacks.push(refreshEnumerationsOnSettingsPage);

    //region Button
    $('#btnAddLocation').on('click', function () {refreshLocationItem();});
    $('#btnAddMember').on('click', function () {refreshMemberItem();});
    $('#btnAddDefaultPriceItem').on('click', function () {refreshDefaultPriceItem();});
    $('#btnAddDefaultAppointmentItem').on('click', function () {refreshDefaultAppointmentItem();});
    $('#btnAddDefaultModuleTopicItem').on('click', function () {refreshDefaultModuleTopicItem();});
    $('#btnAddDefaultTodoItem').on('click', function () {refreshDefaultTodoItem();});
    $('#btnAddModuleTypeItem').on('click', function () {refreshModuleTypeItem();});
    $('#btnAddEmailTemplateItem').on('click', function () {refreshEmailTemplateItem();});

    $('#btnSavePersonalData').on('click', function () {savePersonalData();});
    $('#btnSaveSchoolData').on('click', function () {saveSchoolData();});
    $('#btnSaveLocationItem').on('click', function () {saveLocationItem();});
    $('#btnSaveMemberItem').on('click', function () {saveMemberItem();});
    $('#btnSaveDefaultPriceItem').on('click', function () {saveDefaultPriceItem();});
    $('#btnSaveDefaultAppointmentItem').on('click', function () {saveDefaultAppointmentItem();});
    $('#btnSaveDefaultModuleTopicItem').on('click', function () {saveDefaultModuleTopicItem();});
    $('#btnSaveDefaultTodoItem').on('click', function () {saveDefaultTodoItem();});
    $('#btnSaveModuleTypeItem').on('click', function () {saveModuleTypeItem();});
    $('#btnSaveEmailTemplateItem').on('click', function () {saveEmailTemplateItem();});
    //endregion Button

    //region DataTable

    $('#locationsDataTable').dataTable({
        language: datatable_hu,
        aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]],
        searching: true,
        paging: true,
        info: true,
        scrollY: "175px", scrollCollapse: true,
        scrollX: true,
        dataType: 'json',
        "ajax": function (data, callback, settings) {
            callback({data: dataSet_Locations});
        },
        columnDefs: [{targets: 3, className: 'dt-center'}],

        columns: [
            {
                data: null, title: "Név", render: function (data, type, row, meta) {
                    return data.nameShort + " (" + data.nameOfficial + ")";
                }
            },
            {data: "description", title: "Leírás"},
            {data: null, title: "Cím", render: function (data, type, row, meta) {return getAddressFromRow(data)},},
            {
                data: null,
                title: "Műveletek",
                width: "10%",
                orderable: false,
                render: function (data, type, row, meta) {
                    return "" +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Duplikál"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" onclick="duplicateLocationItem(\'' + data.id + '\')"><i class="fas fa-copy"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditLocationItem" onclick="refreshLocationItem(\'' + data.id + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteLocationItem(\'' + data.id + '\')"><i class="fas fa-trash-alt"></i></a></span>';;
                },
            }
        ]
    });
    $('#locationsDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});

    $('#membersDataTable').dataTable({
        language: datatable_hu,
        aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]],
        searching: true,
        paging: true,
        info: true,
        scrollY: "175px", scrollCollapse: true,
        scrollX: true,
        dataType: 'json',
        "ajax": function (data, callback, settings) {callback({data: dataSet_Members});},
        columnDefs: [{targets: 4, className: 'dt-center'}],
        columns: [
            {data: "name", title: "Név"},
            {data: "relevance", title: "Relevancia", render: function (data, type, row, meta) {return getRelevanceNamesByIds(data)},},
            {data: "additionalInfo", title: "Információk"},
            {data: "comment", title: "Megjegyzés"},
            {
                data: null,
                title: "Műveletek",
                width: "10%",
                orderable: false,
                render: function (data, type, row, meta) {
                    return ""+
                        '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditMemberItem" onclick="refreshMemberItem(\'' + data.memberId + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteMemberItem(\'' + data.memberId + '\')"><i class="fas fa-trash-alt"></i></a></span>';;
                },
            }
        ]
    });
    $('#membersDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});

    $('#priceDefaultDataTable').dataTable({
        language: datatable_hu,
        aLengthMenu: [[25, 50, 100, -1], [ 25, 50, 100, "Összes"]],
        searching: true,
        paging: true,
        info: true,
        scrollY: "175px", scrollCollapse: true,
        scrollX: true,
        dataType: 'json',
        "ajax": function (data, callback, settings) {
            callback({data: dataSet_PriceDefault});
        },
        columnDefs: [
            {targets: 5, className: 'dt-center'},
            {targets: 4, type: 'formatted-num' }
        ],

        columns: [
            {data: null, title: "Képzés",render: function (data, type, row, meta) {return  data.shortCode + "<i> (" + getItemTypeNameByShortCode(data.shortCode) +")</i>";} },
            {data: "educationMode", title: "Oktatás módja", render: function (data, type, row, meta) {return getEducationModeNameById(data);}},
            {data: "priceItemType", title: "Típus", render: function (data, type, row, meta) {return getPriceItemTypeNameById(data);}},

            {data: "itemDescription", title: "Leírás"},
            {data: "price", title: "Ár",  render: function (data, type, row, meta) {return  data.toLocaleString('en-US').replace(',', ' ') + " Ft";}},
            {
                data: null,
                title: "Műveletek",
                width: "10%",
                orderable: false,
                render: function (data, type, row, meta) {
                    return "" +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Duplikál"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" onclick="duplicatePriceDefaultItem(\'' + data.id + '\')"><i class="fas fa-copy"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditDefaultPriceItem" onclick="refreshDefaultPriceItem(\'' + data.id + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeletePriceItem(\'' + data.id + '\')"><i class="fas fa-trash-alt"></i></a></span>';

                    ;
                },
            }
        ]
    });
    $('#priceDefaultDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});

    $('#moduleTopicDefaultDataTable').dataTable({
        language: datatable_hu, aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]],
        searching: true, paging: true, info: true, scrollY: "175px", scrollCollapse: true, scrollX: true, dataType: 'json',
        "ajax": function (data, callback, settings) {callback({data: dataSet_ModuleTopicDefault});},
        columnDefs: [{targets: 5, className: 'dt-center'}],
        columns: [
            {data: "moduleShortCode", title: "Képzés kód"},
            {data: "moduleTopicType", title: "Tantárgy kód"},
            {data: "name", title: "Tantárgy név",  render: function (data, type, row, meta) {return data.length > 60 ? data.substr(0,60) +"..." : data;}},
            {data: "numberOfHours", title: "Órák száma"},
            {data: null, title: "Típus / Formátum ", width:"15%", render: function (data, type, row, meta) {return getModuleTopicTypeNameById(data.type) + " / " + getModuleTopicFormatNameById(data.format);}},
            {data: null, title: "Műveletek", width: "10%", orderable: false,
                render: function (data, type, row, meta) {
                    return "" +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditDefaultModuleTopicItem" onclick="refreshDefaultModuleTopicItem(\'' + data.id + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteModuleTopicDefault(\'' + data.id + '\')"><i class="fas fa-trash-alt"></i></a></span>';
                    ;
                },
            }
        ],
        "createdRow": function( row, data, dataIndex){
            if( data.type ==  "EXAM") {
                $(row).addClass('appointmentExam');
                if( data.moduleTopicType.indexOf("_MODULZARO") < 0){$(row).addClass('vizsga');}
            }
            if( data.format ==  "PRACTICAL"){$(row).addClass('appointmentPractical');}
        }
    });
    $('#moduleTopicDefaultDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});

    $('#appointmentDefaultDataTable').dataTable({
        language: datatable_hu, aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]], searching: true, paging: true, info: true,
        scrollY: "175px", scrollCollapse: true, scrollX: true, dataType: 'json',
        "ajax": function (data, callback, settings) {
            callback({data: dataSet_AppointmentDefault});
        },
        columnDefs: [{targets: 4, className: 'dt-center'}],
        columns: [
            {data: "moduleTopicType", title: "Tantárgy kód"},
            {data: "name", title: "Név",  render: function (data, type, row, meta) {return data.length > 40 ? data.substr(0,40) +"..." : data;}},
            {data: "details", title: "Részletek",  render: function (data, type, row, meta) { if (data) {return data.length > 40 ? data.substr(0,40) +"..." : data;} else {return "";}}},
            {data: "numberOfHours", title: "Órák száma"},
            {data: null, title: "Típus / Formátum ", width:"15%", render: function (data, type, row, meta) {return getModuleTopicTypeNameById(data.type) + " / " + getModuleTopicFormatNameById(data.format);}},
            {data: null, title: "Műveletek", width: "10%", orderable: false,
                render: function (data, type, row, meta) {
                    return '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditDefaultAppointmentItem" onclick="refreshDefaultAppointmentItem(\'' + data.id + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteAppointmentDefault(\'' + data.id + '\')"><i class="fas fa-trash-alt"></i></a></span>';
                },
            }
        ],
        "createdRow": function( row, data, dataIndex){
            if( data.type ==  "EXAM") {
                $(row).addClass('appointmentExam');
                if( data.moduleTopicType.indexOf("_MODULZARO") < 0){$(row).addClass('vizsga');}
            }
            if( data.format ==  "PRACTICAL"){$(row).addClass('appointmentPractical');}

        }
    });
    $('#appointmentDefaultDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});

    $('#defaultTodoDataTable').dataTable({
        language: datatable_hu, aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]], searching: true, paging: true, info: true,
        scrollY: "175px", scrollCollapse: true, scrollX: true, dataType: 'json',
        "ajax": function (data, callback, settings) {callback({data: dataSet_DefaultTodos});},
        columnDefs: [{targets: 4, className: 'dt-center'}],
        columns: [
            {data: null, title: "Modul", width:"15%", render: function (data, type, row, meta) {return getItemTypeNameByShortCode(data.moduleShortCode);}},
            {data: null, title: "Oktatási mód(ok)", width:"15%", render: function (data, type, row, meta) {
                    let educationModes = data.educationModes.split(',');
                    let ret = "";
                    educationModes.forEach((educationMode) => {
                        if(ret != "") ret += ", ";
                        ret += getEducationModeNameById(educationMode.trim());
                    });
                    return  ret;
            }},

            {data: null, title: "Típus", width:"15%", render: function (data, type, row, meta) {return getTodoTypeNameById(data.type);}},

            {data: "title", title: "Cím",  render: function (data, type, row, meta) {return data.length > 40 ? data.substr(0,40) +"..." : data;}},

            {data: null, title: "Műveletek", width: "10%", orderable: false,
                render: function (data, type, row, meta) {
                    return '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditDefaultTodoItem" onclick="refreshDefaultTodoItem(\'' + data.id + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteDefaultTodo(\'' + data.id + '\')"><i class="fas fa-trash-alt"></i></a></span>';
                },
            }
        ],
    });
    $('#defaultTodoDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});


    $('#moduleTypeDataTable').dataTable({
        language: datatable_hu, aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]], searching: true, paging: true, info: true,
        scrollY: "175px", scrollCollapse: true, scrollX: true, dataType: 'json',
        "ajax": function (data, callback, settings) {callback({data: /*dataSet_ModuleTypes*/enum_ModuleTypes});},
        columnDefs: [{targets: 4, className: 'dt-center'}],
        columns: [

            {data: "itemFamily", title: "Család"},
            {data: "itemGroup", title: "Csoport", render: function (data, type, row, meta) {return data.length > 60 ? data.substr(0,60) +"..." : data;}},
            {data: "itemType", title: "Típus", render: function (data, type, row, meta) {return data.length > 60 ? data.substr(0,60) +"..." : data;}},
            {data: "shortCode", title: "Kód"},

            {data: null, title: "Műveletek", width: "10%", orderable: false,
                render: function (data, type, row, meta) {
                    return '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditModuleTypeItem" onclick="refreshModuleTypeItem(\'' + data.shortCode + '\')"><i class="fas fa-pen"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteModuleType(\'' + data.shortCode + '\')"><i class="fas fa-trash-alt"></i></a></span>';
                },
            }
        ]
    });
    $('#moduleTypeDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});

    $('#backupDataTable').dataTable({
        language: datatable_hu,
        //aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]],
        searching: false,
        //paging: true,
        info: true,
        scrollY: "175px", scrollCollapse: true,
        scrollX: true,
        dataType: 'json',
        "ajax": function (data, callback, settings) {callback({data: dataSet_Backups});},
        columnDefs: [{targets: 1, className: 'dt-center'}],

        columns: [
            {
                data: "created", title: "Dátum", render: function (data, type, row, meta) {
                    return moment(data).format("YYYY.MM.DD. HH:mm:ss");
                }
            },
            {
                data: null,
                title: "Műveletek",
                width: "10%",
                orderable: false,
                render: function (data, type, row, meta) {
                    return "" +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Visszaállít"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" onclick="confirmRestore(\'' + data.created + '\')"><i class="fas fa-recycle"></i></a></span>' +
                        '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteBackup(\'' + data.created + '\')"><i class="fas fa-trash-alt"></i></a></span>';;
                },
            }
        ]
    });
    $('#backupDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});


    $('#emailTemplatesDataTable').dataTable({
        language: datatable_hu, aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]], searching: true, paging: true, info: true,
        scrollY: "175px", scrollCollapse: true, scrollX: true, dataType: 'json',
        "ajax": function (data, callback, settings) {callback({data: dataSet_EmailTemplates});},
        columnDefs: [{targets: 1, className: 'dt-center'}],
        columns: [
            {data: "name", title: "Név",width: "90%"},
            {data: null, title: "Műveletek", width: "10%", orderable: false,
                render: function (data, type, row, meta) {
                    return  '<span data-toggle="tooltip" data-placement="bottom" title="Szerkeszt"><a class="tdbtn tdbtn-icon tdbtn-info" style="color: white" data-backdrop="static" data-keyboard="false" data-toggle="modal" data-target="#modalEditEmailTemplateItem" onclick="refreshEmailTemplateItem(\'' + data.id + '\')"><i class="fas fa-pen"></i></a></span>' +
                            '<span data-toggle="tooltip" data-placement="bottom" title="Töröl"><a class="tdbtn tdbtn-icon tdbtn-red"  style="color:white" onclick="confirmDeleteEmailtemplateItem(\'' + data.id + '\')"><i class="fas fa-trash-alt"></i></a></span>';
                },
            }
        ],
    });
    $('#emailTemplatesDataTable').on('draw.dt', function () {$('[data-toggle="tooltip"]').tooltip();});
    //endregion

    $('#modalEditMemberItem').on('shown.bs.modal', function (e) {$('#memberItemName').focus();});

    $('#modalFilterDefaultPrices').on('shown.bs.modal', function (e) {prepare_settings_filter_defaultPrices_ModuleShortCode(); $('.tooltip').hide();});


    $('a[data-toggle="pill"]').on('shown.bs.tab', function (e) {
        $('#locationsDataTable').DataTable().columns.adjust();
        $('#membersDataTable').DataTable().columns.adjust();
        $('#priceDefaultDataTable').DataTable().columns.adjust();
        $('#moduleTopicDefaultDataTable').DataTable().columns.adjust();
        $('#appointmentDefaultDataTable').DataTable().columns.adjust();
        $('#defaultTodoDataTable').DataTable().columns.adjust();
        $('#moduleTypeDataTable').DataTable().columns.adjust();
        $('#backupDataTable').DataTable().columns.adjust();
        $('#emailTemplatesDataTable').DataTable().columns.adjust();
    });

    resizePanel();
    $(window).bind('resize', function(){resizePanel();});

    preparePills();


    refreshTableUpdateTimes();
    refreshTableUpdateTimes_Modifications();
    setInterval(function () {
        refreshTableUpdateTimes();
        refreshTableUpdateTimes_Modifications();
    }, 5000);
});



//region Download / Refresh data
function refreshTableUpdateTimes() {
    $.ajax({
        url: "../generalCommunication/tableupdatetimes",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {

            if(resp) {

                let tableUpdateTimes = resp.tableUpdateTimes;
                sessionRefreshedAt = resp.sessionRefreshedAt;

                for (let key in tableUpdateTimes) {
                    if (!(key in dataSet_TableUpdateTimes) || tableUpdateTimes[key] > dataSet_TableUpdateTimes[key]) {
                        dataSet_TableUpdateTimes[key] = tableUpdateTimes[key];
                        refreshItem(key);
                    }
                }
            } else {
                dataSet_TableUpdateTimes = [];
            }


        }
    });
}

function refreshTableUpdateTimes_Modifications() {
    $.ajax({
        url: "../generalCommunication/tableupdatetimes_usage",
        method: 'GET',
        dataType: 'json',
        success: function(resp)
        {

            if(resp) {

                let tableUpdateTimes = resp.tableUpdateTimes;
                sessionRefreshedAt = resp.sessionRefreshedAt;

                for (let key in tableUpdateTimes) {
                    if (!(key in dataSet_TableUpdateTimes_mod) || tableUpdateTimes[key] > dataSet_TableUpdateTimes_mod[key]) {
                        dataSet_TableUpdateTimes_mod[key] = tableUpdateTimes[key];
                        refreshItem(key);
                    }
                }
            } else {
                dataSet_TableUpdateTimes_mod = [];
            }
        }
    });
}

function refreshItem(key) {
    switch (key) {
        case "kvp":refreshKVPs();break;
        case "priceDefault":refreshPriceDefaults();break;
        case "moduleTopicDefault":refreshModuleTopicDefaults();break;
        case "appointmentDefault":refreshAppointmentsDefaults();break;
        case "defaultTodo":refreshDefaultTodos();break;
        case "backup":refreshBackups();break;
        case "todo":            refreshToDosOfUser(username);break;
        case "notification":    refreshNotificationsOfUser(username); break;
        case "emailTemplate":    refreshEmailTemplates(); break;
        default:
            refreshEnumerationData(key);
            break;
    }
}

function refreshPageWithData() {

    $('#schoolNameOfficial').val(dataSet_KVPs["schoolNameOfficial"]);
    $('#schoolId').val(dataSet_KVPs["schoolId"]);
    $('#schoolAddress').val(dataSet_KVPs["schoolAddress"]);
    $('#schoolTaxId').val(dataSet_KVPs["schoolTaxId"]);
    $('#schoolDirector').val(dataSet_KVPs["schoolDirector"]);

    $('#schoolHead').val(dataSet_KVPs["schoolHeadOfSchool"]);
    $('#schoolProgramAccreditationNumber').val(dataSet_KVPs["schoolProgramAccreditationNumber"]);
    $('#schoolBankAccountNumber').val(dataSet_KVPs["schoolBankAccountNumber"]);
    $('#schoolCompanyRegistrationNumber').val(dataSet_KVPs["schoolCompanyRegistrationNumber"]);
    $('#schoolFurtherEducationRegistrationNumber').val(dataSet_KVPs["schoolFurtherEducationRegistrationNumber"]);

    $('#schoolNameShort').val(dataSet_KVPs["schoolNameShort"]);
    $('#schoolTelephone').val(dataSet_KVPs["schoolTelephone"]);
    $('#schoolFax').val(dataSet_KVPs["schoolFax"]);
    $('#schoolAccreditationNumber').val(dataSet_KVPs["schoolAccreditationNumber"]);
    $('#schoolRegistrationNumber').val(dataSet_KVPs["schoolRegistrationNumber"]);
    $('#schoolEmail').val(dataSet_KVPs["schoolEmail"]);
    $('#schoolWeb').val(dataSet_KVPs["schoolWeb"]);



    $('#schoolStatisticsNumber').val(dataSet_KVPs["schoolStatisticsNumber"]);
    $('#schoolMobileTelephone').val(dataSet_KVPs["schoolMobileTelephone"]);
    $('#schoolLicenceNumber').val(dataSet_KVPs["schoolLicenceNumber"]);

    $('#schoolSupervisorName').val(dataSet_KVPs["schoolSupervisorName"]);
    $('#schoolSupervisorAddress').val(dataSet_KVPs["schoolSupervisorAddress"]);
    $('#schoolSupervisorTelephone').val(dataSet_KVPs["schoolSupervisorTelephone"]);
    $('#simulatorNumber').val(dataSet_KVPs["simulatorNumber"]);


    $('#schoolFireSafetyResponsible').val(dataSet_KVPs["schoolFireSafetyResponsible"]);


    if (("personalTheme_" + username) in dataSet_KVPs) {
        $('#personalTheme').val(dataSet_KVPs["personalTheme_" + username]);
        setMenuTheme(dataSet_KVPs["personalTheme_" + username])
    } else {
        $('#personalTheme').val("Világos");
    }
}
//endregion

//region Save data
function saveSchoolData() {

    dataSet_KVPs["schoolNameOfficial"] = $('#schoolNameOfficial').val();

    dataSet_KVPs["schoolId"] = $('#schoolId').val();
    dataSet_KVPs["schoolAddress"] = $('#schoolAddress').val();
    dataSet_KVPs["schoolTaxId"] = $('#schoolTaxId').val();
    dataSet_KVPs["schoolDirector"] = $('#schoolDirector').val();

    dataSet_KVPs["schoolNameShort"] = $('#schoolNameShort').val();
    dataSet_KVPs["schoolTelephone"] = $('#schoolTelephone').val();
    dataSet_KVPs["schoolFax"] = $('#schoolFax').val();
    dataSet_KVPs["schoolAccreditationNumber"] = $('#schoolAccreditationNumber').val();
    dataSet_KVPs["schoolRegistrationNumber"] = $('#schoolRegistrationNumber').val();
    dataSet_KVPs["schoolEmail"] = $('#schoolEmail').val();
    dataSet_KVPs["schoolWeb"] = $('#schoolWeb').val();

    dataSet_KVPs["schoolHeadOfSchool"] = $('#schoolHead').val();
    dataSet_KVPs["schoolProgramAccreditationNumber"] = $('#schoolProgramAccreditationNumber').val();
    dataSet_KVPs["schoolBankAccountNumber"] = $('#schoolBankAccountNumber').val();
    dataSet_KVPs["schoolCompanyRegistrationNumber"] = $('#schoolCompanyRegistrationNumber').val();
    dataSet_KVPs["schoolFurtherEducationRegistrationNumber"] = $('#schoolFurtherEducationRegistrationNumber').val();


    dataSet_KVPs["schoolStatisticsNumber"]  = $('#schoolStatisticsNumber').val();
    dataSet_KVPs["schoolMobileTelephone"] = $('#schoolMobileTelephone').val();
    dataSet_KVPs["schoolLicenceNumber"] = $('#schoolLicenceNumber').val();

    dataSet_KVPs["schoolSupervisorName"] = $('#schoolSupervisorName').val();
    dataSet_KVPs["schoolSupervisorAddress"] = $('#schoolSupervisorAddress').val();
    dataSet_KVPs["schoolSupervisorTelephone"] = $('#schoolSupervisorTelephone').val();
    dataSet_KVPs["simulatorNumber"] = $('#simulatorNumber').val();

    dataSet_KVPs["schoolFireSafetyResponsible"] = $('#schoolFireSafetyResponsible').val();

    saveKVPs();
}

function savePersonalData() {
    dataSet_KVPs["personalTheme_" + username] = $('#personalTheme').val();
    saveKVPs();
}
//endregion

//region Helpers
function preparePills() {

    if(preselectedItemType !== "undefined" ) {

        $('#pills-personalSettings-tab').removeClass("show");
        $('#pills-personalSettings-tab').removeClass("active");
        $('#pills-personalSettings').removeClass("show");
        $('#pills-personalSettings').removeClass("active");

        $('#pills-systemSettings-tab').removeClass("show");
        $('#pills-systemSettings-tab').removeClass("active");
        $('#pills-systemSettings').removeClass("show");
        $('#pills-systemSettings').removeClass("active");

        $('#pills-priceDefault-tab').removeClass("show");
        $('#pills-priceDefault-tab').removeClass("active");
        $('#pills-priceDefault').removeClass("show");
        $('#pills-priceDefault').removeClass("active");

        $('#pills-appointmentDefault-tab').removeClass("show");
        $('#pills-appointmentDefault-tab').removeClass("active");
        $('#pills-appointmentDefault').removeClass("show");
        $('#pills-appointmentDefault').removeClass("active");

        $('#pills-moduleTopicDefault-tab').removeClass("show");
        $('#pills-moduleTopicDefault-tab').removeClass("active");
        $('#pills-moduleTopicDefault').removeClass("show");
        $('#pills-moduleTopicDefault').removeClass("active");

        $('#pills-moduleTypes-tab').removeClass("show");
        $('#pills-moduleTypes-tab').removeClass("active");
        $('#pills-moduleTypes').removeClass("show");
        $('#pills-moduleTypes').removeClass("active");

        $('#pills-members-tab').removeClass("show");
        $('#pills-members-tab').removeClass("active");
        $('#pills-members').removeClass("show");
        $('#pills-members').removeClass("active");

        $('#pills-locations-tab').removeClass("show");
        $('#pills-locations-tab').removeClass("active");
        $('#pills-locations').removeClass("show");
        $('#pills-locations').removeClass("active");

        $('#pills-defaultTodos-tab').removeClass("show");
        $('#pills-defaultTodos-tab').removeClass("active");
        $('#pills-defaultTodos').removeClass("show");
        $('#pills-defaultTodos').removeClass("active");


        switch (preselectedItemType) {
            case "szemelyes":
                $('#pills-personalSettings-tab').addClass("show");
                $('#pills-personalSettings-tab').addClass("active");

                $('#pills-personalSettings').addClass("show");
                $('#pills-personalSettings').addClass("active");
                break;
            case "iskola":
                $('#pills-systemSettings-tab').addClass("show");
                $('#pills-systemSettings-tab').addClass("active");
                $('#pills-systemSettings').addClass("show");
                $('#pills-systemSettings').addClass("active");
                break;
            case "arak":
                $('#pills-priceDefault-tab').addClass("show");
                $('#pills-priceDefault-tab').addClass("active");
                $('#pills-priceDefault').addClass("show");
                $('#pills-priceDefault').addClass("active");
                break;
            case "tantargyak":
                $('#pills-moduleTopicDefault-tab').addClass("show");
                $('#pills-moduleTopicDefault-tab').addClass("active");
                $('#pills-moduleTopicDefault').addClass("show");
                $('#pills-moduleTopicDefault').addClass("active");
                break;
            case "alkalmak":
                $('#pills-appointmentDefault-tab').addClass("show");
                $('#pills-appointmentDefault-tab').addClass("active");
                $('#pills-appointmentDefault').addClass("show");
                $('#pills-appointmentDefault').addClass("active");
                break;
            case "teendok":
                $('#pills-defaultTodos-tab').addClass("show");
                $('#pills-defaultTodos-tab').addClass("active");
                $('#pills-defaultTodos').addClass("show");
                $('#pills-defaultTodos').addClass("active");
                break;
            case "kepzesek":
                $('#pills-moduleTypes-tab').addClass("show");
                $('#pills-moduleTypes-tab').addClass("active");
                $('#pills-moduleTypes').addClass("show");
                $('#pills-moduleTypes').addClass("active");
                break;
            case "oktatok":
                $('#pills-members-tab').addClass("show");
                $('#pills-members-tab').addClass("active");
                $('#pills-members').addClass("show");
                $('#pills-members').addClass("active");
                break;
            case "helyszinek":
                $('#pills-locations-tab').addClass("show");
                $('#pills-locations-tab').addClass("active");
                $('#pills-locations').addClass("show");
                $('#pills-locations').addClass("active");
                break;

        }
    }
}

function refreshKVPsOnSettingsPage() {
    refreshPageWithData();
}

function refreshEnumerationsOnSettingsPage(caller) {
    switch (caller) {
        case "members":
            $('#membersDataTable').DataTable().ajax.reload();
            break;
        case "todoType":
        case "deadlineReferenceType":
            $('#defaultTodoDataTable').DataTable().ajax.reload();
            break;
        case "locations":
            $('#locationsDataTable').DataTable().ajax.reload();
            break;
        case "priceItemTypes":
        case "educationModes":
            $('#priceDefaultDataTable').DataTable().ajax.reload();
            break;
        case "moduleTypes":
            $('#moduleTypeDataTable').DataTable().ajax.reload();
            $('#priceDefaultDataTable').DataTable().ajax.reload();
            break;

    }
}

function preparePriceItemTypeSelector(priceItemType) {

    let $select = $('#defaultPriceItemPriceItemType');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultPriceItemPriceItemType').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'id', labelField: 'name', searchField: 'name', sortField: 'name', options: [],
        load: function(query, callback) {
            $.ajax({
                url: '/data/priceItemTypes', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(priceItemType) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(priceItemType, true);
            }
        },
    });
}

function prepareEducationModeSelector(educationMode) {

    let $select = $('#defaultPriceItemEducationMode');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultPriceItemEducationMode').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'id', labelField: 'name', searchField: 'name', sortField: 'name', options: [],
        load: function(query, callback) {
            $.ajax({
                url: '/data/educationModes', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(educationMode) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(educationMode, true);
            }
        },


    });
}

function prepareShortCodeSelector(shortCode) {

    let $select = $('#defaultPriceItemShortCode');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultPriceItemShortCode').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'shortCode',  labelField: ['shortCode','itemType'], searchField: ['itemType', 'shortCode'], sortField: 'itemType', options: [],
        optgroups: [
            {id: 'Szaktanfolyam', name: 'Szaktanfolyam'},
            {id: 'Szakmai továbbképzés', name: 'Szakmai továbbképzés'},
            {id: 'Kategóriás', name: 'Kategóriás'},
            {id: 'OKJ és hatósági gépkezelő', name: 'OKJ és hatósági gépkezelő'},
        ],
        optgroupField: 'itemFamily', optgroupLabelField: 'name', optgroupValueField: 'id',

        load: function(query, callback) {
            $.ajax({
                url: '/data/moduleTypes', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(shortCode) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(shortCode, true);
            }
        },
        render: {
            option: function(item, escape) {return '<div class="option">' + item.itemType + " ("+ item.shortCode + ")" + '</div>'},
            item: function(data, escape) {return '<div class="item">' + escape(data.itemType) + " " + "<i>("+ escape(data.shortCode) +")</i>" +'</div>';}
        },
    });
}

function resizePanel() {
    let navHeader = $("#navHeader")[0];
    let pillsTab = $("#pills-tab")[0];
    let body = $(".main-body")[0];

    let docH = $(window).height() - navHeader.clientHeight - pillsTab.clientHeight - 220 - (body.offsetTop*2);

    //$('#priceDefaultPanel').css({'height': (docH)+'px'});
    $('#priceDefaultDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#priceDefaultDataTable').DataTable().draw();

    $('#moduleTopicDefaultDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#moduleTopicDefaultDataTable').DataTable().draw();

    $('#appointmentDefaultDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#appointmentDefaultDataTable').DataTable().draw();


    $('#moduleTypeDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#moduleTypeDataTable').DataTable().draw();

    $('#membersDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#membersDataTable').DataTable().draw();

    $('#locationsDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#locationsDataTable').DataTable().draw();

    $('#defaultTodoDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#defaultTodoDataTable').DataTable().draw();

    $('#emailTemplatesDataTable').closest('.dataTables_scrollBody').css('max-height', docH - 150+'px');
    $('#emailTemplatesDataTable').DataTable().draw();
}
//endregion

//region Appointment Default

//region Download
function refreshAppointmentsDefaults() {
    $.ajax({
        url: "../data/appointmentDefaults",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {
            if(resp) dataSet_AppointmentDefault = resp;
            else dataSet_AppointmentDefault = [];
            $('#appointmentDefaultDataTable').DataTable().ajax.reload();
        }
    });
}
//endregion

//region Save
function saveDefaultAppointmentItem() {

    /*
        let id = req.query.id,

        moduleTopicType = req.query.moduleTopicType,

        sequenceNumber = req.query.sequenceNumber,
        start = req.query.start,
        finish = req.query.finish,
        numberOfHours = req.query.numberOfHours,

        name = req.query.name,
        details = req.query.details,

        locationId = req.query.locationId,
        teacherId = req.query.teacherId,

        type = req.query.type,
        format = req.query.format;
     */
    let params =
        "id=" + selectedDefaultAppointmentItem +
        "&moduleTopicType=" + $('#appointmentModalModuleTopicType').val() +
        "&numberOfHours=" + $('#appointmentModalNumberOfHours').val() +
        "&name=" + $('#appointmentModalName').val() +
        "&details=" + $('#appointmentModalDetails').val().replace(/\r|\n/g, '<br />') +
        "&type=" + $('#appointmentDefaultType').val() +
        "&format=" + $('#appointmentDefaultFormat').val();

    $.ajax({
        url: '../data/appointmentDefault?' + params,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az alkalom mentése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshAppointmentsDefaults();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "Az alkalom mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshAppointmentsDefaults();
        }
    });
}
//endregion Save

//region Refresh
function refreshDefaultAppointmentItem(id) {
    $('.tooltip').hide();

    $('#appointmentModalModuleTopicType').val("");

    $('#appointmentModalNumberOfHours').val("");

    $('#appointmentModalName').val("");
    $('#appointmentModalDetails').val("");

    $('#appointmentModalTitle').html("Alkalom hozzáadása");
    selectedDefaultAppointmentItem = 0;

    if (id !== undefined) {
        dataSet_AppointmentDefault.forEach(function (entry) {
            if (entry.id === id) {

                selectedDefaultAppointmentItem = id;

                prepareAppointmentTypeSelector(entry.type);
                preapreAppointmentFormatSelector(entry.format);

                $('#appointmentModalModuleTopicType').val(entry.moduleTopicType);

                $('#appointmentModalNumberOfHours').val(entry.numberOfHours);
                $('#appointmentModalName').val(entry.name);

                if (entry.details != null) {
                    let regex = /<br\s*[\/]?>/gi;
                    let replaced_details= entry.details.replace(regex, "\n");
                    $('#appointmentModalDetails').val(replaced_details);
                }

                $('#appointmentModalTitle').html("Alkalom szerkesztése");
            }
        });
    } else {
        prepareAppointmentTypeSelector();
        preapreAppointmentFormatSelector();
    }
}

function prepareAppointmentTypeSelector(type) {

    let options = [];
    enum_ModuleTopicTypes.forEach(function (item) {
        options.push({id: item.id, title: item.name});
    });

    let $select = $('#appointmentDefaultType');
    if ($select[0].selectize) $select[0].selectize.destroy();

    $select = $('#appointmentDefaultType').selectize({maxItems: 1, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'title', options: options, create: false});
    let selectize = $select[0].selectize;

    if (type) {
        selectize.setValue(type, true);
    }
}

function preapreAppointmentFormatSelector(format) {

    let options = [];
    enum_ModuleTopicFormats.forEach(function (item) {
        options.push({id: item.id, title: item.name});
    });

    let $select = $('#appointmentDefaultFormat');
    if ($select[0].selectize) $select[0].selectize.destroy();

    $select = $('#appointmentDefaultFormat').selectize({maxItems: 1, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'title', options: options, create: false});
    let selectize = $select[0].selectize;

    if (format) {selectize.setValue(format, true);}
}
//endregion Refresh

//region Delete
function confirmDeleteAppointmentDefault(id) {
    if (!confirm("Valóban törölni akarja az alkalmat?")) {return false;}
    else {deleteAppointmentDefault(id);return true;}
}

function deleteAppointmentDefault(id) {
    $('.tooltip').hide();

    let params = "id=" + id;

    $.ajax({
        url: '../data/appointmentDefault?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az alkalom törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshAppointmentsDefaults();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A alkalom törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshAppointmentsDefaults();
        }
    });

}
//endregion Delete

//endregion

//region ModuleTopic Default

//region Download
function refreshModuleTopicDefaults() {
    $.ajax({
        url: "../data/moduleTopicDefaults",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {
            if(resp) dataSet_ModuleTopicDefault = resp;
            else dataSet_ModuleTopicDefault = [];
            $('#moduleTopicDefaultDataTable').DataTable().ajax.reload();
        }
    });
}
//endregion

//region Refresh
function refreshDefaultModuleTopicItem(id) {

    /*
    let id = req.query.id,
    moduleShortCode = req.query.moduleShortCode,
    numberOfHours = req.query.numberOfHours,
    moduleTopicType = req.query.moduleTopicType,
    name = req.query.name,
    details = req.query.details,
    type = req.query.type,
    format = req.query.format;

    let params =
        "id=" + selectedDefaultModuleTopicItem +
        "&moduleShortCode=" +$('#moduleTopicModalModuleShortCode').val() +
        "&moduleTopicType=" +$('#moduleTopicModalModuleTopicType').val() +
        "&numberOfHours=" + $('#moduleTopicModalNumberOfHours').val() +
        "&name=" + $('#moduleTopicModalName').val() +
        "&details=" + $('#moduleTopicModalDetails').val().replace(/\r|\n/g, '<br />') +
        "&type=" + $('#moduleTopicModalType').val() +
        "&format=" + $('#moduleTopicModalFormat').val();
     */
    $('.tooltip').hide();


    $('#moduleTopicModalModuleShortCode').val("");
    $('#moduleTopicModalModuleTopicType').val("");

    $('#moduleTopicModalName').val("");
    $('#moduleTopicModalDetails').val("");

    $('#moduleTopicModalNumberOfHours').val("");

    $('#moduleTopicCommitments').val("");
    $('#moduleTopicRegulations').val("");
    $('#moduleTopicNameOfficial').val("");

    $('#moduleTopicModalTitle').html("Tantárgy hozzáadása");
    selectedDefaultModuleTopicItem = 0;

    if (id !== undefined) {
        dataSet_ModuleTopicDefault.forEach(function (entry) {
            if (entry.id === id) {

                selectedDefaultModuleTopicItem = id;

                prepareModuleTopicTypeSelector(entry.type);
                preapreModuleTopicFormatSelector(entry.format);

                $('#moduleTopicModalNumberOfHours').val(entry.numberOfHours);
                $('#moduleTopicModalModuleTopicType').val(entry.moduleTopicType);
                $('#moduleTopicModalModuleShortCode').val(entry.moduleShortCode);

                $('#moduleTopicModalName').val(entry.name);
                if (entry.details != null) {
                    let regex = /<br\s*[\/]?>/gi;
                    let replaced_details = entry.details.replace(regex, "\n");
                    $('#moduleTopicModalDetails').val(replaced_details);
                }

                $('#moduleTopicModalTitle').html("Tantárgy szerkesztése");

                showOrHideModuleTopipParametersBasedOnModuleTopicType(entry.moduleTopicType);
                if(entry.additionalInformation) {
                    let additionalInfo = JSON.parse(entry.additionalInformation);

                    if(additionalInfo.hasOwnProperty("commitments")) $('#moduleTopicCommitments').val(additionalInfo.commitments);
                    if(additionalInfo.hasOwnProperty("regulations")) $('#moduleTopicRegulations').val(additionalInfo.regulations);
                    if(additionalInfo.hasOwnProperty("nameOfficial")) $('#moduleTopicNameOfficial').val(additionalInfo.nameOfficial);
                }

            }
        });
    } else {
        prepareModuleTopicTypeSelector();
        preapreModuleTopicFormatSelector();
    }
}

function prepareModuleTopicTypeSelector(type) {

    let options = [];
    enum_ModuleTopicTypes.forEach(function (item) {
        options.push({id: item.id, title: item.name});
    });

    let $select = $('#moduleTopicModalType');
    if ($select[0].selectize) $select[0].selectize.destroy();

    $select = $('#moduleTopicModalType').selectize({maxItems: 1, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'title', options: options, create: false});
    let selectize = $select[0].selectize;

    if (type) {
        selectize.setValue(type, true);
    }
}

function preapreModuleTopicFormatSelector(format) {

    let options = [];
    enum_ModuleTopicFormats.forEach(function (item) {
        options.push({id: item.id, title: item.name});
    });

    let $select = $('#moduleTopicModalFormat');
    if ($select[0].selectize) $select[0].selectize.destroy();

    $select = $('#moduleTopicModalFormat').selectize({maxItems: 1, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'title', options: options, create: false});
    let selectize = $select[0].selectize;

    if (format) {selectize.setValue(format, true);}
}
//endregion Refresh

//region Save
function saveDefaultModuleTopicItem() {
    let additionalInfo = {
        "commitments": $('#moduleTopicCommitments').val(),
        "regulations": $('#moduleTopicRegulations').val(),
        "nameOfficial": $('#moduleTopicNameOfficial').val(),
    };

    /*
        let id = req.query.id,

        moduleShortCode = req.query.moduleShortCode,
        numberOfHours = req.query.numberOfHours,
        moduleTopicType = req.query.moduleTopicType,

        name = req.query.name,
        details = req.query.details,

        type = req.query.type,
        format = req.query.format
    ;
     */
    let params =
        "id=" + selectedDefaultModuleTopicItem +

        "&moduleShortCode=" +$('#moduleTopicModalModuleShortCode').val() +
        "&moduleTopicType=" +$('#moduleTopicModalModuleTopicType').val() +
        "&numberOfHours=" + $('#moduleTopicModalNumberOfHours').val() +

        "&name=" + $('#moduleTopicModalName').val() +
        "&details=" + $('#moduleTopicModalDetails').val().replace(/\r|\n/g, '<br />') +

        "&type=" + $('#moduleTopicModalType').val() +
        "&format=" + $('#moduleTopicModalFormat').val() +
        "&additionalInformation=" + JSON.stringify(additionalInfo)
    ;

    $.ajax({
        url: '../data/moduleTopicDefault?' + params,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A tantárgy mentése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshModuleTopicDefaults();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A tantárgy mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshModuleTopicDefaults();
        }
    });
}
//endregion Save

//region Delete
function confirmDeleteModuleTopicDefault(id) {
    if (!confirm("Valóban törölni akarja az tantárgyat?")) {return false;}
    else {deleteModuleTopicDefault(id);return true;}
}

function deleteModuleTopicDefault(id) {
    $('.tooltip').hide();

    let params = "id=" + id;

    $.ajax({
        url: '../data/moduleTopicDefault?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az tantárgy törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshModuleTopicDefaults();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A tantárgy törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshModuleTopicDefaults();
        }
    });

}
//endregion Delete

function showOrHideModuleTopipParametersBasedOnModuleTopicType(moduleTopicType) {
    if (moduleTopicType.indexOf("SZAKMAI") >= 0) {
        $('#moduleTopicCommitmentsGroup').show();
        $('#moduleTopicRegulationsGroup').show();
        $('#moduleTopicNameOfficialGroup').show();
    } else {
        $('#moduleTopicCommitmentsGroup').hide();
        $('#moduleTopicRegulationsGroup').hide();
        $('#moduleTopicNameOfficialGroup').hide();
    }
}

//endregion

//region ModuleType

//region Download
/*function refreshModuleTypes() {
    $.ajax({
        url: "../data/moduleTypes",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {
            if(resp) dataSet_ModuleTypes = resp;
            else dataSet_ModuleTypes = [];
            $('#moduleTypeDataTable').DataTable().ajax.reload();
        }
    });
}*/
//endregion

//region Refresh
function refreshModuleTypeItem(shortCode) {
    $('.tooltip').hide();

    $('#moduleTypeModalTabs-Alapok').removeClass("active");
    $('#moduleTypeModalTabs-Details').removeClass("active");
    $('#moduleTypeModalTabs-Alapok').addClass("active");

    $('#alap').removeClass("active");
    $('#details').removeClass("active");
    $('#alap').addClass("active");

    $('#alap').removeClass("show");
    $('#details').removeClass("show");
    $('#alap').addClass("show");


    $('#moduleTypeShortCode').val("");
    $('#moduleTypeItemFamily').val("");
    $('#moduleTypeItemGroup').val("");
    $('#moduleTypeItemType').val("");
    $('#moduleTypeShortName').val("");


    $('#moduleTypeQualificationProvided').val("");
    $('#moduleTypeNameOfficial').val("");
    $('#moduleTypeRegulations').val("");
    $('#moduleTypeCommitments').val("");
    $('#moduleTypeEquipments').val("");

    $('#moduleTypeModalTitle').html("Képzés típus hozzáadása");

    if (shortCode !== undefined) {

        enum_ModuleTypes.forEach(function (entry) {
            if (entry.shortCode === shortCode) {

                let itemFamily = getItemFamilyByShortCode(shortCode);

                $('#moduleTypeShortCode').val(entry.shortCode) ;
                $('#moduleTypeItemFamily').val(entry.itemFamily) ;
                $('#moduleTypeItemGroup').val(entry.itemGroup) ;
                $('#moduleTypeItemType').val(entry.itemType) ;
                $('#moduleTypeShortName').val(entry.shortName);

                if(entry.additionalInfo != null) {
                    let additionalInfo = JSON.parse(entry.additionalInfo);

                    if(additionalInfo.hasOwnProperty("qualificationProvided")) $('#moduleTypeQualificationProvided').val(additionalInfo.qualificationProvided);
                    if(additionalInfo.hasOwnProperty("nameOfficial")) $('#moduleTypeNameOfficial').val(additionalInfo.nameOfficial);



                    let regex = /<br\s*[\/]?>/gi;

                    if(additionalInfo.hasOwnProperty("commitments")) {
                        let replaced_commitments = additionalInfo.commitments.replace(regex, "\n");
                        $('#moduleTypeCommitments').val(replaced_commitments);
                    }

                    if(additionalInfo.hasOwnProperty("regulations")) {
                        let replaced_regulations = additionalInfo.regulations.replace(regex, "\n");
                        $('#moduleTypeRegulations').val(replaced_regulations);
                    }

                    if(additionalInfo.hasOwnProperty("equipments")) {
                        let replaced_equipments = additionalInfo.equipments.replace(regex, "\n");
                        $('#moduleTypeEquipments').val(replaced_equipments);
                    }

                } else {
                    $('#moduleTypeQualificationProvided').val("");
                    $('#moduleTypeNameOfficial').val("");
                    $('#moduleTypeRegulations').val("");
                    $('#moduleTypeCommitments').val("");
                    $('#moduleTypeEquipments').val("");
                }

                switch (itemFamily) {
                    case "Szaktanfolyamok":
                        $('#moduleTypeQualificationProvidedGroup').show();
                        $('#moduleTypeRegulationsGroup').hide();
                        $('#moduleTypeCommitmentsGroup').hide();
                        $('#moduleTypeEquipmentsGroup').hide();
                        break;
                    case "Kategóriás":
                        $('#moduleTypeQualificationProvidedGroup').show();
                        $('#moduleTypeRegulationsGroup').hide();
                        $('#moduleTypeCommitmentsGroup').hide();
                        $('#moduleTypeEquipmentsGroup').hide();
                        break;
                    case "OKJ és hatósági gépkezelő":

                        $('#moduleTypeQualificationProvidedGroup').hide();
                        $('#moduleTypeRegulationsGroup').hide();
                        $('#moduleTypeCommitmentsGroup').hide();
                        $('#moduleTypeEquipmentsGroup').show();
                        break;
                    case "Szakmai továbbképzés":
                        $('#moduleTypeQualificationProvidedGroup').hide();

                        $('#moduleTypeRegulationsGroup').show();
                        $('#moduleTypeCommitmentsGroup').show();

                        $('#moduleTypeEquipmentsGroup').hide();
                        break;
                }
            }
        });
    }
}
//endregion Refresh

//region Save
function saveModuleTypeItem() {
    let additionalInformation = {};

    if($('#moduleTypeQualificationProvided').val() != "") additionalInformation.qualificationProvided = $('#moduleTypeQualificationProvided').val();
    if($('#moduleTypeNameOfficial').val() != "") additionalInformation.nameOfficial =  $('#moduleTypeNameOfficial').val();

    if($('#moduleTypeRegulations').val() != "") additionalInformation.regulations =  $('#moduleTypeRegulations').val().replace(/\r|\n/g, '<br />');
    if($('#moduleTypeCommitments').val() != "")  additionalInformation.commitments =  $('#moduleTypeCommitments').val().replace(/\r|\n/g, '<br />');
    if($('#moduleTypeEquipments').val() != "")  additionalInformation.equipments =  $('#moduleTypeEquipments').val().replace(/\r|\n/g, '<br />');

    let params =
        "shortCode=" +              $('#moduleTypeShortCode').val() +
        "&itemFamily=" +            $('#moduleTypeItemFamily').val() +
        "&itemGroup=" +             $('#moduleTypeItemGroup').val() +
        "&itemType=" +              $('#moduleTypeItemType').val() +
        "&additionalInfo=" +        JSON.stringify(additionalInformation) +
        "&shortName=" +             $('#moduleTypeShortName').val()
    ;

    $.ajax({
        url: '../data/moduleType?' + params,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A képzés típus mentése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshModuleTypes();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A képzés típus mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshModuleTypes();
        }
    });
}
//endregion Save

//region Delete
function confirmDeleteModuleType(shortCode) {
    if (!confirm("Valóban törölni akarja az képzés típust?")) {return false;}
    else {deleteModuleType(shortCode);return true;}
}

function deleteModuleType(shortCode) {
    $('.tooltip').hide();

    let params = "shortCode=" + shortCode;

    $.ajax({
        url: '../data/moduleType?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A képzés típus törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshModuleTypes();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A képzés típus törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshModuleTypes();
        }
    });

}
//endregion Delete

//endregion ModuleType

//region Member
function refreshMemberItem(memberId) {
    $('.tooltip').hide();

    $('#memberItemName').val("");


    $('#memberItemAdditionalInformation').val("");
    $('#memberItemComment').val("");
    $('#memberItemRelevance').val("");

    $('#memberItemModuleTitle').html("Tag hozzáadása");


    selectedMemberItem = 0;

    if (memberId !== undefined) {
        dataSet_Members.forEach(function (entry) {
            if (entry.memberId === memberId) {

                selectedMemberItem = memberId;

                $('#memberItemName').val(entry.name);
                $('#memberItemAdditionalInformation').val(entry.additionalInfo);

                prepareMemberItemRelevances(entry.relevance);

                let regex = /<br\s*[\/]?>/gi;
                let replaced = entry.comment.replace(regex, "\n");
                $('#memberItemComment').val(replaced);

                $('#memberItemModuleTitle').html("Tag szerkesztése");
            }
        });
    } else {
        prepareMemberItemRelevances();
    }
}

function saveMemberItem() {

    let p =
        "memberId=" + selectedMemberItem +
        "&name=" + $('#memberItemName').val() +
        "&relevance=" + $('#memberItemRelevance').val() +
        "&additionalInfo=" + $('#memberItemAdditionalInformation').val() +
        "&comment=" + $('#memberItemComment').val().replace(/\r|\n/g, '<br />');


    $.ajax({
        url: '../data/member?' + p,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({
                heading: 'Siker!',
                text: 'Az adatok mentése sikeres',
                icon: 'success',
                loader: true,
                loaderBg: '#9EC600',
                allowToastClose: true,
                position: 'top-right'
            });
            refreshMembers();
        },
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({
                heading: 'Hiba!',
                text: "Az adatok mentése sikertelen. Ok: " + message,
                icon: 'error',
                loader: true,
                loaderBg: '#9EC600',
                allowToastClose: true,
                hideAfter: false,
                position: 'top-right'
            });
            refreshMembers();
        }
    });
}

function confirmDeleteMemberItem(id) {
    if (!confirm("Valóban törölni akarja az elemet?")) {return false;}
    else {deleteMemberItem(id);return true;}
}

function deleteMemberItem(id) {
    $('.tooltip').hide();

    let params = "memberId=" + id;

    $.ajax({
        url: '../data/member?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az elem törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshMembers();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A elem törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshMembers();
        }
    });

}

function prepareMemberItemRelevances(relevances) {

    let options = [];

    memberRelevances.forEach(function (item) {options.push({id: item.id, title: item.title});});

    let $select = $('#memberItemRelevance');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#memberItemRelevance').selectize({
        maxItems: null, preload: true, create: false,
        valueField: 'id', labelField: ['title'], searchField: ['title'], sortField: 'title', options: options,
        plugins: ['remove_button'],
    });

    if(relevances) {
        let selectize = $select[0].selectize;
        if(!selectize.isOpen) selectize.setValue(relevances.split(','), true);

    }
}

function getRelevanceNameById(id) {
    let ret = "";
    memberRelevances.forEach(function (item) {
        if(item.id == id) ret = item.title;
    });
    return ret;
}

function getRelevanceNamesByIds(ids) {
    let ret = "";
    let idArray = ids.split(',');

    memberRelevances.forEach(function (item) {
        idArray.forEach((id)=> {
            if(item.id == id) {
                if(ret != "") ret += ", ";
                ret += item.title;
            }
        })

    });
    return ret;
}

//endregion

//region Location

function preparePostalCodeSelector(postalCode) {

    let $select = $('#locationItemPostalCode');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#locationItemPostalCode').selectize({
        maxItems: 1, preload: true, create: true,
        valueField: 'postalCode', labelField: ['postalCode'], searchField: ['postalCode'], sortField: 'postalCode', options: [],
        /*plugins: ['remove_button'],*/
        load: function(query, callback) {
            $.ajax({
                url: '/data/cityByPostalCode?postalCode='+query, type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onChange: function(value) {

            $.ajax({
                url: '/data/cityByPostalCode?postalCode=' + value,
                method: 'GET',dataType: 'json',
                data: {},
                success: function (resp) {
                    if (resp && resp.length > 0) prepareCitySelector(resp[0].city);
                },
            });
        },
        onLoad: function(_) {
            if(postalCode) {
                let selectize = $select[0].selectize;
                if(!Object.keys(selectize.options).includes(postalCode)) selectize.addOption({postalCode:postalCode});
                if(!selectize.isOpen) selectize.setValue(postalCode, true);
            }
        },
    });
}

function prepareCitySelector(city) {

    let $select = $('#locationItemCity');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#locationItemCity').selectize({
        maxItems: 1, preload: true, create: true,
        valueField: 'city', labelField: 'city', searchField: ['city'], sortField: 'city', options: [],
        load: function(query, callback) {
            $.ajax({
                url: '/data/city?city='+query, type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(city) {
                let selectize = $select[0].selectize;
                if(!Object.keys(selectize.options).includes(city)) selectize.addOption({city:city});
                if(!selectize.isOpen) selectize.setValue(city, true);
            }
        },
    });
}

function prepareAddressSelector(address) {

    let $select = $('#locationItemPlaceName');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#locationItemPlaceName').selectize({
        maxItems: 1, preload: true, create: true,
        valueField: 'address', labelField: 'address', searchField: ['address'], sortField: 'address', options: [],
        /*plugins: ['remove_button'],*/
        load: function(query, callback) {
            $.ajax({
                url: '/data/address?address='+query, type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(address) {
                let selectize = $select[0].selectize;
                if(!Object.keys(selectize.options).includes(address)) selectize.addOption({address:address});
                if(!selectize.isOpen) selectize.setValue(address, true);
            }
        },
    });
}

function prepareAddressTypeSelector(addressType) {

    let $select = $('#locationItemPlaceType');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#locationItemPlaceType').selectize({
        maxItems: 1, preload: true, create: true,
        valueField: 'addressType', labelField: 'addressType', searchField: ['addressType'], /*sortField: 'addressType',*/ options: [],
        /*plugins: ['remove_button'],*/
        load: function(query, callback) {
            $.ajax({
                url: '/data/addressType?addressType='+query, type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(addressType) {
                let selectize = $select[0].selectize;
                if(!Object.keys(selectize.options).includes(addressType)) selectize.addOption({addressType:addressType});
                if(!selectize.isOpen) selectize.setValue(addressType, true);
            }
        },
    });
}




function refreshLocationItem(locationId) {
    $('.tooltip').hide();

    $('#locationItemNameShort').val("");
    $('#locationItemNameOfficial').val("");


    $('#locationItemDescription').val("");

    $('#locationItemPostalCode').val("");
    $('#locationItemCity').val("");

    $('#locationItemPlaceName').val("");
    $('#locationItemPlaceType').val("");
    $('#locationItemPlaceNumber').val("");
    $('#locationItemBuilding').val("");
    $('#locationItemStaircase').val("");
    $('#locationItemFloor').val("");
    $('#locationItemDoor').val("");

    $('#locationItemRoomName').val("");

    $('#locationItemRelevance').val("");


    $('#locationItemModuleTitle').html("Helyszín hozzáadása");

    selectedLocationItem = 0;

    if (locationId !== undefined) {
        dataSet_Locations.forEach(function (entry) {
            if (entry.id === locationId) {
                selectedLocationItem = locationId;
                $('#locationItemNameShort').val(entry.nameShort);
                $('#locationItemNameOfficial').val(entry.nameOfficial);
                $('#locationItemDescription').val(entry.description);

                $('#locationItemRoomName').val(entry.roomName);
                $('#locationItemRelevance').val(entry.relevance);


                $('#locationItemPlaceNumber').val(entry.placeNumber);
                $('#locationItemBuilding').val(entry.building);
                $('#locationItemStaircase').val(entry.staircase);
                $('#locationItemFloor').val(entry.floor);
                $('#locationItemDoor').val(entry.door);

                /*
                $('#locationItemPostalCode').val(entry.postalCode);
                $('#locationItemCity').val(entry.city);
                $('#locationItemPlaceName').val(entry.placeName);
                $('#locationItemPlaceType').val(entry.placeType);
                 */

                preparePostalCodeSelector(entry.postalCode);
                prepareCitySelector(entry.city);
                prepareAddressSelector(entry.placeName);
                prepareAddressTypeSelector(entry.placeType);


                $('#locationItemModuleTitle').html("Helyszín szerkesztése");
            }
        });
    } else {
        preparePostalCodeSelector();
        prepareCitySelector();
        prepareAddressSelector();
        prepareAddressTypeSelector();
    }
}

function saveLocationItem() {

    let p =
        "id=" + selectedLocationItem +
        "&nameShort=" + $('#locationItemNameShort').val() +
        "&nameOfficial=" + $('#locationItemNameOfficial').val() +
        "&description=" + $('#locationItemDescription').val() +
        "&postalCode=" + $('#locationItemPostalCode').val() +
        "&city=" + $('#locationItemCity').val() +
        "&placeName=" + $('#locationItemPlaceName').val() +
        "&placeType=" + $('#locationItemPlaceType').val() +
        "&placeNumber=" + $('#locationItemPlaceNumber').val() +
        "&building=" + $('#locationItemBuilding').val() +
        "&staircase=" + $('#locationItemStaircase').val() +
        "&floor=" + $('#locationItemFloor').val() +
        "&door=" + $('#locationItemDoor').val() +
        "&relevance=" + $('#locationItemRelevance').val() +
        "&roomName=" + $('#locationItemRoomName').val();


    $.ajax({
        url: '../data/location?' + p,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({
                heading: 'Siker!',
                text: 'Az adatok mentése sikeres',
                icon: 'success',
                loader: true,
                loaderBg: '#9EC600',
                allowToastClose: true,
                position: 'top-right'
            });
            refreshLocations();
        },
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({
                heading: 'Hiba!',
                text: "Az adatok mentése sikertelen. Ok: " + message,
                icon: 'error',
                loader: true,
                loaderBg: '#9EC600',
                allowToastClose: true,
                hideAfter: false,
                position: 'top-right'
            });
            refreshLocations();
        }
    });
}

function duplicateLocationItem(locationId) {

    $.ajax({
        url: '../data/duplicateLocation?id=' + locationId,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A duplikálás sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshLocations();
        },
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A duplikálás sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshLocations();
        }
    });
}



function confirmDeleteLocationItem(id) {
    if (!confirm("Valóban törölni akarja az elemet?")) {return false;}
    else {deleteLocationItem(id);return true;}
}

function deleteLocationItem(id) {
    $('.tooltip').hide();

    let params = "id=" + id;

    $.ajax({
        url: '../data/location?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az elem törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshLocations();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A elem törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshLocations();
        }
    });

}

//endregion

//region Price Default
function refreshPriceDefaults() {
    $('.tooltip').hide();

    $.ajax({
        url: "../data/pricedefaults",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {
            if(resp) dataSet_PriceDefault = resp;
            else dataSet_PriceDefault = [];
            $('#priceDefaultDataTable').DataTable().ajax.reload();

        }
    });

}

function refreshDefaultPriceItem(id) {

    $('#defaultPriceItemItemDescription').val("");
    $('#defaultPriceItemPrice').val(0);

    selectedDefaultPriceItem = 0;

    $('#defaultPriceItemModuleTitle').html("Alapértelmezett ár létrehozása");

    if (id !== undefined) {
        dataSet_PriceDefault.forEach(function (entry) {
            if (entry.id === id) {
                selectedDefaultPriceItem = id;

                $('#defaultPriceItemPrice').val(entry.price);
                $('#defaultPriceItemItemDescription').val(entry.itemDescription);

                prepareEducationModeSelector(entry.educationMode);
                preparePriceItemTypeSelector(entry.priceItemType);
                prepareShortCodeSelector(entry.shortCode);

                $('#defaultPriceItemModuleTitle').html("Alapértelmezett ár szerkesztése");
            }
        });
    } else {
        prepareEducationModeSelector();
        preparePriceItemTypeSelector();
        prepareShortCodeSelector();
    }
}

function saveDefaultPriceItem() {

    let p =
        "id=" + selectedDefaultPriceItem +
        "&shortCode=" + $('#defaultPriceItemShortCode').val() +
        "&priceItemType=" + $('#defaultPriceItemPriceItemType').val() +
        "&educationMode=" + $('#defaultPriceItemEducationMode').val() +
        "&price=" + $('#defaultPriceItemPrice').val() +
        "&itemDescription=" + $('#defaultPriceItemItemDescription').val();


    $.ajax({
        url: '../data/pricedefault?' + p,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az adatok mentése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshPriceDefaults();
        },
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "Az adatok mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshPriceDefaults();
        }
    });
}

function confirmDeletePriceItem(id) {
    if (!confirm("Valóban törölni akarja az elemet?")) {return false;}
    else {deletePriceItem(id);return true;}
}

function deletePriceItem(id) {
    $('.tooltip').hide();

    let params = "id=" + id;

    $.ajax({
        url: '../data/pricedefault?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az elem törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshPriceDefaults();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "A elem törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshPriceDefaults();
        }
    });

}

function duplicatePriceDefaultItem(id) {

    $.ajax({
        url: '../data/duplicateDefaultPriceItem?id=' + id,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A duplikálás sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshPriceDefaults();
        },
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A duplikálás sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshPriceDefaults();
        }
    });
}

function prepare_settings_filter_defaultPrices_ModuleShortCode() {

    let options = [];
    enum_ModuleTypes.forEach(function (item) {
        options.push({
            id: item.shortCode,
            title: item.shortCode + " (" + item.itemFamily + " / " + item.itemGroup + " / " + item.itemType + ")"
        });
    });

    let $select = $('#settings_filter_defaultPrices_moduleShortCode');
    if ($select[0].selectize) $select[0].selectize.destroy();
    $select = $('#settings_filter_defaultPrices_moduleShortCode').selectize({maxItems: 1, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'title', options: options, create: false});
}

function filterDefaultPrices() {


    let shortCode = $('#settings_filter_defaultPrices_moduleShortCode').val();
    let itemType = "";
    enum_ModuleTypes.forEach(function (item) {if(item.shortCode == shortCode) { itemType = "("+item.itemType+")";}});


    $("#priceDefaultDataTable_filter").find("input").focus();
    $("#priceDefaultDataTable_filter").find("input").val(itemType);
    $("#priceDefaultDataTable").DataTable().search(itemType).draw();
    
}
//endregion

//region Backups

function refreshBackups() {
    $.ajax({
        url: "../data/backups", method: 'GET', dataType: 'json',
        success: function(resp) {
            dataSet_Backups = resp.message;
            $('#backupDataTable').DataTable().ajax.reload();
        }
    });
}

function createBackup() {
    $.toaster({heading: 'Siker!', text: 'Biztonsági mentés elindítva', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
    $.ajax({
        url: '../data/createBackup',
        method: 'PUT',
        success: function() {
            $.toaster({heading: 'Siker!', text: 'Sikeres biztonsági mentés', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshBackups()
        },
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "Sikertelen biztonsági mentés. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }

    });
}

function confirmRestore(created) {

    if (!confirm("A visszaállítás a következő adatokat érinti:\n - A)\n - B)\n - C)\n - D)\nValóban ezt akarja?")) {
        return false;
    } else {
        $.ajax({
            url: '../data/restoreBackup?created='+parseInt(created),
            method: 'PUT',
            success: function() {
                $.toaster({heading: 'Siker!', text: 'Sikeres visszaállítás', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
                refreshBackups();
            },
            error: function (response) {
                let message = "";
                if (response.responseJSON) message = response.responseJSON.message;
                else message = response.responseText;
                $.toaster({heading: 'Hiba!', text: "Sikertelen visszaállítás. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            }
        });
        return true;
    }
}

function confirmDeleteBackup(created) {

    if (!confirm("Valóban törölni akarja a biztonsági mentést?")) {
        return false;
    } else {
        $.ajax({
            url: '../data/deleteBackup?created='+parseInt(created),
            method: 'PUT',
            data: {},
            success: function() {
                $.toaster({heading: 'Siker!', text: 'A biztonsági mentés törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
                refreshBackups();
            },
            error: function (response) {
                let message = "";
                if (response.responseJSON) message = response.responseJSON.message;
                else message = response.responseText;
                $.toaster({heading: 'Hiba!', text: "A biztonsági mentés törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            }
        });
        return true;
    }
}
//endregion

//region DefaultTodos

//region Download
function refreshDefaultTodos() {
    $.ajax({
        url: "../data/defaultTodos",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {
            if(resp) dataSet_DefaultTodos = resp;
            else dataSet_DefaultTodos = [];
            $('#defaultTodoDataTable').DataTable().ajax.reload();
        }
    });
}
//endregion

//region Save
function saveDefaultTodoItem() {

    /*
        let id = req.query.id,

        moduleShortCode = req.query.moduleShortCode,
        educationModes = req.query.educationModes,
        type = req.query.type,

        title = req.query.title,
        details = req.query.details,

        relativeReferenceType = req.query.relativeReferenceType,
        relativeDeadline = tryParseInt(req.query.relativeDeadline, 0),
        relativeNotification = tryParseInt(req.query.relativeNotification, 0),

        defaultResponsibles = req.query.defaultResponsibles
    ;

     */

    let params =
        "id="                       + selectedDefaultTodoItem +
        "&moduleShortCode="         + $('#defaultTodoModalModuleShortCode').val() +
        "&educationModes="          + $('#defaultTodoModaleducationModes')[0].selectize.getValue().toString() +
        "&moduleTopic="             + $('#defaultTodoModalModuleTopic').val() +

        "&type="                    + $('#defaultTodoModalType').val() +
        "&title="                   + $('#defaultTodoModalTitle').val() +
        "&details="                 + $('#defaultTodoModalDetails').val().replace(/\r|\n/g, '<br />') +

        "&relativeReferenceType="   + $('#defaultTodoModalReferenceType').val() +
        "&relativeDeadline="        + $('#defaultTodoModalDeadline').val()+
        "&relativeNotification="    + $('#defaultTodoModalNotification').val() +
        "&defaultDeadline="         + $('#defaultTodoModalDefaultDeadline').val() +
        "&defaultNotification="     + $('#defaultTodoModalDefaultNotification').val();
    $.ajax({
        url: '../data/defaultTodo?' + params,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A elem mentése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshDefaultTodos();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "Az elem mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshDefaultTodos();
        }
    });
}
//endregion Save

//region Refresh
function refreshDefaultTodoItem(id) {
    $('.tooltip').hide();



    $('#defaultTodoModalModuleShortCode').val("") ;
    $('#defaultTodoModaleducationModes').val("") ;

    $('#defaultTodoModalType').val("") ;
    $('#defaultTodoModalTitle').val("") ;
    $('#defaultTodoModalDetails').val("");

    $('#defaultTodoModalReferenceType').val("") ;
    $('#defaultTodoModalDeadline').val(10);
    $('#defaultTodoModalNotification').val(10);


    $('#defaultTodoModalDefaultDeadline').val(10);
    $('#defaultTodoModalDefaultNotification').val(10);

    $('#defaultTodoModalResponsibles').val("");
    $('#defaultTodoModalModuleTopic').val("");

    $('#defaultTodoItemModuleTitle').html("Alapértelmezett teendő hozzáadása");
    selectedDefaultTodoItem = 0;

    if (id !== undefined) {
        dataSet_DefaultTodos.forEach(function (entry) {
            if (entry.id === id) {
                /*
                    "id": row.id,

                    "moduleShortCode": row.moduleShortCode,
                    "educationModes": row.educationModes,
                    "type": row.type,

                    "title": row.title,
                    "details": row.details,

                    "relativeReferenceType": row.relativeReferenceType,
                    "relativeDeadline": row.relativeDeadline,
                    "relativeNotification": row.relativeNotification,

                    "defaultResponsibles": row.defaultResponsibles,
                 */

                selectedDefaultTodoItem = id;

                prepareDefaultTodoItemModuleTypeSelector(entry.moduleShortCode);
                prepareDefaultTodoItemEducationModeSelector(entry.educationModes);
                prepareDefaultTodoItemTypeSelector(entry.type);
                $('#defaultTodoModalModuleTopic').val(entry.moduleTopic);


                $('#defaultTodoModalTitle').val(entry.title) ;
                if (entry.details != null) {
                    let regex = /<br\s*[\/]?>/gi;
                    let replaced_details= entry.details.replace(regex, "\n");
                    $('#defaultTodoModalDetails').val(replaced_details);
                }


                prepareDefaultTodoItemReferenceTypeSelector(entry.relativeReferenceType);

                $('#defaultTodoModalDeadline').val(entry.relativeDeadline);
                $('#defaultTodoModalNotification').val(entry.relativeNotification);

                $('#defaultTodoModalDefaultDeadline').val(entry.defaultDeadline);
                $('#defaultTodoModalDefaultNotification').val(entry.defaultNotification);



                $('#defaultTodoItemModuleTitle').html("Alapértelmezett teendő szerkesztése");
            }
        });
    } else {
        prepareDefaultTodoItemModuleTypeSelector();
        prepareDefaultTodoItemEducationModeSelector();
        prepareDefaultTodoItemTypeSelector();
        prepareDefaultTodoItemReferenceTypeSelector();
    }
}

function prepareDefaultTodoItemModuleTypeSelector(shortCode) {

    let options = [],
        optgroupMap = new Map(), optgroupArray = [];

    enum_ModuleTypes.forEach(function (item) {

        options.push({
            id: item.shortCode,
            title: item.shortCode + " (" + item.itemFamily + " / " + item.itemGroup + " / " + item.itemType + ")",
            itemFamily : item.itemFamily + " / " +item.itemGroup

        });

        if(!optgroupMap.has(item.itemFamily + " / " + item.itemGroup)) {
            optgroupMap.set( item.itemFamily + " / " + item.itemGroup, {
                "id" : item.itemFamily + " / " + item.itemGroup,
                "name": item.itemFamily + " / " + item.itemGroup
            });
        }
    });

    for(let key of optgroupMap.keys()) {optgroupArray.push(optgroupMap.get(key));}

    optgroupArray.sort(function (a, b) {return a.name.localeCompare(b.name, 'hu');});

    let $select = $('#defaultTodoModalModuleShortCode');
    if ($select[0].selectize) $select[0].selectize.destroy();

    $select = $('#defaultTodoModalModuleShortCode').selectize({
        maxItems: 1, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'itemFamily', options: options, create: false,
        optgroups: optgroupArray,
        optgroupLabelField: 'name', optgroupValueField: 'id',
        optgroupField: 'itemFamily',
    });

    if (shortCode) {
        let selectize = $select[0].selectize;
        selectize.setValue(shortCode, true);
    }
}

function prepareDefaultTodoItemEducationModeSelector(educationMode) {

    let $select = $('#defaultTodoModaleducationModes');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultTodoModaleducationModes').selectize({
        maxItems: null, preload: true, create: false,
        valueField: 'id', labelField: 'name', searchField: ['name'], sortField: 'name', options: [],
        delimiter: ',',    plugins: ['remove_button'],
        load: function(query, callback) {
            $.ajax({
                url: '/data/educationModes', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(educationMode) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(educationMode.split(','), true);
            }
        },
    });
}

function prepareDefaultTodoItemTypeSelector(type) {

    let $select = $('#defaultTodoModalType');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultTodoModalType').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'id', labelField: 'name', searchField: ['name'], sortField: 'name', options: [],
        load: function(query, callback) {
            $.ajax({
                url: '/data/todotypes', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(type) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(type, true);
            }
        },
    });
}

function prepareDefaultTodoItemReferenceTypeSelector(type) {


    let $select = $('#defaultTodoModalReferenceType');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultTodoModalReferenceType').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'id', labelField: 'name', searchField: ['name'], sortField: 'name', options: [],
        load: function(query, callback) {
            $.ajax({
                url: '/data/deadlineReferenceTypes', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(type) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(type, true);
            }
        },
    });
}

/*
function prepareDefaultTodoItemResponsiblesSelector(responsibles) {
    let $select = $('#defaultTodoModalResponsibles');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#defaultTodoModalResponsibles').selectize({
        maxItems: null, preload: true, create: false,
        valueField: 'username', labelField: 'displayName', searchField: ['displayName'], sortField: 'displayName', options: [],
        delimiter: ',',    plugins: ['remove_button'],
        load: function(query, callback) {
            $.ajax({
                url: '/data/users', type: 'GET', dataType: 'json',
                error: function(error) {callback();},
                success: function(res) {callback(res);}
            });
        },
        onLoad: function(_) {
            if(responsibles) {
                let selectize = $select[0].selectize;
                if(!selectize.isOpen)  selectize.setValue(responsibles.split(','), true);
            }
        },
    });
}
*/

//endregion Refresh

//region Delete
function confirmDeleteDefaultTodo(id) {
    if (!confirm("Valóban törölni akarja az elemet?")) {return false;}
    else {deleteDefaultTodo(id);return true;}
}

function deleteDefaultTodo(id) {
    $('.tooltip').hide();

    let params = "id=" + id;

    $.ajax({
        url: '../data/defaultTodo?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az elem törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshDefaultTodos();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "Az elem törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshDefaultTodos();
        }
    });

}
//endregion Delete

//endregion DefaultTodos

//region EmailTemplates

//region Download
function refreshEmailTemplates() {
    $.ajax({
        url: "../data/emailTemplates",
        method: 'GET',
        dataType: 'json',
        success: function (resp) {
            if(resp) dataSet_EmailTemplates = resp;
            else dataSet_EmailTemplates = [];
            $('#emailTemplatesDataTable').DataTable().ajax.reload();
        }
    });
}
//endregion

//region Save
function saveEmailTemplateItem() {

    let params =
        "id="                       + selectedEmailTemplateItem +
        "&name="                    + $('#emailTemplateItemName').val() +
        "&subject="                    + $('#emailTemplateItemSubject').val() +
        "&message="                 + $('#emailTemplateItemMessage').val().replace(/\r|\n/g, '<br />')   +
        "&relevance="               + $('#emailTemplateItemRelevance')[0].selectize.getValue().toString();
    $.ajax({
        url: '../data/emailTemplate?' + params,
        method: 'PUT',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'A elem mentése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshEmailTemplates();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "Az elem mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshEmailTemplates();
        }
    });
}
//endregion Save

//region Refresh
function refreshEmailTemplateItem(id) {
    $('.tooltip').hide();

    $('#emailTemplateItemName').val("") ;
    $('#emailTemplateItemSubject').val("") ;
    $('#emailTemplateItemMessage').val("") ;


    $('#emailTemplateModalTitle').html("Email sablon hozzáadása");
    selectedEmailTemplateItem = 0;

    if (id !== undefined) {
        dataSet_EmailTemplates.forEach(function (entry) {
            if (entry.id === id) {

                selectedEmailTemplateItem = id;

                $('#emailTemplateItemName').val(entry.name);
                $('#emailTemplateItemSubject').val(entry.subject);

                let regex = /<br\s*[\/]?>/gi;
                let replaced_content = entry.message.replace(regex, "\n");
                $('#emailTemplateItemMessage').val(replaced_content);

                prepareEmailTemplateItemRelevance(entry.relevance);

                $('#emailTemplateModalTitle').html("Email sablon szerkesztése");
            }
        });
    } else {
        prepareEmailTemplateItemRelevance();
    }
}

function prepareEmailTemplateItemRelevance(relevance) {

    let options = [],
        optgroupMap = new Map(), optgroupArray = [];

    enum_ModuleTypes.forEach(function (item) {

        options.push({
            id: item.shortCode,
            title: item.shortCode + " (" + item.itemFamily + " / " + item.itemGroup + " / " + item.itemType + ")",
            itemFamily : item.itemFamily + " / " +item.itemGroup

        });

        if(!optgroupMap.has(item.itemFamily + " / " + item.itemGroup)) {
            optgroupMap.set( item.itemFamily + " / " + item.itemGroup, {
                "id" : item.itemFamily + " / " + item.itemGroup,
                "name": item.itemFamily + " / " + item.itemGroup
            });
        }
    });

    for(let key of optgroupMap.keys()) {optgroupArray.push(optgroupMap.get(key));}

    optgroupArray.sort(function (a, b) {return a.name.localeCompare(b.name, 'hu');});

    let $select = $('#emailTemplateItemRelevance');
    if ($select[0].selectize) $select[0].selectize.destroy();

    $select = $('#emailTemplateItemRelevance').selectize({
        maxItems: null, valueField: 'id', labelField: 'title', searchField: 'title', sortField: 'itemFamily', options: options, create: false,
        plugins: ['remove_button'], delimiter: ',',
        optgroups: optgroupArray,
        optgroupLabelField: 'name', optgroupValueField: 'id',
        optgroupField: 'itemFamily',
    });

    if(relevance) {
        let selectize = $select[0].selectize;
        if(!selectize.isOpen) selectize.setValue(relevance.split(','), true);

    }
}

//endregion Refresh

//region Delete
function confirmDeleteEmailtemplateItem(id) {
    if (!confirm("Valóban törölni akarja az elemet?")) {return false;}
    else {deleteEmailtemplateItem(id);return true;}
}

function deleteEmailtemplateItem(id) {
    $('.tooltip').hide();

    let params = "id=" + id;

    $.ajax({
        url: '../data/emailTemplate?' + params,
        method: 'DELETE',
        data: {},
        success: function () {
            $.toaster({heading: 'Siker!', text: 'Az elem törlése sikeres', icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, position: 'top-right'});
            refreshEmailTemplates();
        },
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;

            $.toaster({heading: 'Hiba!', text: "Az elem törlése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
            refreshEmailTemplates();
        }
    });

}
//endregion Delete

//endregion EmailTemplates