function saveDevice() {

    let url = "../data/modifyDevice";
    if($('#modalDeviceEditor_DeviceSelector').val() == 0) url = "../data/device";

    $.ajax({
        url: url,
        method: 'PUT',
        data: {
            "deviceId": $('#modalDeviceEditor_DeviceSelector').val(),
            "deviceName": $('#modalDeviceEditor_Name').val(),
            "deviceType": $('#modalDeviceEditor_deviceType').val(),
            "MAC_address": $('#modalDeviceEditor_MAC').val(),
        },
        success: function () {$.toaster({heading: 'Siker!', text: "A mentés sikeres", icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: 10000, position: 'top-right'});},
        error: function (response) {
            let message = "";
            if(response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A mentés sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }
    });
}

function refreshDeviceEditorModal() {
    prepareDeviceSelector();
    prepareDeviceTypeSelector();

    $('#modalDeviceEditor_MAC').val("");
    $('#modalDeviceEditor_Name').val("");
}

function prepareDeviceSelector(deviceId) {

    let $select = $('#modalDeviceEditor_DeviceSelector');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#modalDeviceEditor_DeviceSelector').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'deviceId',  searchField: ['deviceName', 'deviceType'], sortField: 'deviceName', options: [], labelField: 'deviceName',
        /*render: {
            option: function(data, escape) {return '<div class="option">' + '<span><b>' + escape(data.deviceName) + '</b></span>' + ' <span><i>(' + escape(data.deviceType) + ')</i></span>' + '</div>';},
            item: function(data, escape) {return '<div class="item">' + '<span><b>' + escape(data.deviceName) + '</b></span> ' + ' <span><i>(' + escape(data.deviceType) + ')</i></span>' + '</div>';}
        },*/
        load: function (query, callback) {
            $.ajax({
                url: '/data/devices', type: 'GET', dataType: 'json',
                error: function (error) {callback();},
                success: function (res) {callback(res);}
            });
        },
        onLoad: function (_) {
            let selectize = $select[0].selectize;

            if (deviceId) {
                if (!selectize.isOpen) selectize.setValue(deviceId, true);
            }

            selectize.addOption({
                deviceId:'0',
                deviceName: '< Új elem >',
                deviceType: '0',
                MAC_Address: '0',
            });
            selectize.refreshOptions() ;
            selectize.addItem('0');
        },
        onChange: function (value) {

            let id = "";
            Object.values($select[0].selectize.options).forEach(function (item) {if (item.deviceId === value) {id = item.deviceId;}});

            $.ajax({
                url: '/data/device?deviceId=' + id, type: 'GET', dataType: 'json',
                error: function (error) {console.log(error)},
                success: function (res) {
                    if (res != undefined) {
                        $('#modalDeviceEditor_MAC').val(res.MAC_Address);
                        $('#modalDeviceEditor_Name').val(res.deviceName);
                        prepareDeviceTypeSelector(res.deviceType);
                    }
                }
            });
        }
    });
}

function prepareDeviceTypeSelector(deviceType) {

    let $select = $('#modalDeviceEditor_deviceType');
    if ($select[0].selectize) {$select[0].selectize.off('change');$select[0].selectize.destroy();}

    $select = $('#modalDeviceEditor_deviceType').selectize({
        maxItems: 1, preload: true, create: false,
        valueField: 'id', labelField: 'name', searchField: ['name'], sortField: 'name', options: [],
        load: function (query, callback) {
            $.ajax({
                url: '/data/deviceTypes', type: 'GET', dataType: 'json',
                error: function (error) {callback();},
                success: function (res) {callback(res);}
            });
        },
        onLoad: function (_) {
            if (deviceType) {
                let selectize = $select[0].selectize;
                if (!selectize.isOpen) selectize.setValue(deviceType, true);
            }
        },
    });
}

function confirmDeleteDevice() {
    if (!confirm("Valóban törölni akarja a bejegyzést?")) {return false;}
    else {deleteDevice();return true;}


}

function deleteDevice() {

    let url = "../data/device";

    $.ajax({
        url: url,
        method: 'DELETE',
        data: {
            "deviceId": $('#modalDeviceEditor_DeviceSelector').val(),
        },
        success: function () {$.toaster({heading: 'Siker!', text: "A törlés sikeres", icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: 10000, position: 'top-right'});},
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A törlés sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }
    });
}

function rebuildDeviceList() {

    let menu_jquery = $('#btnGroupDeviceListItems');
    menu_jquery.empty();

    devices.forEach(item=> {
        if(item.deviceType == layoutType) createDeviceListItem(item.deviceName, item.deviceId, item.connectionStatus);
    });
}

function createDeviceListItem(itemName, id, connectionStatus) {
    //<li class="dropdown-item"><a href="#!"><i class="far fa-file"></i> Jelenléti ív</a></li>

    //<a class="dropdown-item" onclick="showData('egy')"   href="#"><i class="fab fa-bluetooth goodColor"></i> Egy</a>

    let item = document.createElement("a");
    item.className = "dropdown-item";
    item.setAttribute('href', "#" );
    item.setAttribute('onclick', "showData('" + id +"')");

    let icon = document.createElement("i");
    icon.className = "fab fa-bluetooth ";
    if(connectionStatus == "CONNECTED") icon.className += "goodColor";
    else icon.className += "badColor";

    item.appendChild(icon);
    item.appendChild(document.createTextNode(" "+itemName));

    let menu_js = document.getElementById("btnGroupDeviceListItems");
    menu_js.appendChild(item);
}