function saveRFID_DeviceData() {

    let url = "../data/modifyRFID_Device";
    if($('#modalRFIDEditor_id').val() == 0) url = "../data/RFID_device";


    $.ajax({
        url: url,
        method: 'PUT',
        data: {
            "id": $('#modalRFIDEditor_id').val(),
            "deviceId": $('#modalRFIDEditor_deviceID').val(),
            "timeStampFrom": moment($('#modalRFIDEditor_dateFrom').val()).valueOf(),
            "timeStampTo": moment($('#modalRFIDEditor_dateTo').val()).valueOf(),
            "rfid": $('#modalRFIDEditor_rfid').val(),
        },
        success: function () {$.toaster({heading: 'Siker!', text: "A mentés sikeres", icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: 10000, position: 'top-right'});},
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A beállítások mentése sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }
    });
}

function deleteRFID_DeviceData() {

    let url = "../data/RFID_device";

    $.ajax({
        url: url,
        method: 'DELETE',
        data: {
            "id": $('#modalRFIDEditor_id').val(),
        },
        success: function () {$.toaster({heading: 'Siker!', text: "A törlés sikeres", icon: 'success', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: 10000, position: 'top-right'});},
        error: function (response) {
            let message = "";
            if (response.responseJSON) message = response.responseJSON.message;
            else message = response.responseText;
            $.toaster({heading: 'Hiba!', text: "A törlés sikertelen. Ok: " + message, icon: 'error', loader: true, loaderBg: '#9EC600', allowToastClose: true, hideAfter: false, position: 'top-right'});
        }
    });
}

function refreshRFIDEditorModal() {

    let dateTo = moment().endOf('day').valueOf();
    let dateFrom = moment().endOf('day').subtract(1, 'day').valueOf();
    $('#modalRFIDEditor_dateFrom').val(moment(dateFrom).format('YYYY-MM-DDTHH:mm'));
    $('#modalRFIDEditor_dateTo').val(moment(dateTo).format('YYYY-MM-DDTHH:mm'));
    prepareRFIDDeviceSelector();

    prepareRFIDSelector();


}

function prepareRFIDSelector(id) {

    let $select = $('#modalRFIDEditor_id');
    if ($select[0].selectize) {
        $select[0].selectize.off('change');
        $select[0].selectize.destroy();
    }

    $select = $('#modalRFIDEditor_id').selectize({
            maxItems: 1, preload: true, create: false,
            valueField: 'id', searchField: ['deviceName'], sortField: 'deviceName', options: [],
            render: {
                option: function (data, escape) {
                    if(data.timeStampTo > 0 && data.timeStampFrom > 0)
                        return '<div class="option">' + '<span><b>' + escape(getDeviceNameById(data.deviceId)) + '</b></span>' + ' <span><i>(' + escape(moment(data.timeStampFrom).format('YYYY.MM.DD. HH:mm')) + " - " + escape(moment(data.timeStampTo).format('HH:mm')) + ')</i></span>' + '</div>';
                    else
                        return '<div class="option">' + '<span><b>' + escape(data.deviceId) + '</b></span></div>';
                },
                item: function (data, escape) {
                    if(data.timeStampTo > 0 && data.timeStampFrom > 0)
                        return '<div class="item">' + '<span><b>' + escape(getDeviceNameById(data.deviceId)) + '</b></span>' + ' <span><i>(' + escape(moment(data.timeStampFrom).format('YYYY.MM.DD. HH:mm')) + " - " + escape(moment(data.timeStampTo).format('HH:mm')) + ')</i></span>' + '</div>';
                    else
                        return '<div class="item">' + '<span><b>' + escape(data.deviceId) + '</b></span></div>';
                }
            },
            load: function (query, callback) {
                $.ajax({
                    url: '/data/RFID_devices', type: 'GET', dataType: 'json',
                    error: function (error) {
                        callback();
                    },
                    success: function (res) {
                        callback(res);
                    }
                });
            },
            onLoad: function (_) {
                let selectize = $select[0].selectize;

                if (id) {if (!selectize.isOpen) selectize.setValue(id, true);}

                selectize.addOption({
                    id:'0',
                    deviceId: '< Új elem >',
                    rfid: '0',
                    timeStampFrom: 0,
                    timeStampTo: 0,
                });
                selectize.refreshOptions() ;
                selectize.addItem('0');

            },
            onChange: function (value) {

                if(value == "0") {
                    $('#modalRFIDEditor_deviceID').val("");

                    let $select = $('#modalRFIDEditor_deviceID');
                    if ($select[0].selectize) {
                        $select[0].selectize.off('change');
                        $select[0].selectize.destroy();
                    }

                    prepareRFIDDeviceSelector();

                    $('#modalRFIDEditor_dateFrom').val(moment().format('YYYY-MM-DDTHH:mm'));
                    $('#modalRFIDEditor_dateTo').val(moment().format('YYYY-MM-DDTHH:mm'));

                    $('#modalRFIDEditor_rfid').val("");

                } else {
                    let id = "";
                    Object.values($select[0].selectize.options).forEach(function (item) {
                        if (item.id === value) {
                            id = item.id;

                            $('#modalRFIDEditor_dateFrom').val(moment(item.timeStampFrom).format('YYYY-MM-DDTHH:mm'));
                            $('#modalRFIDEditor_dateTo').val(moment(item.timeStampTo).format('YYYY-MM-DDTHH:mm'));

                            $('#modalRFIDEditor_rfid').val(item.rfid);

                            prepareRFIDDeviceSelector(item.deviceId);

                        }
                    });
                }
            }
        }
    );
}

function prepareRFIDDeviceSelector(deviceId) {

        let $select = $('#modalRFIDEditor_deviceID');
        if ($select[0].selectize) {
            $select[0].selectize.off('change');
            $select[0].selectize.destroy();
        }

        $select = $('#modalRFIDEditor_deviceID').selectize({
            maxItems: 1,
            preload: true,
            create: false,
            valueField: 'deviceId',
            searchField: ['deviceName'],
            sortField: 'deviceName',
            options: [],
            labelField: 'deviceName',
            load: function (query, callback) {
                $.ajax({
                    url: '/data/devices', type: 'GET', dataType: 'json',
                    error: function (error) {
                        callback();
                    },
                    success: function (res) {
                        callback(res);
                    }
                });
            },
            onLoad: function (_) {
                if (deviceId) {
                    let selectize = $select[0].selectize;
                    if (!selectize.isOpen) selectize.setValue(deviceId, true);
                }
            },
        });
    }

function confirmDeleteRFID_DeviceData() {
    if (!confirm("Valóban törölni akarja a bejegyzést?")) {return false;}
    else {deleteRFID_DeviceData();return true;}
}