let enum_Roles = [],
    enum_ModuleTopicTypes = [],
    enum_ModuleTopicFormats = [],
    enum_Statuses = [],
    enum_Results = [],
    enum_PaymentMethods = [],
    enum_PaymentModes = [],
    enum_ModuleTypes = [],
    enum_EducationModes = [],
    enum_PriceItemTypes = [],
    enum_Categories = [],
    enum_DocumentTypes = [],
    enum_DocumentCategories = [],
    enum_UserRoles = [],
    enum_TodoType = [],
    enum_RepeatType = [],
    enum_DeadlineReferenceType = [],

    enum_EventResults = [],
    enum_EventOperations = [],

    dataSet_Tags = [],

    dataSet_Locations = [],
    dataSet_Members = [],

    enumerationRefreshCallbacks = [],

    devices = []
;



function refreshEnumerationData(dataToRefresh) {
    switch (dataToRefresh) {
        case "device":                  refreshDevices(); break;

        case "status":                  refreshStatuses(); break;
        case "result":                  refreshResults(); break;
        case "role":                    refreshRoles(); break;
        case "userRole":                refreshUserRoles(); break;
        case "moduleTopicType":         refreshModuleTopicTypes(); break;
        case "moduleTopicFormat":       refreshModuleTopicFormats(); break;
        case "paymentMethod":           refreshPaymentMethods(); break;
        case "paymentMode":             refreshPaymentModes(); break;
        case "educationMode":           refreshEducationModes(); break;
        case "moduleType":              refreshModuleTypes(); break;
        case "priceItemType":           refreshPriceItemTypes(); break;
        case "category":                refreshCategories(); break;
        case "documentType":            refreshDocumentTypes(); break;
        case "eventResult":             refreshEventResults(); break;
        case "eventOperation":          refreshEventOperations(); break;

        case "location":                refreshLocations(); break;
        case "member":                  refreshMembers(); break;
        case "documentCategory":        refreshDocumentCategories(); break;

        case "todoType":                refreshTodoTypes(); break;
        case "deadlineReferenceType":   refreshDeadlineReferenceTypes(); break;

        case "repeatType":              refreshRepeatTypes(); break;

        case "tag":                     refreshTags(); break;

    }
}

function refreshEnumeration() {
        refreshDevices();
}

//region Enumerations
function refreshDevices() {$.ajax({url: "../data/devices", method: 'GET', dataType: 'json', success: function (resp) {devices = resp;refreshEnumerationUsers("devices");}});}

function refreshStatuses() {$.ajax({url: "../data/statuses", method: 'GET', dataType: 'json', success: function (resp) {enum_Statuses = resp;refreshEnumerationUsers("statuses");}});}
function refreshResults() {$.ajax({url: "../data/results", method: 'GET', dataType: 'json', success: function (resp) {enum_Results = resp;refreshEnumerationUsers("results");}});}
function refreshRoles() {$.ajax({url: "../data/roles", method: 'GET', dataType: 'json', success: function (resp) {enum_Roles = resp;refreshEnumerationUsers("roles");}});}
function refreshUserRoles() {$.ajax({url: "../data/userRoles", method: 'GET', dataType: 'json', success: function (resp) {enum_UserRoles = resp;refreshEnumerationUsers("userRoles");}});}
function refreshModuleTopicTypes() {$.ajax({url: "../data/moduleTopicTypes", method: 'GET', dataType: 'json', success: function (resp) {enum_ModuleTopicTypes = resp;refreshEnumerationUsers("moduleTopicTypes");}});}
function refreshModuleTopicFormats() {$.ajax({url: "../data/moduleTopicFormats", method: 'GET', dataType: 'json', success: function (resp) {enum_ModuleTopicFormats = resp;refreshEnumerationUsers("moduleTopicFormats");}});}
function refreshPaymentMethods() {$.ajax({url: "../data/paymentMethods", method: 'GET', dataType: 'json', success: function (resp) {enum_PaymentMethods = resp;refreshEnumerationUsers("paymentMethods");},});}
function refreshPaymentModes() {$.ajax({url: "../data/paymentModes", method: 'GET', dataType: 'json', success: function (resp) {enum_PaymentModes = resp;refreshEnumerationUsers("paymentModes");}});}
function refreshEducationModes() {$.ajax({url: "../data/educationModes", method: 'GET', dataType: 'json', success: function (resp) {enum_EducationModes = resp;refreshEnumerationUsers("educationModes");}});}
function refreshModuleTypes() {$.ajax({url: "../data/moduleTypes", method: 'GET', dataType: 'json', success: function (resp) {enum_ModuleTypes = resp;refreshEnumerationUsers("moduleTypes");}});}
function refreshPriceItemTypes() {$.ajax({url: "../data/priceItemTypes", method: 'GET', dataType: 'json', success: function (resp) {enum_PriceItemTypes = resp;refreshEnumerationUsers("priceItemTypes");}});}
function refreshCategories() {$.ajax({url: "../data/categories", method: 'GET', dataType: 'json', success: function (resp) {enum_Categories = resp;refreshEnumerationUsers("categories");}});}
function refreshDocumentTypes() {$.ajax({url: "../data/documentTypes", method: 'GET', dataType: 'json', success: function (resp) {enum_DocumentTypes = resp;refreshEnumerationUsers("documentTypes");}});}
function refreshDocumentCategories() {$.ajax({url: "../data/documentCategories", method: 'GET', dataType: 'json', success: function (resp) {enum_DocumentCategories = resp;refreshEnumerationUsers("documentCategories");}});}


function refreshTodoTypes() {$.ajax({url: "../data/todotypes", method: 'GET', dataType: 'json', success: function (resp) {enum_TodoType = resp;refreshEnumerationUsers("todoType");}});}
function refreshRepeatTypes() {$.ajax({url: "../data/repeattypes", method: 'GET', dataType: 'json', success: function (resp) {enum_RepeatType = resp;refreshEnumerationUsers("repeatType");}});}
function refreshDeadlineReferenceTypes() {$.ajax({url: "../data/deadlineReferenceTypes", method: 'GET', dataType: 'json', success: function (resp) {enum_DeadlineReferenceType = resp;refreshEnumerationUsers("deadlineReferenceType");}});}

function refreshEventOperations() {$.ajax({url: "../data/eventOperations", method: 'GET', dataType: 'json', success: function (resp) {enum_EventOperations = resp;refreshEnumerationUsers("eventOperations");}});}
function refreshEventResults() {$.ajax({url: "../data/eventResults", method: 'GET', dataType: 'json', success: function (resp) {enum_EventResults = resp;refreshEnumerationUsers("eventResults");}});}

function refreshLocations() {$.ajax({url: "../data/locations", method: 'GET', dataType: 'json', success: function (resp) {dataSet_Locations = resp;refreshEnumerationUsers("locations");}});}
function refreshMembers() {$.ajax({url: "../data/members", method: 'GET', dataType: 'json', success: function (resp) {dataSet_Members = resp;refreshEnumerationUsers("members");}});}

function refreshTags() {$.ajax({url: "../data/tags", method: 'GET', dataType: 'json', success: function (resp) {dataSet_Tags = resp;refreshEnumerationUsers("tags");}});}
//endregion Enumerations

//region enumerations
function getDeviceNameById(id) {let ret = "Letöltés alatt";devices.forEach(function (item) {if(item.deviceId === id) ret = item.deviceName;});return ret;}
function getDeviceById(id) {let ret = "Letöltés alatt";devices.forEach(function (item) {if(item.deviceId === id) ret = item;});return ret;}


function getStatusNameById(id) {let ret = "Letöltés alatt";enum_Statuses.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}
function getResultById(id) {let ret = "Letöltés alatt";enum_Results.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getResultNameById(id) {let ret = "Letöltés alatt";enum_Results.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getRoleById(id) {let ret = "Letöltés alatt";enum_Roles.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getRoleNameById(id) {let ret = "Letöltés alatt";enum_Roles.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getUserRoleNameById(id) {let ret = "Letöltés alatt";enum_UserRoles.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getModuleTopicTypeById(id) {let ret = "Letöltés alatt";enum_ModuleTopicTypes.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getModuleTopicFormatById(id) {let ret = "Letöltés alatt";enum_ModuleTopicFormats.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getPaymentMethodById(id) {let ret = "Letöltés alatt";enum_PaymentMethods.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getPaymentModeById(id) {let ret = "Letöltés alatt";enum_PaymentModes.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getEducationModeById(id) {let ret = "Letöltés alatt";enum_EducationModes.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getEducationModeNameById(id) {let ret = "Letöltés alatt";enum_EducationModes.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getModuleTopicFormatNameById(id) {let ret = "Letöltés alatt";enum_ModuleTopicFormats.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}
function getModuleTopicTypeNameById(id) {let ret = "Letöltés alatt";enum_ModuleTopicTypes.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getModuleTypeById(id) {let ret = "Letöltés alatt";enum_ModuleTypes.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getModuleTypeNameById(id) {let ret = "Letöltés alatt";enum_ModuleTypes.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}
function getModuleTypeByShortCode(shortCode) {let ret = "Letöltés alatt";enum_ModuleTypes.forEach(function (item) {if(item.shortCode === shortCode) ret = item;});return ret;}
function getItemTypeNameByShortCode(shortCode) {let ret = "Letöltés alatt";enum_ModuleTypes.forEach(function (item) {if(item.shortCode === shortCode) ret = item.itemType;});return ret;}
function getItemGroupByShortCode(shortCode) {let ret = "Letöltés alatt";enum_ModuleTypes.forEach(function (item) {if(item.shortCode === shortCode) ret = item.itemGroup;});return ret;}
function getItemFamilyByShortCode(shortCode) {let ret = "Letöltés alatt";enum_ModuleTypes.forEach(function (item) {if(item.shortCode === shortCode) ret = item.itemFamily;});return ret;}

function getPriceItemTypeById(id) {let ret = "Letöltés alatt";enum_PriceItemTypes.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getPriceItemTypeNameById(id) {let ret = "Letöltés alatt";enum_PriceItemTypes.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getCategoryById(id) {let ret = "Letöltés alatt";enum_Categories.forEach(function (item) {if(item.id === id) ret = item;});return ret;}
function getCategoryNameById(id) {let ret = "Letöltés alatt";enum_Categories.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getEventOperationNameById(id) {let ret = "Letöltés alatt";enum_EventOperations.forEach(function (item) {if(item.id == id) ret = item.name;});return ret;}
function getEventResultNameById(id) {let ret = "Letöltés alatt";enum_EventResults.forEach(function (item) {if(item.id == id) ret = item.name;});return ret;}

function getDocumentTypeNameById(id) {let ret = "Letöltés alatt";enum_DocumentTypes.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getTagNameById(id) {let ret = "Letöltés alatt";dataSet_Tags.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}


function getDocumentCategoryNameById(id) {let ret = "Letöltés alatt";enum_DocumentCategories.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}

function getTodoTypeNameById(id) {let ret = "Letöltés alatt";enum_TodoType.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}
function getRepeatTypeNameById(id) {let ret = "Letöltés alatt";enum_RepeatType.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}
function getDeadlineReferenceTypeNameById(id) {let ret = "Letöltés alatt";enum_DeadlineReferenceType.forEach(function (item) {if(item.id === id) ret = item.name;});return ret;}


function getLocationNameById(locationId) {let ret = "Letöltés alatt";dataSet_Locations.forEach(function (item) {if (item.id === locationId) ret = item.nameShort;});return ret;}
function getMemberNameById(memberId) {
    let ret = "Letöltés alatt";
    if(memberId == "Nincs megadva") return "Nincs megadva";
    dataSet_Members.forEach(function (item) {if (item.memberId === memberId) ret = item.name;});
    return ret;}

function getResultNameById(id) {let ret = "Letöltés alatt";enum_Results.forEach(function (item) {if (item.id === id) ret = item.name;});return ret;}


//endregion enumerations

function refreshEnumerationUsers(caller) {
    if(enumerationRefreshCallbacks !== undefined && enumerationRefreshCallbacks.length ) {
        enumerationRefreshCallbacks.forEach(function(item) {item(caller);})
    }
}