let dataSet_Events = [],
    referenceIdForEvents = "";

jQuery(document).ready(function ($) {

    enumerationRefreshCallbacks.push(refreshEnumerationsInEventsTable);
    usersRefreshedCallbacks.push(refreshUsersInEventsTable);

    let paging = false,
        info = false;
    if(referenceIdForEvents==0) {paging = true;info = true;}

    $('#events').dataTable({
        language: datatable_hu,

        scrollY:        "300px", scrollX: false, scrollCollapse: true,
        paging:         paging, info: info,
        aLengthMenu: [[25, 50, 100, -1], [25, 50, 100, "Összes"]],
        fixedColumns: true,
        /* When deferred rendering is enabled, rather than having DataTables create all TR and TD nodes required for the table when the data is loaded,
         * DataTables will only create the nodes required for each individual row at the time of that row being drawn on the page (these nodes are then
         * retained in case they are needed again so they aren't created multiple times). */
        deferRender: true,
        dataType: 'json',
        ajax: function (data, callback, settings) {callback( { data: dataSet_Events } );},
        order: [[ 0, 'desc' ]],
        columns: [
            { data: "eventDate",  title: "Dátum", render: function (data, type, row, meta) {return moment(data).format('YYYY.MM.DD. HH:mm:ss');}},
            { data: "userId",     title: "Felhasználó", render: function (data, type, row, meta) {return getUserDisplayNameById(data);}},
            { data: "operation",  title: "Művelet", render: function (data, type, row, meta) {return getEventOperationNameById(data);}},
            { data: "result",     title: "Eredmény", render: function (data, type, row, meta) {return getEventResultNameById(data);}},
            { data: "message",    title: "Részletek"},
        ]
    });

    $('.card').on('slideToggled', function(params) { if(params.detail == "eventsCard") refreshEvents();});
    if(window.location.pathname == "/naplo") $(".card-option .minimize-card").click();

});

function refreshEvents() {

    if($('#eventsCardBlock').css("display") == "block") {
        let url = "";
        if(referenceIdForEvents != null && referenceIdForEvents != "") {url = "../data/eventsByReferenceId?referenceId="+referenceIdForEvents}
        else url = "../data/events";

        $.ajax({
            url: url,
            method: 'GET',
            dataType: 'json',
            success: function (resp) {
                if(resp) {dataSet_Events = resp;}
                else { dataSet_Events = [];}
                $('#events').DataTable().ajax.reload();
            }
        });

    }
}

function refreshUsersInEventsTable() {
    $('#events').DataTable().ajax.reload();
}

function refreshEnumerationsInEventsTable(callback) {
    $('#events').DataTable().ajax.reload();
}