jQuery(document).ready(function ($) {
    $('.main-search').on('openSearch', function() {createSearchField();});
    $('.main-search').on('closeSearch', function() {destroySearchField();});
});

function createSearchField() {
    let $select = $('#headerSearch');
    if ($select[0].selectize) {
        $select[0].selectize.off('change');
        $select[0].selectize.destroy();
        $select = null;
    }
    $select = $('#headerSearch').selectize({
        create: false, placeholder:"Kit/mit keres?",
        valueField: 'elementId', labelField: 'dataToDisplay', searchField: 'dataToDisplay',
        sortField: [{field: 'dataToDisplay', direction: 'asc'}, {field: '$score'}],
        options: [],
        optgroups: [
            {id: 'COURSE', name: 'Tanfolyam'},
            {id: 'PARTNER', name: 'Partner'},
            {id: 'DOCUMENT', name: 'Dokumentum'},
            {id: 'STUDENT', name: 'Tanuló'},
        ],
        optgroupField: 'category', optgroupLabelField: 'name', optgroupValueField: 'id',
        load: function(query, callback) {
            if (!query.length) return callback();
            $.ajax({
                url: '/data/search?where=partner,student,course&what='+query, type: 'GET', dataType: 'json',
                error: function(error) {console.log("Error: ");console.log(error);callback();},
                success: function(res) {console.log(res);callback(res);}
            });
        },
        //score: function(search) {let score = this.getScoreFunction(search);return function(item) {return score(item) * (1 + Math.min(1 / 100, 1));};},
        //render: {option: function(item, escape) {return '<div class="item" category="'+item.category+'" data-value="'+item.elementId+'">' + item.dataToDisplay.substring(0,10) + '</div>'}},
        onType: function(str) {if(str == "") {$select[0].selectize.clearOptions();}},
        onChange: function(value) {
            let selectize = $select[0].selectize;

            let link = "";
            switch (selectize.options[value].category) {
                case "DOCUMENT": link = "/dokumentumok?documentId=" + value; break;
                case "STUDENT": link = "/tanulok/szerkeszt?studentId="+ value; break;
                case "PROPOSAL": link = "/ajanlatok/szerkeszt?proposalId=+ value"; break;
                case "COURSE": link = "/tanfolyamok/szerkeszt?courseId="+ value; break;
                case "PARTNER": link = "/partnerek/szerkeszt?partnerId="+ value; break;
                default: link = "/index";break;
            }

            window.location.assign(link);
        }
    });
}


function destroySearchField() {
    let $select = $('#headerSearch');
    $select[0].selectize.destroy();
}