var express = require('express'),
    passport= require('passport'),
    eventLogger = require('../lib/eventLogger'),
    db          = require('../lib/SQLConnection'),

    router  = express.Router();

router.get('/', function (req, res) {res.render('login-cloud');});

router.post('/',
    /*passport.authenticate("local", {successRedirect: "/kezdolap", failureRedirect: "/login"}),
    function (req, res) {}*/

    function(req, res, next) {
        passport.authenticate('local', function(err, user, info) {

            if (err) { return next(err); }

            let redirectURL = "/kezdolap";
            if(req.body.redirectURL != undefined && req.body.redirectURL != "") {redirectURL = req.body.redirectURL;}

            let message = "Ismeretlen hiba";

            if (!user) {
                message = "Ismeretlen hiba";

                if(info && info.message === "Incorrect username") {
                    message = "Bejelentkezési kísérlet ismeretlen felhasználói névvel: " + req.body.username;
                    eventLogger.insertEvent(req.body.username, req.body.username, eventLogger.eventType.Login, eventLogger.operation.Login, eventLogger.eventResult.Failed, message);
                } else if(info && info.message === "Incorrect password") {
                    message = "Bejelentkezési kísérlet hibás jelszóval.";
                    eventLogger.insertEvent(req.body.username, req.body.username, eventLogger.eventType.Login, eventLogger.operation.Login, eventLogger.eventResult.Failed, "Bejelentkezési kísérlet hibás jelszóval.");
                }

                if(redirectURL)
                    res.status(400).json({status: "ERROR", message: message, redirectURL: "/login?redirectURL="+redirectURL});
                else
                    res.status(400).json({status: "ERROR", message: message, redirectURL: "/login"});

                return;
            }

            req.logIn(user, function(err) {
                if (err) { return next(err); }

                message = "Sikeres bejelentkezés";
                eventLogger.insertEvent(req.body.username, req.body.username, eventLogger.eventType.Login, eventLogger.operation.Login, eventLogger.eventResult.Success, message);

                db.updateUserLoginDate(req.body.username);

                res.status(200).json({status: "OK", message: message, redirectURL: redirectURL});

            });

        })(req, res, next);
    }
);

module.exports = router;